package com.zillion.database.agent;

import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.zillion.util.common.MyException;
import org.zillion.util.json.FastJsonReaderUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.zillion.database.async.AsyncJob;
import com.zillion.util.common.ZillionConstant;

public class ZillionAgentWebImpl implements IZillionAgent {
	public static long async_interval_milliseconds = 1000L;
	// http://47.93.132.139:8082/metadata-web/
	String base_url;

	public ZillionAgentWebImpl(String base_url) {
		this.base_url = base_url;

	}

	public void Start() throws Exception {

	}

	public void Stop() {

	}

	public JSONObject Query(JSONObject queryJSON) throws Exception {
		JSONObject result = Query_sync(queryJSON);
		return result;
	}

	public JSONObject Query(JSONObject queryJSON, boolean unuse, AsyncJob job) throws Exception {
		JSONObject result;
		result = Query_async(queryJSON, job);
		return result;
	}

	private JSONObject Query_sync(JSONObject queryJSON) throws Exception {
		String QueryType = (String) queryJSON.get("QueryType");
		String ExportZip = (String) queryJSON.get("ExportZip");
		if (QueryType.equals("export")) {
			queryJSON.put("QueryType", "select");
		} else if (QueryType.equals("combine_export")) {
			queryJSON.put("QueryType", "combine_select");
			QueryType = "export";
		}
		ZipArchiveOutputStream out = null;
		if (QueryType.equals("export")) {
			queryJSON.remove("ExportZip");
			out = new ZipArchiveOutputStream(new FileOutputStream(ExportZip));
		}

		String url_SubmitJob = this.base_url + "services/Service1_POST/" + "Query";
		String postResult = this.PostUrl(url_SubmitJob, "param", JSON.toJSONString(queryJSON, SerializerFeature.WriteMapNullValue));
		JSONObject json = (JSONObject) FastJsonReaderUtil.Instance().parse(postResult);
		if (QueryType.equals("export")) {
			JSONArray Content = (JSONArray) json.remove("Content");
			ZillionQueryTmp zqt = new ZillionQueryTmp();
			JSONArray contentInner = new JSONArray();
			for (int i = 0; i < Content.size(); i++) {
				contentInner.add(Content.get(i));
				if (contentInner.size() >= ZillionConstant.export_batch_size) {
					out.putArchiveEntry(new ZipArchiveEntry(zqt.df.format(zqt.zip_index++) + ".json"));
					byte[] bytes = JSON.toJSONString(contentInner, SerializerFeature.WriteMapNullValue).getBytes("UTF-8");
					out.write(bytes);
					out.closeArchiveEntry();
					contentInner.clear();
				}
			}
			if (contentInner.size() > 0) {
				out.putArchiveEntry(new ZipArchiveEntry(zqt.df.format(zqt.zip_index++) + ".json"));
				byte[] bytes = JSON.toJSONString(contentInner, SerializerFeature.WriteMapNullValue).getBytes("UTF-8");
				out.write(bytes);
				out.closeArchiveEntry();
				contentInner.clear();
			}
			out.finish();
			out.close();
		}
		return json;
	}

	private JSONObject Query_async(JSONObject queryJSON, AsyncJob job) throws Exception {
		String QueryType = (String) queryJSON.get("QueryType");
		String ExportZip = (String) queryJSON.get("ExportZip");
		ZipArchiveOutputStream out = null;
		if (QueryType.equals("export")) {
			queryJSON.put("QueryType", "select");
		} else if (QueryType.equals("combine_export")) {
			queryJSON.put("QueryType", "combine_select");
			QueryType = "export";
		}
		if (QueryType.equals("export") || QueryType.equals("select") || QueryType.equals("combine_select")) {
			if (!queryJSON.containsKey("PageSize")) {
				queryJSON.put("PageSize", 1000L);
			}
			if (!queryJSON.containsKey("Timeout")) {
				queryJSON.put("Timeout", 60000L);
			}
		}
		if (QueryType.equals("export")) {
			queryJSON.remove("ExportZip");
			out = new ZipArchiveOutputStream(new FileOutputStream(ExportZip));
		}
		job.time_start = new Date();
		String url_SubmitJob = this.base_url + "services/Service1_POST/" + "SubmitJob";
		String uuid = this.PostUrl(url_SubmitJob, "param", JSON.toJSONString(queryJSON, SerializerFeature.WriteMapNullValue));
		ZillionQueryTmp zqt = new ZillionQueryTmp();
		JSONArray contentInner = new JSONArray();
		while (true) {
			try {
				Thread.sleep(async_interval_milliseconds);
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (QueryType.equals("export") || QueryType.equals("select") || QueryType.equals("combine_select")) {
				String url_Scan_TryPopOnePage = this.base_url + "services/Service1_POST/" + "Scan_TryPopOnePage";
				String onePage = this.PostUrl(url_Scan_TryPopOnePage, "param", uuid);
				JSONArray json = (JSONArray) FastJsonReaderUtil.Instance().parse(onePage);
				if (json.size() > 0) {
					if (QueryType.equals("export")) {
						for (int i = 0; i < json.size(); i++) {
							JSONObject item = (JSONObject) json.get(i);
							contentInner.add(item);
						}
						if (contentInner.size() >= ZillionConstant.export_batch_size) {
							out.putArchiveEntry(new ZipArchiveEntry(zqt.df.format(zqt.zip_index++) + ".json"));
							byte[] bytes = JSON.toJSONString(contentInner, SerializerFeature.WriteMapNullValue).getBytes("UTF-8");
							out.write(bytes);
							out.closeArchiveEntry();
							contentInner.clear();
						}
					} else if (job.brs != null) {
						for (int i = 0; i < json.size(); i++) {
							JSONObject item = (JSONObject) json.get(i);
							job.brs.TryPush(item);
						}
					}
					continue;
				} else if (job.brs != null) {
					if (QueryType.equals("export")) {
						if (contentInner.size() > 0) {
							out.putArchiveEntry(new ZipArchiveEntry(zqt.df.format(zqt.zip_index++) + ".json"));
							byte[] bytes = JSON.toJSONString(contentInner, SerializerFeature.WriteMapNullValue).getBytes("UTF-8");
							out.write(bytes);
							out.closeArchiveEntry();
							contentInner.clear();
						}
					} else {
						job.brs.Finish(true, null);
					}
					String url_Finish = this.base_url + "services/Service1_POST/" + "Scan_Finish";
					this.PostUrl(url_Finish, "param", uuid);
				}
				if (QueryType.equals("export")) {
					if (contentInner.size() > 0) {
						out.putArchiveEntry(new ZipArchiveEntry(zqt.df.format(zqt.zip_index++) + ".json"));
						byte[] bytes = JSON.toJSONString(contentInner, SerializerFeature.WriteMapNullValue).getBytes("UTF-8");
						out.write(bytes);
						out.closeArchiveEntry();
						contentInner.clear();
					}
				}
			}
			String url_QueryJobStatus = this.base_url + "services/Service1_POST/" + "QueryJobStatus";
			String JobStatus = this.PostUrl(url_QueryJobStatus, "param", uuid);
			JSONObject json = (JSONObject) FastJsonReaderUtil.Instance().parse(JobStatus);
			boolean finish = (Boolean) json.get("finish");
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			job.finish = json.getBoolean("finish");
			job.count = json.getLongValue("count");
			job.success = json.getBooleanValue("success");
			job.exception = json.getString("exception");
			job.queryResult = json.getJSONObject("queryResult");
			String time_start = json.getString("time_start");
			String time_end = json.getString("time_end");
			if (time_start != null) {
				job.time_start = sdf.parse(time_start);
			}
			if (time_end != null) {
				job.time_end = sdf.parse(time_end);
			}
			if (finish) {
				if (QueryType.equals("export")) {
					out.finish();
					out.close();
				}
				boolean success = (Boolean) json.get("success");
				if (success) {
					String url_ClearJob = this.base_url + "services/Service1_POST/" + "ClearJob";
					this.PostUrl(url_ClearJob, "param", uuid);
					JSONObject queryResult = (JSONObject) json.get("queryResult");
					return queryResult;
				} else {
					String exception = (String) json.get("exception");
					throw new MyException(exception);
				}
			}
		}

	}

	ThreadLocal<HttpClient> local = new ThreadLocal<HttpClient>();

	public String PostUrl(String url, String paramName, String jsonString) throws Exception {
		HttpPost httpost = new HttpPost(url);
		httpost.addHeader("Connection", "Keep-Alive");
		List<NameValuePair> nvps = new ArrayList<NameValuePair>();
		if (paramName != null) {
			nvps.add(new BasicNameValuePair(paramName, jsonString));
		}
		httpost.setEntity(new UrlEncodedFormEntity(nvps, "UTF-8"));

		String result;
		if (local.get() == null) {
			local.set(HttpClients.createDefault());
		}
		HttpClient client = local.get();
		HttpResponse response = client.execute(httpost);
		if (response.getEntity() != null) {
			InputStream is = response.getEntity().getContent();
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			int i = -1;
			while ((i = is.read()) != -1) {
				baos.write(i);
			}

			result = baos.toString("UTF-8");
		} else {
			result = null;
		}
		return result;
	}
}
