package com.zillion.database.agent;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.async.AsyncJob;
import com.zillion.util.common.HashObject;
import com.zillion.util.table.SchemaRepositoryContainer;
import com.zillion.util.table.SchemaWrapper;
import com.zillion.util.table.ZillionTableIndex;
import com.zillion.util.table.ZillionTableSchema;

public class ZillionHashUtil {
	public static int thread_count_default = 8;

	public static HashObject AddOrRepairIndex(SchemaRepositoryContainer container, ZillionTableSchema schema,
			List<ZillionTableIndex> schema_indexList, boolean add_index, int thread_count, AsyncJob job) throws Exception {
		JSONObject Criteria = new JSONObject();
		List<JSONObject> CriteriaList = new ArrayList<JSONObject>();
		CriteriaList.add(Criteria);
		List<SchemaWrapper> schemaWrapperList = ZillionQueryUtil.getSchemaWrapperList(container, schema, null, true, CriteriaList, true, true, null);

		HashObject result;
		try {
			String work_type = add_index ? "AddIndex" : "RepairIndex";
			ZillionHashWorker worker = new ZillionHashWorker(container, schema, work_type, schema_indexList, schemaWrapperList, thread_count, job);
			result = worker.Do();
		} finally {
			for (SchemaWrapper schemaWrapper : schemaWrapperList) {
				schemaWrapper.unuse();
			}
		}

		return result;
	}

	public static HashObject RefreshHash(SchemaRepositoryContainer container, ZillionTableSchema schema, int thread_count, AsyncJob job)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		List<JSONObject> CriteriaList = new ArrayList<JSONObject>();
		CriteriaList.add(Criteria);
		List<SchemaWrapper> schemaWrapperList = ZillionQueryUtil.getSchemaWrapperList(container, schema, null, false, CriteriaList, true, true, null);

		HashObject result;
		try {
			ZillionHashWorker worker = new ZillionHashWorker(container, schema, schemaWrapperList, thread_count, job);
			result = worker.Do();
		} finally {
			for (SchemaWrapper schemaWrapper : schemaWrapperList) {
				schemaWrapper.unuse();
			}
		}

		return result;
	}
}
