package com.zillion.database.agent;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

public class ZillionOrderByUtil {
	public static boolean Match(String[] keys, JSONArray OrderBy) {
		if (OrderBy == null) {
			return true;
		}
		if (OrderBy.size() > keys.length) {
			return false;
		}

		Boolean first_Asc = null;
		for (int i = 0; i < OrderBy.size(); i++) {
			JSONObject item = (JSONObject) OrderBy.get(i);
			String Column = (String) item.get("Column");
			Boolean Asc = (Boolean) item.get("Asc");
			String key = keys[i];
			if (!key.equals(Column)) {
				return false;
			}
			if (first_Asc == null) {
				first_Asc = Asc;
			}
			if (Asc.booleanValue() != first_Asc.booleanValue()) {
				return false;
			}
		}
		return true;
	}

	public static boolean Match(String[] keys, JSONObject Criteria, JSONArray OrderBy, JSONArray OrderByReal) {
		if (OrderBy == null) {
			return true;
		}
		if (OrderBy.size() > keys.length) {
			return false;
		}

		int column_equal_count = 0;
		for (int index_key = 0; index_key < keys.length; index_key++) {
			String key = keys[index_key];
			if (Criteria.containsKey(key)) {
				Object value = Criteria.get(key);
				if (value != null && value instanceof JSONObject) {
					break;
				}
				column_equal_count++;
			} else {
				break;
			}
		}
		return Match(keys, column_equal_count, OrderBy, OrderByReal);
	}

	public static boolean Match(String[] keys, int column_equal_count, JSONArray OrderBy, JSONArray OrderByReal) {
		int valid_OrderBy_index = -1;
		Boolean Asc_first = null;
		for (int i = 0; i < OrderBy.size(); i++) {
			JSONObject item = (JSONObject) OrderBy.get(i);
			String Column = (String) item.get("Column");
			Boolean Asc = (Boolean) item.get("Asc");
			int in_key_index = -1;
			for (int index_key = 0; index_key < keys.length; index_key++) {
				String key = keys[index_key];
				if (key.equals(Column)) {
					in_key_index = index_key;
					break;
				}
			}
			if (in_key_index == -1) {
				return false;
			}
			if (in_key_index < column_equal_count) {
			} else {
				OrderByReal.add(item);
				if (Asc_first == null) {
					Asc_first = Asc;
				}
				valid_OrderBy_index++;
				if (column_equal_count + valid_OrderBy_index >= keys.length) {
					return false;
				}
				if (keys[column_equal_count + valid_OrderBy_index].equals(Column) && Asc_first.booleanValue() == Asc.booleanValue()) {
				} else {
					return false;
				}
			}
		}
		return true;
	}

	public static void main(String[] args) throws Exception {
		{
			String[] keys = { "c1", "c2", "c3", "c4" };
			JSONObject Criteria = new JSONObject();
			Criteria.put("c1", true);
			Criteria.put("c2", true);
			Criteria.put("c3", new JSONObject());
			JSONArray OrderBy = new JSONArray();
			OrderBy.add(generate("c1", true));
			OrderBy.add(generate("c2", true));
			OrderBy.add(generate("c3", false));
			OrderBy.add(generate("c4", false));
			JSONArray OrderByReal = new JSONArray();
			System.out.println(Match(keys, Criteria, OrderBy, OrderByReal));
			System.out.println(Match(keys, OrderBy));
		}
	}

	static JSONObject generate(String Column, Boolean Asc) {
		JSONObject result = new JSONObject();
		result.put("Column", Column);
		result.put("Asc", Asc);
		return result;
	}
}
