package com.zillion.database.async;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.IZillionAgent;

public class AsyncJobThread extends Thread {
	IZillionAgent agent;
	JSONObject queryJSON;
	AsyncJob job;

	public AsyncJobThread(IZillionAgent agent, JSONObject queryJSON, AsyncJob worker) {
		this.agent = agent;
		this.queryJSON = queryJSON;
		this.job = worker;
	}

	public void run() {
		try {
			JSONObject queryResult = agent.Query(this.queryJSON, true, this.job);
			this.job.Finish(queryResult, true, null);
		} catch (Exception e) {
			e.printStackTrace();
			this.job.Finish(null, false, e.getMessage());
			if (this.job.brs != null) {
				this.job.brs.Finish(false, e.getMessage());
			}
		}
	}
}
