package com.zillion.database.async;

import java.util.List;
import java.util.UUID;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.IZillionAgent;

public class AsyncUtil {
	public static long count_wait = 100L;

	public static String SubmitJob(IZillionAgent agent, JSONObject queryJSON) throws Exception {
		String QueryType = (String) queryJSON.get("QueryType");
		// if (!QueryType.equals("index_create") &&
		// !QueryType.equals("indexs_create") &&
		// !QueryType.equals("select_count")
		// && !QueryType.equals("combine_select_count") &&
		// !QueryType.equals("select") && !QueryType.equals("combine_select")
		// && !QueryType.equals("delete") && !QueryType.equals("combine_delete")
		// && !QueryType.equals("update")
		// && !QueryType.equals("combine_update") && !QueryType.equals("export")
		// && !QueryType.equals("combine_export")
		// && !QueryType.equals("import")) {
		// throw new MyException("QueryType can't be:" + QueryType);
		// }

		String uuid = UUID.randomUUID().toString();
		AsyncJob job = new AsyncJob(uuid, queryJSON);
		if (QueryType.equals("select") || QueryType.equals("combine_select")) {
			if (!queryJSON.containsKey("PageSize")) {
				queryJSON.put("PageSize", 1000L);
			}
			if (!queryJSON.containsKey("Timeout")) {
				queryJSON.put("Timeout", 60000L);
			}
			long PageSize = (Long) queryJSON.get("PageSize");
			long Timeout = (Long) queryJSON.get("Timeout");
			job.brs = new AsyncResultSet(uuid, PageSize, Timeout);
		}
		AsyncJobThread thread = new AsyncJobThread(agent, queryJSON, job);
		AsyncJobRepository.Add(job, thread);
		thread.start();

		return uuid;
	}

	public static JSONObject QueryJobStatus(String uuid) throws Exception {
		JSONObject result = AsyncJobRepository.QueryJobStatus(uuid);
		return result;
	}

	public static void ClearJob(String uuid) throws Exception {
		AsyncJobRepository.ClearJob(uuid);
	}

	public static JSONArray GetJobList() throws Exception {
		JSONArray result = AsyncJobRepository.GetJobList();
		return result;
	}

	public static JSONArray RemoveTimeoutJob() throws Exception {
		JSONArray result = AsyncJobRepository.RemoveTimeoutJob();
		return result;
	}

	public static JSONArray TryPopOnePage(String uuid) throws Exception {
		AsyncResultSet brs = AsyncJobRepository.GetBufferedResultSet(uuid);
		List<JSONObject> dataList = brs.TryPopOnePage();
		JSONArray result = new JSONArray();
		for (JSONObject data : dataList) {
			result.add(data);
		}
		return result;
	}

	public static void Finish(String uuid) throws Exception {
		AsyncJobRepository.GetBufferedResultSet(uuid).Finish(false, "Client end job");
	}
}
