package com.zillion.database.consistency;

import java.util.List;

import org.zillion.util.json.FastJsonCompareUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.util.common.ElasticSearchUtil;
import com.zillion.util.table.ZillionTableIndex;
import com.zillion.util.table.ZillionTableSchema;

public class StrongConsistencyUtil {

	public static boolean not_consistency(ZillionTableSchema schema, ZillionAgent agent, String Database, String table_name,
			List<JSONArray> ContentList) throws Exception {
		if (schema.elastic_search) {
			JSONArray Content = ElasticSearchUtil.selectAll(schema, agent.container.esClient, Database, table_name);
			ContentList.add(Content);
		}
		{
			JSONObject Criteria = new JSONObject();
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "select");
			wrapperObject.put("Database", Database);
			wrapperObject.put("Datatable", table_name);
			wrapperObject.put("Criteria", Criteria);
			JSONObject queryResult = agent.Query(wrapperObject);
			JSONArray Content = (JSONArray) queryResult.get("Content");
			ContentList.add(Content);
		}
		for (int ii = 0; ii < schema.Indexes.size(); ii++) {
			ZillionTableIndex index_schema = schema.Indexes.get(ii);
			JSONObject Criteria = new JSONObject();
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "select");
			wrapperObject.put("Database", Database);
			wrapperObject.put("Datatable", table_name);
			wrapperObject.put("Criteria", Criteria);
			wrapperObject.put("Hint", index_schema.index_name);
			JSONObject queryResult = agent.Query(wrapperObject);
			JSONArray Content = (JSONArray) queryResult.get("Content");
			ContentList.add(Content);
		}
		boolean not_consistency = false;
		for (int i = 1; i < ContentList.size(); i++) {
			JSONArray ContentLast = ContentList.get(i - 1);
			JSONArray Content = ContentList.get(i);
			boolean cmp = FastJsonCompareUtil.Instance().Compare(ContentLast, Content);
			if (!cmp) {
				not_consistency = true;
				break;
			}
		}
		return not_consistency;
	}
}
