package com.zillion.database.consistency;

import java.util.ArrayList;
import java.util.List;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

import com.zillion.util.zk.ZKNodeBatch;

public final class ThreadLocalRepository {
	public Queue<ZKNodeBatch> myQueue = new ConcurrentLinkedQueue<ZKNodeBatch>();
	private ThreadLocal<List<ZKNodeBatch>> conn = new ThreadLocal<List<ZKNodeBatch>>();

	public List<ZKNodeBatch> get() {
		List<ZKNodeBatch> queue = conn.get();
		if (queue == null) {
			queue = new ArrayList<ZKNodeBatch>();
			conn.set(queue);
		}
		return queue;
	}

	public void add(ZKNodeBatch item) {
		List<ZKNodeBatch> queue = conn.get();
		if (queue == null) {
			queue = new ArrayList<ZKNodeBatch>();
			conn.set(queue);
		}
		queue.add(item);
	}
}