package com.zillion.database.second;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.reflections.Reflections;

public class SecondComparableManager {
	private static SecondComparableManager instance = new SecondComparableManager();

	public static SecondComparableManager Instance() {
		return instance;
	}

	private SecondComparableManager() {
		this.Initialize();
	}

	public void Initialize() {
		this.LoadClassByReflections();
	}

	private void LoadClassByReflections() {
		try {
			Reflections reflections = new Reflections("com.zillion.database.second.impl");
			Set<Class<?>> annotated = reflections.getTypesAnnotatedWith(SecondAnnotation.class);
			Iterator<Class<?>> classIter = annotated.iterator();
			while (classIter.hasNext()) {
				Class<?> clazz = classIter.next();
				Class<?>[] interfaces = clazz.getInterfaces();
				boolean flag = false;
				for (int ii = 0; ii < interfaces.length; ii++) {
					Class<?> inter = interfaces[ii];
					if (inter.getName().equals("com.zillion.database.second.ISecondComparable")) {
						flag = true;
					}
				}
				if (flag) {
					Class<?>[] parameterTypes = new Class[0];
					Method method = clazz.getMethod("Name", parameterTypes);
					String Name = (String) method.invoke(null, new Object[0]);
					clazzMap.put(Name, clazz);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	Map<String, Class<?>> clazzMap = new HashMap<String, Class<?>>();

	public ISecondComparable Generate(String Operator, String Column, Object Value) throws Exception {
		Class<?> clazz = clazzMap.get(Operator);
		ISecondComparable object = (ISecondComparable) clazz.newInstance();
		object.setColumn(Column);
		object.setParam(Value);
		return object;
	}
}
