package com.zillion.database.util;

import java.util.List;

import org.apache.zookeeper.data.Stat;

import com.zillion.util.common.ByteToObject;
import com.zillion.util.common.ZillionConstant;
import com.zillion.util.zk.ZKWrapper;

public class ObserverCheck {
	public static void Wait(ZKWrapper zookeeper, String namespace, int repo_version) {
		if (ZillionConstant.ObserverCheck) {
			while (!Check(zookeeper, namespace, repo_version)) {
				try {
					Thread.sleep(1L);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		} else {
			if (ZillionConstant.ObserverWait > 0) {
				try {
					Thread.sleep(1000L * 5);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}

	public static boolean Check(ZKWrapper zookeeper, String namespace, int repo_version) {
		String zkpath_namespace = ZillionConstant.zk_root + ZillionConstant._ns + "/" + namespace;
		try {
			Stat stat = zookeeper.exists(zkpath_namespace + ZillionConstant.zk_observer, false);
			if (stat == null) {
				return true;
			}

			List<String> childList = zookeeper.getChildren(zkpath_namespace + ZillionConstant.zk_observer, false);
			for (String child : childList) {
				byte[] data = zookeeper.getData(zkpath_namespace + ZillionConstant.zk_observer + "/" + child, false, null);
				String data_string = ByteToObject.toString(data);
				String version_string = data_string;
				int index = data_string.indexOf("_");
				if (index != -1) {
					version_string = data_string.substring(0, index);
				}
				if (Integer.parseInt(version_string) < repo_version) {
					return false;
				}
			}
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
}
