package com.zillion.database.util;

import org.apache.hadoop.hbase.client.HTable;

public class TableWrapper_HBase implements ITableWrapper {
	public int connection_index;
	public HTable htable;
	int using_count = 0;

	public TableWrapper_HBase(int index, HTable table) {
		this.connection_index = index;
		this.htable = table;
	}

	public synchronized boolean can_use() {
		if (this.using_count < 1) {
			return true;
		} else {
			return false;
		}
	}

	public synchronized void use() {
		this.using_count++;
	}

	public synchronized void unuse() {
		this.using_count--;
	}

	public void close() {
		try {
			this.htable.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
