package com.zillion.util.common;

public class HashUtil {
	public static byte[] merge_hash_code(byte[] hash_code, byte[] row_key_bytes) {
		if (hash_code.length < row_key_bytes.length) {
			byte[] tmp = new byte[row_key_bytes.length];
			System.arraycopy(hash_code, 0, tmp, 0, hash_code.length);
			hash_code = tmp;
		}
		for (int i = 0; i < row_key_bytes.length; i++) {
			hash_code[i] = (byte) ((hash_code[i] & 0xFF) ^ (row_key_bytes[i] & 0xFF));
		}
		return hash_code;
	}

	public static byte[] merge_hash(byte[] hash1, byte[] hash2) {
		long insert_count1 = ByteToObject.toLong(hash1, 0);
		long delete_count1 = ByteToObject.toLong(hash1, ByteToObject.SIZEOF_LONG);
		long insert_count2 = ByteToObject.toLong(hash2, 0);
		long delete_count2 = ByteToObject.toLong(hash2, ByteToObject.SIZEOF_LONG);
		long insert_count = insert_count1 + insert_count2;
		long delete_count = delete_count1 + delete_count2;
		if (hash1.length < hash2.length) {
			byte[] tmp = new byte[hash2.length];
			System.arraycopy(hash1, 0, tmp, 0, hash1.length);
			hash1 = tmp;
		}
		ByteToObject.putLong(hash1, 0, insert_count);
		ByteToObject.putLong(hash1, ByteToObject.SIZEOF_LONG, delete_count);
		for (int i = ByteToObject.SIZEOF_LONG * 2; i < hash2.length; i++) {
			hash1[i] = (byte) ((hash1[i] & 0xFF) ^ (hash2[i] & 0xFF));
		}
		return hash1;
	}

	public static HashObject Parse(byte[] hash) {
		HashObject result = new HashObject();
		result.insert_count = ByteToObject.toLong(hash, 0);
		result.delete_count = ByteToObject.toLong(hash, ByteToObject.SIZEOF_LONG);
		result.hash_code = new byte[hash.length - ByteToObject.SIZEOF_LONG * 2];
		System.arraycopy(hash, ByteToObject.SIZEOF_LONG * 2, result.hash_code, 0, result.hash_code.length);
		return result;
	}
}
