package com.zillion.util.common;

import java.util.Comparator;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

public class JSONObjectComparator implements Comparator<JSONObject> {
	JSONArray OrderBy;

	public JSONObjectComparator(JSONArray OrderBy) {
		this.OrderBy = OrderBy;
	}

	@Override
	public int compare(JSONObject o1, JSONObject o2) {
		for (int i = 0; i < OrderBy.size(); i++) {
			JSONObject item = (JSONObject) OrderBy.get(i);
			String Column = (String) item.get("Column");
			Boolean Asc = (Boolean) item.get("Asc");
			Object v1 = o1.get(Column);
			Object v2 = o2.get(Column);
			if (v1 == null && v2 != null) {
				if (Asc) {
					return -1;
				} else {
					return 1;
				}
			} else if (v1 != null && v2 == null) {
				if (Asc) {
					return 1;
				} else {
					return -1;
				}
			} else if (v1 == null && v2 == null) {
				continue;
			} else {
				int cmp;
				if (v1 instanceof String && v2 instanceof String) {
					cmp = ((String) v1).compareTo((String) v2);
				} else if (v1 instanceof Integer && v2 instanceof Integer) {
					cmp = ((Integer) v1).compareTo((Integer) v2);
				} else if (v1 instanceof Long && v2 instanceof Long) {
					cmp = ((Long) v1).compareTo((Long) v2);
				} else if (v1 instanceof Float && v2 instanceof Float) {
					cmp = ((Float) v1).compareTo((Float) v2);
				} else if (v1 instanceof Double && v2 instanceof Double) {
					cmp = ((Double) v1).compareTo((Double) v2);
				} else if (v1 instanceof Boolean && v2 instanceof Boolean) {
					cmp = ((Boolean) v1).compareTo((Boolean) v2);
				} else {
					continue;
				}
				if (cmp == 0) {
					continue;
				} else {
					if (Asc) {
						return cmp;
					} else {
						return 0 - cmp;
					}
				}
			}
		}
		return 0;
	}
}
