package com.zillion.util.common;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

import com.zillion.util.table.SchemaRepository;
import com.zillion.util.table.ZillionTableSchema;

public class SplitUtil {
	public static Map<String, Integer> split_type2child_length = new HashMap<String, Integer>();

	static {
		split_type2child_length.put("split_hour", 10);
		split_type2child_length.put("split_day", 8);
		split_type2child_length.put("split_month", 6);
		split_type2child_length.put("split_year", 4);
	}

	public static void SplitParse(SimpleDateFormat sdf, SchemaRepository repository, String prefix, String suffix, SplitWrapper sw) throws Exception {
		if (suffix.length() == 10) {
			sdf.parse(suffix + "0000");
			sw.tableName = prefix;
			ZillionTableSchema schemaInner = repository.GetTable(sw.tableName);
			if (schemaInner != null) {
				if (schemaInner.table_type != null && schemaInner.table_type.equals("split_hour")) {
					sw.schema = schemaInner;
					sw.is_split_table = true;
					sw.query_month = suffix;
				}
			}
		} else if (suffix.length() == 8) {
			sdf.parse(suffix + "000000");
			sw.tableName = prefix;
			ZillionTableSchema schemaInner = repository.GetTable(sw.tableName);
			if (schemaInner != null) {
				if (schemaInner.table_type != null && schemaInner.table_type.equals("split_day")) {
					sw.schema = schemaInner;
					sw.is_split_table = true;
					sw.query_month = suffix;
				}
			}
		} else if (suffix.length() == 6) {
			sdf.parse(suffix + "01000000");
			sw.tableName = prefix;
			ZillionTableSchema schemaInner = repository.GetTable(sw.tableName);
			if (schemaInner != null) {
				if (schemaInner.table_type != null && schemaInner.table_type.equals("split_month")) {
					sw.schema = schemaInner;
					sw.is_split_table = true;
					sw.query_month = suffix;
				}
			}
		} else if (suffix.length() == 4) {
			sdf.parse(suffix + "0101000000");
			sw.tableName = prefix;
			ZillionTableSchema schemaInner = repository.GetTable(sw.tableName);
			if (schemaInner != null) {
				if (schemaInner.table_type != null && schemaInner.table_type.equals("split_year")) {
					sw.schema = schemaInner;
					sw.is_split_table = true;
					sw.query_month = suffix;
				}
			}
		}
	}
}
