package com.zillion.util.common;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import com.alibaba.fastjson.JSONObject;
import com.zillion.util.table.ZillionTableColumn;
import com.zillion.util.table.ZillionTableColumnEnum;
import com.zillion.util.table.ZillionTableIndex;
import com.zillion.util.table.ZillionTableSchema;

public class ZillionGenerateUtil {
	public static List<String> getIndexColumn(ZillionTableSchema schema) {
		List<String> result = new ArrayList<String>();
		for (String key : schema.OtherColumn) {
			boolean is_index = false;
			for (int ii = 0; ii < schema.Indexes.size(); ii++) {
				ZillionTableIndex index_schema = schema.Indexes.get(ii);
				for (String column : index_schema.Key) {
					if (column.equals(key)) {
						is_index = true;
						break;
					}
				}
				if (is_index) {
					break;
				}
			}
			if (is_index) {
				result.add(key);
			}
		}

		return result;
	}

	// update޸ĵSet
	public static JSONObject generateUpdateSet(ZillionTableSchema schema, List<String> columnList) {
		JSONObject result = new JSONObject();
		Random rand = new Random();
		for (String column : columnList) {
			ZillionTableColumn columnDef = schema.ColumnMap.get(column);
			if (columnDef.Type == ZillionTableColumnEnum.STRING || columnDef.Type == ZillionTableColumnEnum.COMPRESSSTRING) {
				byte[] bytes = new byte[1 + rand.nextInt(8)];
				for (int i = 0; i < bytes.length; i++) {
					bytes[i] = (byte) ('a' + rand.nextInt(26));
				}
				result.put(column, new String(bytes));
			} else if (columnDef.Type == ZillionTableColumnEnum.DOUBLE) {
				result.put(column, rand.nextDouble());
			} else if (columnDef.Type == ZillionTableColumnEnum.LONG) {
				result.put(column, rand.nextLong());
			} else if (columnDef.Type == ZillionTableColumnEnum.BOOLEAN) {
				result.put(column, rand.nextBoolean());
			}
		}

		return result;
	}
}
