package com.zillion.util.table;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

import org.elasticsearch.client.RestHighLevelClient;
import org.redisson.api.RedissonClient;
import org.redisson.config.Config;

import com.zillion.database.agent.ZillionAgent;
import com.zillion.database.consistency.ThreadLocalRepository;
import com.zillion.database.consistency.ZillionConsistencyThread;
import com.zillion.database.consistency.ZillionRedissonLockThread;
import com.zillion.database.util.IDatabase;
import com.zillion.util.zk.ZKNodeUseLock;
import com.zillion.util.zk.ZKWrapper;

import redis.clients.jedis.JedisPoolConfig;
import redis.clients.jedis.JedisShardInfo;
import redis.clients.jedis.ShardedJedisPool;

public class SchemaRepositoryContainer {
	public boolean initialized = false;

	public boolean without_lock = false;
	public ZKWrapper ZK;

	public List<String> namespaceList = new ArrayList<String>();
	public Map<String, SchemaRepository> repositoryMap;
	public SchemaRepositoryThread thread;
	public ZillionConsistencyThread consitencyThread;
	public List<ZillionRedissonLockThread> redissonLockThreadList = new ArrayList<ZillionRedissonLockThread>();
	public ThreadLocalRepository ThreadLocalRepository = new ThreadLocalRepository();

	public IDatabase DatabaseImpl;

	public RestHighLevelClient esClient;

	public JedisPoolConfig redisConfig;
	public List<JedisShardInfo> redisServerList;
	public ShardedJedisPool redisPool;
	public Config redissonConfig;
	public RedissonClient redisson;

	public ZillionAgent agent;

	public Queue<ZKNodeUseLock> delayDeleteZKLock = new ConcurrentLinkedQueue<ZKNodeUseLock>();
}
