package com.zillion.util.table;

import java.util.Date;

import org.zillion.util.log.LogUtil;

import com.zillion.database.util.DatabaseImpl_Mix;
import com.zillion.database.util.DatabaseImpl_MySQL;
import com.zillion.database.util.KerberosUtil;

public class SchemaRepositoryThread extends Thread {
	boolean needStop = false;
	SchemaRepositoryContainer container;
	boolean print = false;
	boolean observer = false;
	String node_path;
	SchemaRepositoryHelper helper;

	public SchemaRepositoryThread(SchemaRepositoryContainer container, boolean print, boolean observer, SchemaRepositoryHelper helper) {
		this.container = container;
		this.print = print;
		this.observer = observer;
		this.helper = helper;
	}

	public void RequestStop() {
		this.needStop = true;
	}

	@Override
	public void run() {
		long alive_cycle_count = 30000;
		long meta_cycle_count = 1000;
		Date last_alive = new Date();
		Date last_meta = new Date();
		while (!this.needStop) {
			try {
				Thread.sleep(100L);
			} catch (Exception e) {
				e.printStackTrace();
			}

			Date curr_time = new Date();
			if (curr_time.getTime() - last_alive.getTime() >= alive_cycle_count) {
				last_alive = curr_time;
				String status = "";
				try {
					if (container.DatabaseImpl instanceof DatabaseImpl_MySQL) {
						DatabaseImpl_MySQL DatabaseImpl_MySQL = (DatabaseImpl_MySQL) container.DatabaseImpl;
						status = DatabaseImpl_MySQL.getDataSourceStatus();
					}
					if (container.DatabaseImpl instanceof DatabaseImpl_Mix) {
						DatabaseImpl_Mix DatabaseImpl_Mix = (DatabaseImpl_Mix) container.DatabaseImpl;
						status = DatabaseImpl_Mix.mysql.getDataSourceStatus();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				LogUtil.warn(" ********************************** " + this.helper.full_name + " alive" + "\t" + status);
				KerberosUtil.reloginFromKeytab(container.DatabaseImpl, true, false);
			}

			if (curr_time.getTime() - last_meta.getTime() >= meta_cycle_count) {
				last_meta = curr_time;
				try {
					this.helper.ReadMeta(this.container, this.print, this.observer);
				} catch (Exception e) {
					e.printStackTrace();
				}

				if (this.needStop) {
					break;
				}
			}
		}
	}
}
