package com.zillion.util.table;

import java.util.List;

import com.zillion.database.util.ITableWrapper;

public class SchemaWrapper {
	public String child_name;
	public ITableWrapper dataWrapper;
	public List<ITableWrapper> indexWrapperList;

	public SchemaWrapper(String child_name, ITableWrapper tableWrapper, List<ITableWrapper> indexWrapperList) {
		this.child_name = child_name;
		this.dataWrapper = tableWrapper;
		this.indexWrapperList = indexWrapperList;
	}

	public synchronized void unuse() {
		if (dataWrapper != null) {
			dataWrapper.unuse();
		}
		for (int i = 0; i < indexWrapperList.size(); i++) {
			ITableWrapper wrapper_index = indexWrapperList.get(i);
			if (wrapper_index != null) {
				wrapper_index.unuse();
			}
		}
	}

	public synchronized boolean valid() {
		if (dataWrapper != null) {
			return true;
		}
		for (int i = 0; i < indexWrapperList.size(); i++) {
			ITableWrapper wrapper_index = indexWrapperList.get(i);
			if (wrapper_index != null) {
				return true;
			}
		}
		return false;
	}
}
