package org.zillion.util.common;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FileUtil {
	public static void delete_folder(String tmpPath) {
		File file = new File(tmpPath);
		if (file.exists()) {
			if (file.isDirectory()) {
				File[] items = file.listFiles();
				for (File item : items) {
					if (item.isDirectory()) {
						delete_folder(item.getPath());
					} else {
						if (item.getName().endsWith(".json")) {
							item.delete();
						}
					}
				}
			}
			file.delete();
		}
	}

	public static void delete_children_file(String tmpPath) {
		File file = new File(tmpPath);
		if (file.exists()) {
			if (file.isDirectory()) {
				File[] items = file.listFiles();
				for (File item : items) {
					if (!item.isDirectory() && item.getName().endsWith(".json")) {
						item.delete();
					}
				}
			}
		}
	}

	public static List<String> read_file(String filePath) throws Exception {
		List<String> result = new ArrayList<String>();

		BufferedReader reader = new BufferedReader(new FileReader(new File(filePath)));
		String temp;
		while ((temp = reader.readLine()) != null) {
			result.add(temp);
		}
		reader.close();

		return result;
	}

	public static Map<String, String> read_file_ini(String filePath) throws Exception {
		Map<String, String> result = new HashMap<String, String>();
		List<String> lineList = read_file(filePath);
		for (String line : lineList) {
			String line_trim = line.trim();
			if (line_trim.length() >= 3) {
				int index = line_trim.indexOf('=');
				String left = line_trim.substring(0, index);
				String right = line_trim.substring(index + 1);
				result.put(left, right);
			}
		}
		return result;
	}

	public static byte[] read_file_bytes(InputStream in) throws Exception {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		byte[] buffer = new byte[1024];
		int readed = 0;
		while ((readed = in.read(buffer)) != -1) {
			out.write(buffer, 0, readed);
		}
		byte[] result = out.toByteArray();
		out.close();
		in.close();
		return result;
	}

	public static void write_file(byte[] bytes, String filepath) throws Exception {
		OutputStream out = new FileOutputStream(filepath);
		out.write(bytes, 0, bytes.length);
		out.close();
	}
}
