package org.zillion.util.common;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.util.Base64;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class GZIPBase64Util {
	public static String gzipBase64(String str) throws Exception {
		if (str == null || str.length() == 0) {
			return "";
		}

		byte[] tArray;
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		GZIPOutputStream gzip = new GZIPOutputStream(out);
		try {
			gzip.write(str.getBytes("UTF-8"));
			gzip.flush();
		} finally {
			gzip.close();
		}

		tArray = out.toByteArray();
		out.close();

		return Base64.getEncoder().encodeToString(tArray);
	}

	public static String ungzipBase64(String str) throws Exception {
		if (str == null || str.length() == 0) {
			return "";
		}

		byte[] t = Base64.getDecoder().decode(str);

		ByteArrayOutputStream out = new ByteArrayOutputStream();
		ByteArrayInputStream in = new ByteArrayInputStream(t);
		GZIPInputStream gunzip = new GZIPInputStream(in);
		try {
			byte[] buffer = new byte[256];
			int n;
			while ((n = gunzip.read(buffer)) >= 0) {
				out.write(buffer, 0, n);
			}
		} finally {
			gunzip.close();
		}
		in.close();
		out.close();

		return out.toString("UTF-8");
	}

	public static void main(String[] args) throws Exception {
		String abc = "abcde";
		System.out.println(abc);
		String zipped = gzipBase64(abc);
		System.out.println(zipped);
		System.out.println(ungzipBase64(zipped));

		byte[] bytes = FileUtil.read_file_bytes(new FileInputStream("D:\\Test\\kerberos\\kerberos.keytab"));
		String base64String = Base64.getEncoder().encodeToString(bytes);
		FileUtil.write_file(base64String.getBytes("UTF-8"), "D:\\Test\\kerberos\\kerberos.txt");
	}
}
