package org.zillion.util.format;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;

public class FormatStaticUtil {
	private static Map<String, DecimalFormat> DecimalFormatMap = new HashMap<String, DecimalFormat>();

	static {
		DecimalFormatMap.put("Double", new DecimalFormat("#.####"));
		DecimalFormatMap.put("Integer", new DecimalFormat("#"));
		DecimalFormatMap.put("Long", new DecimalFormat("#"));
	}

	public static String toString(Double number) {
		return DecimalFormatMap.get("Double").format(number);
	}

	public static String toString(Integer number) {
		return DecimalFormatMap.get("Integer").format(number);
	}

	public static String toString(Long number) {
		return DecimalFormatMap.get("Long").format(number);
	}

}
