package org.zillion.util.json;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;

public class Convertor_JSON {
	public static Object FastJson2SagaJson(Object source) throws Exception {
		if (source == null) {
			return null;
		}

		if (source instanceof com.alibaba.fastjson.JSONArray) {
			com.alibaba.fastjson.JSONArray sourceEntity = (com.alibaba.fastjson.JSONArray) source;
			int sourceLength = sourceEntity.size();

			com.sagacloud.json.JSONArray targetObjectArray = new com.sagacloud.json.JSONArray();

			for (int i = 0; i < sourceLength; i++) {
				Object sourceObject = sourceEntity.get(i);

				Object targetObject = FastJson2SagaJson(sourceObject);
				targetObjectArray.add(targetObject);
			}

			return targetObjectArray;
		} else if (source instanceof com.alibaba.fastjson.JSONObject) {
			com.alibaba.fastjson.JSONObject sourceEntity = (com.alibaba.fastjson.JSONObject) source;

			com.sagacloud.json.JSONObject targetObject = new com.sagacloud.json.JSONObject();

			Iterator<String> keyIter = sourceEntity.keySet().iterator();
			while (keyIter.hasNext()) {
				String key = keyIter.next();
				Object value = sourceEntity.get(key);
				Object value_convert = FastJson2SagaJson(value);
				targetObject.put(key, value_convert);
			}

			return targetObject;
		} else if (source instanceof String) {
			return source;
		} else if (source instanceof Integer) {
			return ((Integer) source).longValue();
		} else if (source instanceof Long) {
			return ((Long) source).longValue();
		} else if (source instanceof BigInteger) {
			return ((BigInteger) source).longValue();
		} else if (source instanceof Float) {
			return ((Float) source).doubleValue();
		} else if (source instanceof Double) {
			return ((Double) source).doubleValue();
		} else if (source instanceof BigDecimal) {
			return ((BigDecimal) source).doubleValue();
		} else if (source instanceof Boolean) {
			return source;
		} else {
			return null;
		}
	}

	public static Object SagaJson2FastJson(Object source) throws Exception {
		if (source == null) {
			return null;
		}

		if (source instanceof com.sagacloud.json.JSONArray) {
			com.sagacloud.json.JSONArray sourceEntity = (com.sagacloud.json.JSONArray) source;
			int sourceLength = sourceEntity.size();

			com.alibaba.fastjson.JSONArray targetObjectArray = new com.alibaba.fastjson.JSONArray();

			for (int i = 0; i < sourceLength; i++) {
				Object sourceObject = sourceEntity.get(i);

				Object targetObject = SagaJson2FastJson(sourceObject);
				targetObjectArray.add(targetObject);
			}

			return targetObjectArray;
		} else if (source instanceof com.sagacloud.json.JSONObject) {
			com.sagacloud.json.JSONObject sourceEntity = (com.sagacloud.json.JSONObject) source;

			com.alibaba.fastjson.JSONObject targetObject = new com.alibaba.fastjson.JSONObject();

			Iterator<String> keyIter = sourceEntity.keySet().iterator();
			while (keyIter.hasNext()) {
				String key = keyIter.next();
				Object value = sourceEntity.get(key);
				Object value_convert = SagaJson2FastJson(value);
				targetObject.put(key, value_convert);
			}

			return targetObject;
		} else if (source instanceof String) {
			return source;
		} else if (source instanceof Long) {
			return source;
		} else if (source instanceof Double) {
			return source;
		} else if (source instanceof Boolean) {
			return source;
		} else {
			return null;
		}
	}
}
