package org.zillion.util.json;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONReader;
import com.alibaba.fastjson.JSONWriter;
import com.alibaba.fastjson.serializer.SerializerFeature;

public class FastJsonReaderUtil {
	private static FastJsonReaderUtil instance = new FastJsonReaderUtil();

	public static FastJsonReaderUtil Instance() {
		return instance;
	}

	private FastJsonReaderUtil() {

	}

	public Object parse(byte[] JSON_bytes) throws Exception {
		return this.parse(new String(JSON_bytes, "UTF-8"));
	}

	public Object parse(String JSONString) throws Exception {
		Object result = JSON.parse(JSONString);
		FastJsonUtil.Normalize(result);
		return result;
	}

	public JSONObject ReadJSONObject(File file) throws Exception {
		Object result = this.ReadInner(file);
		if (result == null) {
			return null;
		} else {
			FastJsonUtil.Normalize(result);
			return (JSONObject) result;
		}
	}

	public JSONArray ReadJSONArray(File file) throws Exception {
		Object result = this.ReadInner(file);
		if (result == null) {
			return null;
		} else {
			FastJsonUtil.Normalize(result);
			return (JSONArray) result;
		}
	}

	private Object ReadInner(File file) throws Exception {
		Object result = null;

		InputStream is = new FileInputStream(file);
		Reader reader = new InputStreamReader(is);
		JSONReader json_reader = new JSONReader(reader);
		result = json_reader.readObject();
		json_reader.close();
		reader.close();
		is.close();

		return result;
	}

	public void Write(JSONObject result, String filepath) throws Exception {
		this.WriteInner(result, filepath);
	}

	public void Write(JSONArray result, String filepath) throws Exception {
		this.WriteInner(result, filepath);
	}

	private void WriteInner(Object result, String filepath) throws Exception {
		OutputStream os = new FileOutputStream(filepath);
		Writer writer = new OutputStreamWriter(os);
		JSONWriter json_writer = new JSONWriter(writer);
		json_writer.config(SerializerFeature.WriteMapNullValue, false);
		json_writer.writeObject(result);
		json_writer.close();
		writer.close();
		os.close();
	}
}
