import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.format.FormatStaticUtil;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.FastJsonUtil;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_1point5 {
	static String[] building_array = new String[1];
	static String[] meter_array = new String[1];
	static Long[] funcid_array = new Long[1];
	static String[] receivetime_array = new String[100];

	static int thread_count = 1;
	static int cycle_number = 1;

	static String database_name = "database_1";

	static {
		try {
			{
				long start = 1101070037;
				for (int i = 0; i < building_array.length; i++) {
					building_array[i] = FormatStaticUtil.toString(start);
					start += 500000000;
				}
			}
			{
				long start = 1000;
				for (int i = 0; i < meter_array.length; i++) {
					meter_array[i] = FormatStaticUtil.toString(start);
					start += 1;
				}
			}
			{
				long start = 0;
				for (int i = 0; i < funcid_array.length; i++) {
					funcid_array[i] = start;
					start += 1;
				}
			}
			{
				SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
				Date start = sdf.parse("20000101000000");
				for (int i = 0; i < receivetime_array.length; i++) {
					receivetime_array[i] = sdf.format(start);
					start = new Date(start.getTime() + 1000L * 60 * 60 * 24);
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration);
		agent.Start();

		agent.NDL_AddDatabase(database_name);

		String table_name = "table_5";
		process(agent, table_name);

		agent.Stop();
		System.out.println();
	}

	static void process(ZillionAgent agent, String table_name) throws Exception {
		List<List<Long>> timeListList = new ArrayList<List<Long>>();
		for (int i = 0; i < cycle_number; i++) {
			// ɾ
			boolean exist = false;
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_list");
			wrapperObject.put("Database", database_name);
			JSONObject result = agent.Query(wrapperObject);
			JSONArray array = (JSONArray) result.get("Content");
			for (int ii = 0; ii < array.size(); ii++) {
				String tableNameInner = (String) array.get(ii);
				if (tableNameInner.equals(table_name)) {
					exist = true;
					break;
				}
			}
			if (exist) {
				agent.DDL_DropTable(database_name, table_name);
			}

			// ʼ
			JSONObject table_schema = FastJsonReaderUtil.Instance().ReadJSONObject(new File("etc/zz_originaldata/def-1.5.json"));
			JSONArray Indexes = (JSONArray) table_schema.get("Indexes");
			table_schema.remove("Indexes");
			agent.DDL_AddTable(database_name, table_name, table_schema, Indexes);

			Date date1 = new Date();
			insert(agent, table_name);

			Thread.sleep(1000L * 3);
			wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_count");
			wrapperObject.put("Database", database_name);
			wrapperObject.put("Datatable", table_name);
			result = agent.Query(wrapperObject);
			LogUtil.warn(FastJsonUtil.toFormatString(result));

			Date date2 = new Date();
			select(agent, table_name);
			Date date3 = new Date();

			List<Long> timeList = new ArrayList<Long>();
			timeList.add(date2.getTime() - date1.getTime());
			timeList.add(date3.getTime() - date2.getTime());
			timeListList.add(timeList);
			for (List<Long> timeListInner : timeListList) {
				StringBuffer sb = new StringBuffer();
				for (Long time : timeListInner) {
					sb.append("\t" + time);
				}
				LogUtil.info(sb.toString());
			}

			agent.container.repositoryMap.get(database_name).GetTable(table_name).unuseTable(agent.container.ZK);
		}
	}

	static void insert(ZillionAgent agent, String table_name) throws Exception {
		Random rand = new Random();
		LogUtil.info("insert begin:" + building_array.length);
		for (int index1 = 0; index1 < building_array.length; index1++) {
			String building = building_array[index1];
			for (int index2 = 0; index2 < meter_array.length; index2++) {
				String meter = meter_array[index2];
				for (int index3 = 0; index3 < funcid_array.length; index3++) {
					Long funcid = funcid_array[index3];
					JSONArray InsertObjects = new JSONArray();
					for (int index4 = 0; index4 < receivetime_array.length; index4++) {
						String receivetime = receivetime_array[index4];
						JSONObject InsertObject = new JSONObject();
						InsertObject.put("building", building);
						InsertObject.put("meter", meter);
						InsertObject.put("funcid", funcid);
						InsertObject.put("receivetime", receivetime);
						InsertObject.put("data", rand.nextDouble());
						InsertObjects.add(InsertObject);
					}
					JSONObject wrapperObject = new JSONObject();
					wrapperObject.put("QueryType", "batch_insert");
					wrapperObject.put("InsertObjects", InsertObjects);
					wrapperObject.put("Database", database_name);
					wrapperObject.put("Datatable", table_name);
					agent.Query(wrapperObject);
				}
			}
			LogUtil.info("insert finish:" + (index1 + 1) + "/" + building_array.length);
		}
	}

	static void select(ZillionAgent agent, String table_name) throws Exception {
		LogUtil.info("select begin:" + building_array.length);
		for (int index1 = 0; index1 < building_array.length; index1++) {
			String building = building_array[index1];
			int count = 0;
			for (int index2 = 0; index2 < meter_array.length; index2++) {
				String meter = meter_array[index2];
				for (int index3 = 0; index3 < funcid_array.length; index3++) {
					Long funcid = funcid_array[index3];
					JSONObject InsertObject = new JSONObject();
					InsertObject.put("building", building);
					InsertObject.put("meter", meter);
					InsertObject.put("funcid", funcid);
					JSONObject wrapperObject = new JSONObject();
					wrapperObject.put("QueryType", "select");
					wrapperObject.put("Criteria", InsertObject);
					wrapperObject.put("Database", database_name);
					wrapperObject.put("Datatable", table_name);
					JSONObject queryResult = agent.Query(wrapperObject);
					JSONArray resultContent = (JSONArray) queryResult.get("Content");
					count += resultContent.size();
				}
			}
			LogUtil.info("select finish:" + (index1 + 1) + "/" + building_array.length + "\t" + count);
		}
	}
}
