
import java.io.FileInputStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.util.table.SchemaParser;
import com.zillion.util.table.ZillionTableSchema;

public class AgentTest_TableDef_check {

	public static void main(String[] args) throws Exception {
//		Configuration configuration = new Configuration();
//		configuration.addResource(new FileInputStream(LogUtil.GetPath() + "/hbase-site.xml"));
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration);
		agent.Start();

		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "database_list");
		JSONObject databases = agent.Query(wrapperObject);
		JSONArray database_array = (JSONArray) databases.get("Content");
		for (int i = 0; i < database_array.size(); i++) {
			String database_name = (String) database_array.get(i);
			wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_list");
			wrapperObject.put("Database", database_name);
			JSONObject result = agent.Query(wrapperObject);
			JSONArray array = (JSONArray) result.get("Content");
			for (int ii = 0; ii < array.size(); ii++) {
				String tableName = (String) array.get(ii);
				wrapperObject = new JSONObject();
				wrapperObject.put("QueryType", "table_detail");
				wrapperObject.put("Database", database_name);
				wrapperObject.put("Datatable", tableName);
				JSONObject resultInner = agent.Query(wrapperObject);
				JSONObject TableDef = (JSONObject) resultInner.get("Content");
				JSONArray Indexes = TableDef.getJSONArray("Indexes");
				Map<String, Boolean> loseColumnMap = new HashMap<String, Boolean>();
				boolean def_good = Check(TableDef, Indexes, loseColumnMap);
				if (!def_good) {
					String[] loseColumns = loseColumnMap.keySet().toArray(new String[0]);
					Arrays.sort(loseColumns);
					StringBuffer sb = new StringBuffer();
					for (String loseColumn : loseColumns) {
						if (sb.length() > 0) {
							sb.append(",");
						}
						sb.append(loseColumn);
					}
					LogUtil.warn(database_name + "\t" + tableName + "\t" + sb.toString());
					// LogUtil.warn(FastJsonUtil.toFormatString(TableDef));
				}
			}
		}

		agent.Stop();
		System.out.println();
	}

	public static boolean Check(JSONObject content, JSONArray indexes, Map<String, Boolean> loseColumnMap) {
		boolean result = true;
		ZillionTableSchema schema = new ZillionTableSchema("a", "a");
		schema.JSON = content;
		SchemaParser.ParseTableSchema(schema, content);
		for (int i = 0; i < indexes.size(); i++) {
			JSONObject index = (JSONObject) indexes.get(i);
			JSONArray Columns = (JSONArray) index.get("Columns");
			for (int index_column = 0; index_column < Columns.size(); index_column++) {
				String Column = (String) Columns.get(index_column);
				if (!schema.ColumnMap.containsKey(Column)) {
					result = false;
					loseColumnMap.put(Column, true);
				}
			}
		}
		return result;
	}
}
