import org.apache.hadoop.hbase.util.Bytes;
import org.zillion.util.common.HexToByte;

public class BytesTest {

	public static void main(String[] args) {
		System.out.println("int:" + Bytes.toBytes((int) 1).length);
		System.out.println("long:" + Bytes.toBytes((long) 1).length);
		System.out.println("float:" + Bytes.toBytes((float) 1).length);
		System.out.println("double:" + Bytes.toBytes((double) 1).length);
		System.out.println("boolean:" + Bytes.toBytes((boolean) true).length);
		{
			byte[] bbb = new byte[1];
			bbb[0] = 0x00;
			System.out.println(HexToByte.byteToHex(bbb));
			bbb[0] = 0x01;
			System.out.println(HexToByte.byteToHex(bbb));
			bbb[0] = 0x02;
			System.out.println(HexToByte.byteToHex(bbb));
			bbb[0] = 0x03;
			System.out.println(HexToByte.byteToHex(bbb));

			bbb[0] = (byte) 0xff;
			System.out.println(HexToByte.byteToHex(bbb));
		}

		for (float i = (float) 1.0; i < 256.0; i = (float) (i * 2.0)) {
			byte[] curr = Bytes.toBytes(i);
			String currHex = HexToByte.byteToHex(curr);
			System.out.println("" + i + "\t" + currHex);
		}
		for (float i = (float) -1.0; i > -256.0; i = (float) (i * 2.0)) {
			byte[] curr = Bytes.toBytes(i);
			String currHex = HexToByte.byteToHex(curr);
			System.out.println("" + i + "\t" + currHex);
		}
		for (double i = 1.0; i < 256.0; i = i * 2.0) {
			byte[] curr = Bytes.toBytes(i);
			String currHex = HexToByte.byteToHex(curr);
			System.out.println("" + i + "\t" + currHex);
		}
		for (double i = -1.0; i > -256.0; i = i * 2.0) {
			byte[] curr = Bytes.toBytes(i);
			String currHex = HexToByte.byteToHex(curr);
			System.out.println("" + i + "\t" + currHex);
		}

		{
			int start = Integer.MIN_VALUE;
			String lastHex = HexToByte.byteToHex(Bytes.toBytes(start));
			for (int i = start + 1; i < start + 11; i++) {
				String currHex = HexToByte.byteToHex(Bytes.toBytes(i));
				System.out.println("" + (i - 1) + "\t" + lastHex + "\t" + i + "\t" + currHex);
				lastHex = currHex;
			}
		}
		{
			int start = 0;
			String lastHex = HexToByte.byteToHex(Bytes.toBytes(start));
			for (int i = start + 1; i < start + 11; i++) {
				String currHex = HexToByte.byteToHex(Bytes.toBytes(i));
				System.out.println("" + (i - 1) + "\t" + lastHex + "\t" + i + "\t" + currHex);
				lastHex = currHex;
			}
		}
		{
			long start = Long.MIN_VALUE;
			String lastHex = HexToByte.byteToHex(Bytes.toBytes(start));
			for (long i = start + 1; i < start + 11; i++) {
				String currHex = HexToByte.byteToHex(Bytes.toBytes(i));
				System.out.println("" + (i - 1) + "\t" + lastHex + "\t" + i + "\t" + currHex);
				lastHex = currHex;
			}
		}
		{
			long start = 0;
			String lastHex = HexToByte.byteToHex(Bytes.toBytes(start));
			for (long i = start + 1; i < start + 11; i++) {
				String currHex = HexToByte.byteToHex(Bytes.toBytes(i));
				System.out.println("" + (i - 1) + "\t" + lastHex + "\t" + i + "\t" + currHex);
				lastHex = currHex;
			}
		}

		for (int i = 0; i < 65536; i++) {
			char a = (char) i;
			byte[] bytes = Bytes.toBytes("" + a);
			boolean haszero = false;
			for (int ii = 0; ii < bytes.length; ii++) {
				if (bytes[ii] == 0) {
					haszero = true;
					break;
				}
			}
			if (haszero) {
				System.out.println("exist:" + a + "\t");
			}
		}

	}

}
