package PerformanceTest;

import java.io.File;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.zillion.util.json.JSONReaderUtil;
import org.zillion.util.log.LogUtil;

import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class Table1 implements ITestTable{
	static final long keyLong = 0;   // key 1, index 2
	static final double keyDouble = 0.0d;// key 2, index 1

	static final long size_l = 10000l;
	static final double size_d = 10000d;
	boolean putV = true;
	boolean hasIndex = false;
	static String database_name = "db_test";
	static String table_name = "table1";
	ZillionAgent agent = null;
	String path = "";
	JSONObject def = null;
	public long time = 0;

	public Table1(ZillionAgent agent, String jsonPath) throws Exception {
		this.agent = agent;
		path = jsonPath;
		def = (JSONObject) JSONReaderUtil.Instance().Read(new File(path));
		if (def != null && def.containsKey("Definition")) {
			JSONObject definition = (JSONObject) def.get("Definition");
			if (definition.containsKey("delete_UsePutV")) {
				putV = (Boolean) definition.get("delete_UsePutV");
			}
			if (definition.containsKey("Indexes")) {
				if(((JSONArray)definition.get("Indexes")).size() > 0)
					hasIndex = true;
			}
			database_name = def.get("Database").toString();
			table_name = def.get("Datatable").toString();
		}
	}

	public void put() throws Exception {
		LogUtil.info("insert begin:");
		for (long keyLong = Table1.keyLong; keyLong < size_l; ++keyLong) {
			JSONArray InsertObjects = new JSONArray();
			for (double keyDouble = Table1.keyDouble; keyDouble < size_d; ++keyDouble) {
				
				JSONObject InsertObject = new JSONObject();
				InsertObject.put("KeyLong", keyLong);
				InsertObject.put("KeyDouble", keyDouble);
				InsertObject.put("ValueLong", keyLong);
				InsertObject.put("ValueDouble", keyDouble);
				InsertObjects.add(InsertObject);
			}
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "batch_put");
			wrapperObject.put("InsertObjects", InsertObjects);
			wrapperObject.put("Database", database_name);
			wrapperObject.put("Datatable", table_name);
			execute(wrapperObject);
			//LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)*size_l/1000/(keyLong + 1) + "s.");
		}
		LogUtil.info("insert finished.");
		show("put data (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void delete() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "delete");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for(long keyLong = Table1.keyLong; keyLong < size_l; ++keyLong)
		{
			criteria.put("KeyLong", keyLong);
			execute(wrapper);
			//LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)* size_l/(keyLong + 1)/1000 + "s.");
		}
		show("delete data by key (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void deleteByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "delete");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for(double keyDouble = Table1.keyDouble; keyDouble < size_d; ++keyDouble)
		{
			criteria.put("KeyDouble", keyDouble);
			execute(wrapper);
			//LogUtil.info(table_name + " :" + (keyDouble + 1) + "/" + size_d);
			LogUtil.info(table_name + " :" + (keyDouble + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double) time)* size_l/1000/(keyDouble + 1) + "s.");
		}
		show("delete data by index (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void select() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "select");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for(long keyLong = Table1.keyLong; keyLong < size_l; ++keyLong)
		{
			criteria.put("KeyLong", keyLong);
			execute(wrapper);
			//LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)* size_l/1000/(keyLong + 1) + "s.");
		}
		show("select data by key (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void selectByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "select");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for(double keyDouble = Table1.keyDouble; keyDouble < size_d; ++keyDouble)
//		for(double keyDouble = 5300.0; keyDouble < size_d; ++keyDouble)
		{
			criteria.put("KeyDouble", keyDouble);
			execute(wrapper);
			//LogUtil.info(table_name + " :" + (keyDouble + 1) + "/" + size_d);
			LogUtil.info(table_name + " :" + (keyDouble + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)* size_l/1000/(keyDouble + 1) + "s.");
		}
		show("select data by index (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void update() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		wrapper.put("QueryType", "update");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		wrapper.put("Set", set);
		for(long keyLong = Table1.keyLong; keyLong < size_d; ++keyLong)
		{
			criteria.put("KeyLong", keyLong);
			set.put("ValueLong", size_l - keyLong);
			set.put("ValueDouble",(double) (size_l - keyLong));
			execute(wrapper);
			//LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (keyLong + 1) + "/" + size_d + ", ǰʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)* size_l/1000/(keyLong + 1) + "s.");
		}
		show("update data by key (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void updateByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		wrapper.put("QueryType", "update");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		wrapper.put("Set", set);
		for(double keyDouble = Table1.keyDouble; keyDouble < size_d; ++keyDouble)
		{
			criteria.put("KeyDouble", keyDouble);
			set.put("ValueLong", (long)(size_d - keyDouble));
			set.put("ValueDouble", size_d - keyDouble);
			execute(wrapper);
			LogUtil.info(table_name + " :" + (keyDouble + 1) + "/" + size_d + ", ǰܺʱ: "+ time/1000 +"s, Ԥܺʱ: " + (long)((double)time)* size_l/1000/(keyDouble + 1) + "s.");
		}
		show("update data by index (PutV = " + putV + ", index = "+hasIndex+")");
	}
	public void dropTable() throws Exception {
		// ɾ
		boolean exist = false;
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "table_list");
		wrapperObject.put("Database", database_name);
		JSONObject result = agent.Query(wrapperObject);
		JSONArray array = (JSONArray) result.get("Content");
		for (int ii = 0; ii < array.size(); ii++) {
			String tableNameInner = (String) array.get(ii);
			if (tableNameInner.equals(table_name)) {
				exist = true;
				break;
			}
		}
		if (exist) {
			agent.DDL_DropTable(database_name, table_name);
		}
	}

	public void preCheckAndCreate() throws Exception {
		agent.NDL_AddDatabase(database_name);
		// ɾ
		dropTable();
		// 
		agent.Query(def);
	}
	
	public void dropNamespace() throws Exception
	{
		agent.NDL_DropDatabase(database_name);
	}
	
	public synchronized void execute(JSONObject obj) throws Exception
	{
		long startTime = System.currentTimeMillis();
		agent.Query(obj);
		long endTime = System.currentTimeMillis();
		time += (endTime-startTime);
	}
	private void show(String str) {
		LogUtil.warn(str + "--ʱ: " + time );
		time = 0;
	}
	
	@Override
	public void rebuildTable() throws Exception {
		preCheckAndCreate();
		put();
	}

	@Override
	public void deserializeToObject() {
		// TODO Auto-generated method stub
		LogUtil.warn("Not Implemented!");
	}
}
