package PerformanceTest;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Random;

import org.zillion.util.json.JSONReaderUtil;
import org.zillion.util.log.LogUtil;

import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class Table2 implements ITestTable {
	static final int size_from = 4, size_range = 47; // real length = size_from
														// + random.nextInt(47);

	static final int size_l = 10000;

	static String database_name = "db_test";
	static String table_name = "table2";
	ZillionAgent agent = null;
	String path = "";
	JSONObject def = null;
	public long time = 0;
	boolean putV = true;
	boolean hasIndex = false;
	ArrayList<String> arr_key1 = new ArrayList<>();
	ArrayList<String> arr_key2 = new ArrayList<>();
	String dataPath = "tmp.dat";
	static Random ran = new Random();

	public Table2(ZillionAgent agent, String jsonPath) throws Exception {
		this.agent = agent;
		path = jsonPath;
		def = (JSONObject) JSONReaderUtil.Instance().Read(new File(path));
		if (def != null && def.containsKey("Definition")) {
			JSONObject definition = (JSONObject) def.get("Definition");
			if (definition.containsKey("delete_UsePutV")) {
				putV = (Boolean) definition.get("delete_UsePutV");
			}
			if (definition.containsKey("Indexes")) {
				if (((JSONArray) definition.get("Indexes")).size() > 0)
					hasIndex = true;
			}
			database_name = def.get("Database").toString();
			table_name = def.get("Datatable").toString();
		}
	}

	public void put() throws Exception {
		LogUtil.info("insert begin:");
		for (int i = 0; i < size_l; ++i) {
			arr_key1.add(getValidRandomString(false));
			arr_key2.add(getValidRandomString(true));
		}
		LogUtil.info("random strings prepared.");
		serializeToFile(arr_key1, arr_key2);
		LogUtil.info("Serialize to file finished");
		putData();
		LogUtil.info("insert finished.");
	}

	public void delete() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "delete");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for (int key1 = 0; key1 < size_l; ++key1) {
			criteria.put("KeyString1", arr_key1.get(key1));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key1 + 1) + "s.");
		}
		show("delete data by key (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void deleteByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "delete");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for (int key2 = 0; key2 < size_l; ++key2) {
			criteria.put("KeyString2", arr_key2.get(key2));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key2 + 1) + "s.");
		}
		show("delete data By index (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void select() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "select");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for (int key1 = 0; key1 < size_l; ++key1) {
			criteria.put("KeyString1", arr_key1.get(key1));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key1 + 1) + "s.");
		}
		show("select data By key (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void selectByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		wrapper.put("QueryType", "select");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		for (int key2 = 0; key2 < size_l; ++key2) {
			criteria.put("KeyString2", arr_key2.get(key2));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key2 + 1) + "s.");
		}
		show("select data By index (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void update() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		wrapper.put("QueryType", "update");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		wrapper.put("Set", set);
		for (int key1 = 0; key1 < size_l; ++key1) {
			criteria.put("KeyString1", arr_key1.get(key1));
			set.put("ValueString1", arr_key2.get(key1));
			set.put("ValueString2", arr_key1.get(key1));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key1 + 1) + "s.");
		}
		show("update data By key (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void updateByIndex() throws Exception {
		JSONObject wrapper = new JSONObject();
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		wrapper.put("QueryType", "update");
		wrapper.put("Database", database_name);
		wrapper.put("Datatable", table_name);
		wrapper.put("Criteria", criteria);
		wrapper.put("Set", set);
		for (int key2 = 0; key2 < size_l; ++key2) {
			criteria.put("KeyString2", arr_key2.get(key2));
			set.put("ValueString1", arr_key1.get(key2));
			set.put("ValueString2", arr_key2.get(key2));
			execute(wrapper);
			// LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key2 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) ((double) time) * size_l / 1000 / (key2 + 1) + "s.");
		}
		show("select data By index (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	public void dropTable() throws Exception {
		// ɾ
		boolean exist = false;
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "table_list");
		wrapperObject.put("Database", database_name);
		JSONObject result = agent.Query(wrapperObject);
		JSONArray array = (JSONArray) result.get("Content");
		for (int ii = 0; ii < array.size(); ii++) {
			String tableNameInner = (String) array.get(ii);
			if (tableNameInner.equals(table_name)) {
				exist = true;
				break;
			}
		}
		if (exist) {
			agent.DDL_DropTable(database_name, table_name);
		}
	}

	public void preCheckAndCreate() throws Exception {
		agent.NDL_AddDatabase(database_name);
		// ɾ
		dropTable();
		// 
		agent.Query(def);
	}

	public synchronized void execute(JSONObject obj) throws Exception {
		long startTime = System.currentTimeMillis();
		agent.Query(obj);
		long endTime = System.currentTimeMillis();
		time += (endTime - startTime);
	}

	private static boolean inPool(String s) {
		String s2 = s.intern();
		if (s2 == s)
			return false;
		return true;
	}
	
	private static String randomString(boolean isCapital) {
		StringBuilder sb = new StringBuilder();
		int length = 2 + ran.nextInt(47);
		for (int i = 0; i < length; ++i) {
			sb.append(isCapital ? (char) ('A' + ran.nextInt(26)) : (char) ('a' + ran.nextInt(26)));
		}
		return sb.toString();
	}

	private static String getValidRandomString(boolean isCapital) {
		String str = randomString(isCapital);
		while (inPool(str)) {
			str = randomString(isCapital);
		}
		return str;
	}

	public void rebuildTable() throws Exception {
		preCheckAndCreate();
		putData();
	}

	private void putData() throws Exception {
		for (int key1 = 0; key1 < size_l; ++key1) {
			JSONArray InsertObjects = new JSONArray();
			for (int key2 = 0; key2 < size_l; ++key2) {
				JSONObject InsertObject = new JSONObject();
				InsertObject.put("KeyString1", arr_key1.get(key1));
				InsertObject.put("KeyString2", arr_key2.get(key2));
				InsertObject.put("ValueString1", arr_key1.get(key1));
				InsertObject.put("ValueString2", arr_key2.get(key2));
				InsertObjects.add(InsertObject);
			}
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "batch_put");
			wrapperObject.put("InsertObjects", InsertObjects);
			wrapperObject.put("Database", database_name);
			wrapperObject.put("Datatable", table_name);
			execute(wrapperObject);
			// LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l);
			LogUtil.info(table_name + " :" + (key1 + 1) + "/" + size_l + ", ǰܺʱ: " + time / 1000 + "s, Ԥܺʱ: "
					+ (long) (((double) time) * size_l) / 1000 / (key1 + 1) + "s.");
		}
		show("put data (PutV = " + putV + ", index = " + hasIndex + ")");
	}

	private void show(String str) {
		LogUtil.info(str + "--ʱ: " + time);
		time = 0;
	}

	private void serializeToFile(ArrayList<String> key_1, ArrayList<String> key_2) {
		try {
			ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(dataPath));
			os.writeObject(key_1);
			os.writeObject(key_2);
			os.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void deserializeToObject() {
		try {
			ObjectInputStream is = new ObjectInputStream(new FileInputStream(dataPath));
			arr_key1 = (ArrayList<String>) is.readObject();
			arr_key2 = (ArrayList<String>) is.readObject();
			is.close();
			LogUtil.info("deserializeToObject finished.");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}
}
