package PerformanceTest;


public class TestBench {
	
	public static long sleep = 5*1000;
	private static String info = "PerformanceTest";
	public static void main(String[] args) throws Exception {
		String[] path = new String[]{
				"etc/base1/performanceTest/Table1.json",         // 0   done
				"etc/base1/performanceTest/Table1_v.json",       // 1	done
				"etc/base1/performanceTest/Table1_index.json",   // 2	done
				"etc/base1/performanceTest/Table1_index_v.json", // 3	done
				"etc/base1/performanceTest/Table2.json",         // 4	done
				"etc/base1/performanceTest/Table2_v.json",       // 5	
				"etc/base1/performanceTest/Table2_index.json",   // 6	
				"etc/base1/performanceTest/Table2_index_v.json"  // 7	
		};
		SingletonZillion.GetZillion(info);
		
		Table1 table0 = new Table1(SingletonZillion.GetZillion(), path[0] );
		Table1 table1 = new Table1(SingletonZillion.GetZillion(), path[1] );
		Table1 table2 = new Table1(SingletonZillion.GetZillion(), path[2] );
		Table1 table3 = new Table1(SingletonZillion.GetZillion(), path[3] );
		Table2 table4 = new Table2(SingletonZillion.GetZillion(), path[4] );
		Table2 table5 = new Table2(SingletonZillion.GetZillion(), path[5] );
		Table2 table6 = new Table2(SingletonZillion.GetZillion(), path[6] );
		Table2 table7 = new Table2(SingletonZillion.GetZillion(), path[7] );
		
		//table5.deserializeToObject(path); // ԻָTable2Ķ.
		
		testType_PSUD(table0);
		testType_PSUD(table1);
		testType_PSSiUUiDRDi(table2);
		testType_PSSiUUiDRDi(table3);
		testType_PSUD(table4);
		testType_PSUD(table5);
		testType_PSSiUUiDRDi(table6);
		testType_PSSiUUiDRDi(table7);
		
		SingletonZillion.GetZillion().Stop();
	}
	
	// P -> Put, S -> Select, U -> Update, D -> Delete, R -> Rebuild table, Si -> Select by Index .....
	// ϲ
	public static void testType_PSUD(ITestTable table) throws Exception
	{
		table.preCheckAndCreate();
		Thread.sleep(sleep);
		table.put();
		Thread.sleep(sleep);
		table.select();
		Thread.sleep(sleep);
		table.update();
		Thread.sleep(sleep);
		//table.deserializeToObject();
		table.delete();
		Thread.sleep(sleep);
		table.dropTable();
	}
	public static void testType_PSSiUUiDRDi(ITestTable table) throws Exception
	{
		table.preCheckAndCreate();
		
		Thread.sleep(sleep);
		table.put();
		Thread.sleep(sleep);
		table.select();
		Thread.sleep(sleep);
		table.selectByIndex();
		Thread.sleep(sleep);
		table.update();
		Thread.sleep(sleep);
		table.updateByIndex();
		Thread.sleep(sleep);
		table.delete();
		Thread.sleep(sleep);
		
		table.rebuildTable();
		Thread.sleep(sleep);
		table.deleteByIndex();
		
		table.dropTable();
	}
}
