
import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.data.Stat;
import org.zillion.util.log.LogUtil;

import com.zillion.util.zk.ZKLockRW;
import com.zillion.util.zk.ZKWrapper;

public class ZKLockRWTest {
	public static void main(String[] args) throws Exception {
		ZKWrapper zk = new ZKWrapper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000);

		String parent_path = "/zillion";
		Stat stat = zk.exists(parent_path, false);
		if (stat == null) {
			zk.create(parent_path, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
		}

		for (int i = 0; i < 3; i++) {
			MyThread thread = new MyThread(i);
			thread.start();
		}

		while (true) {
			Thread.sleep(1L);
		}
	}

	public static class MyThread extends Thread {
		int num;

		public MyThread(int num) {
			this.num = num;
		}

		public void run() {
			try {
				ZKWrapper zk = new ZKWrapper("node2:2181,node3:2181,node4:2181", 10000);
				String parent_path = "/zillion";

				LogUtil.info("node" + num + " ********************************** " + "read wait");
				String node_path = ZKLockRW.Create(zk, parent_path, "r", "true");
				ZKLockRW.WaitFor(zk, parent_path, node_path, 3600);
				LogUtil.info("node" + num + " ********************************** " + "read begin");
				Thread.sleep(1000L * 5);
				ZKLockRW.Finish(zk, node_path);
				LogUtil.info("node" + num + " ********************************** " + "read finish");

				LogUtil.info("node" + num + " ********************************** " + "write wait");
				node_path = ZKLockRW.Create(zk, parent_path, "w", "true");
				ZKLockRW.WaitFor(zk, parent_path, node_path, 3600);
				LogUtil.info("node" + num + " ********************************** " + "write begin");
				Thread.sleep(1000L * 5);
				ZKLockRW.Finish(zk, node_path);
				LogUtil.info("node" + num + " ********************************** " + "write finish");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
