package com.saga.functionalTest.delete;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.saga.functionalTest.utils.Utils;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

import PerformanceTest.SingletonZillion;

public class Delete {

	static ZillionAgent agent = null;
	static JSONObject body = null;
	private static boolean is_l3_equal_l1 = true;
	private static boolean is_s3_equal_s1 = true;
	public static void main(String[] args) throws Exception {
		prepare();
		Delete del = new Delete();
		del.testDelete_30();
		dispose();
	}
	public static void prepare() throws Exception
	{
		agent = SingletonZillion.GetZillion("Delete");
		body = new JSONObject();
		body.put("QueryType", "delete");
		body.put("Database", Utils.getDatabase());
		body.put("Datatable", Utils.getDatatable());
	}

	public void testDelete_1() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		delete(criteria);
	}
	public void testDelete_2() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", null);
		delete(criteria);
	}
	public void testDelete_3() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		delete(criteria);
	}
	public void testDelete_4() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "bc");
		range_String2.put("$lt", "bd");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		delete(criteria);
	}
	public void testDelete_5() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "bd");
		range_String2.put("$lte", "be");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		delete(criteria);
	}
	public void testDelete_6() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		delete(criteria);
	}
	public void testDelete_7() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		delete(criteria);
	}
	public void testDelete_8() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		delete(criteria);
	}
	public void testDelete_9() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", null);
		delete(criteria);
	}
	public void testDelete_10() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 102l);
		range_Long2.put("$lte", 102l);
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", range_Long2);
		delete(criteria);
	}
	public void testDelete_11() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 102l);
		range_Long2.put("$lte", 103l);
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", range_Long2);
		delete(criteria);
	}
	public void testDelete_12() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 104l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		criteria.put("Long2", range_Long2);
		delete(criteria);
	}
	public void testDelete_13() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long1", 1l);
		criteria.put("String1", "b");
		criteria.put("Long2", range_Long2);
		delete(criteria);
	}
	public void testDelete_14() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", "a");
		delete(criteria);
	}
	public void testDelete_15() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		delete(criteria);
	}
	public void testDelete_16() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "aa");
		range_String1.put("$lt", "ac");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		delete(criteria);
	}
	public void testDelete_17() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ad");
		range_String1.put("$lt", "af");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		delete(criteria);
	}
	public void testDelete_18() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ag");
		range_String1.put("$lte", "aj");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		delete(criteria);
	}
	public void testDelete_19() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "az");
		range_String1.put("$lte", "az");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		delete(criteria);
	}
	public void testDelete_20() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lte", "az");
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		delete(criteria);
	}
	public void testDelete_21() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", 1l);
		delete(criteria);
	}
	public void testDelete_22() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", null);
		delete(criteria);
	}
	public void testDelete_23() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 2l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", range_Long1);
		delete(criteria);
	}
	public void testDelete_24() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 3l);
		range_Long1.put("$lte", 4l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", range_Long1);
		delete(criteria);
	}
	public void testDelete_25() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "a");
		criteria.put("Long1", range_Long1);
		delete(criteria);
	}
	public void testDelete_26() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lt", 5l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "b");
		criteria.put("Long1", range_Long1);
		delete(criteria);
	}
	public void testDelete_27() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "aa");
		criteria.put("String2", "bb");
		criteria.put("Long3", 1l);
		delete(criteria);
	}
	public void testDelete_28() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "aa");
		criteria.put("String2", "bb");
		delete(criteria);
	}
	public void testDelete_29() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bz");
		criteria.put("String2", range_String2);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 2l);
		range_Long3.put("$lt", 5l);
		criteria.put("Long3", range_Long3);
		
		delete(criteria);
	}
	public void testDelete_30() throws Exception
	{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		delete(criteria);
	}
	public void testDelete_31() throws Exception
	{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", null);
		range_Long2.put("$lte", 105l);
		criteria.put("Long1", 1l);
		criteria.put("String1", "d");
		criteria.put("Long2", range_Long2);
		delete(criteria);
	}
	private synchronized static JSONObject delete(JSONObject arr) throws Exception
	{
		body.put("Criteria", arr);
		return Utils.execute(body);
	}

	public static void dispose()
	{
		agent.Stop();
	}
}
