package com.saga.functionalTest.insert;

import static org.junit.Assert.*;

import java.io.File;

import org.junit.After;
import org.junit.Before;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;
import org.zillion.util.json.JSONReaderUtil;

import com.saga.functionalTest.utils.Utils;
import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

import PerformanceTest.SingletonZillion;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Insert {
	
	String database_name = "db_test";
	String table_name = "table1";
	JSONObject def = null;
	ZillionAgent agent = null;
	final public static Long LONG1 = 1l;   // 1-10
	final public static Long LONG1_END = 5l;   // 1-10
	final public static Character STR1 = 'a'; // a-z && aa-az
	final public static Long LONG2 = 101l; // 101-110
	final public static Long LONG2_END = 105l; // 101-110
	final public static Character STR2 = 'b'; // a-z && ba-bz
	@Before
	public void setUpBeforeClass() throws Exception{
		this.agent = SingletonZillion.GetZillion("Insert");
		database_name = Utils.getDatabase();
		table_name = Utils.getDatatable();
		def = Utils.getDef();
		agent.NDL_AddDatabase(database_name);
		dropTable();
		Utils.execute(def);
		putData();
	}
	
	private void putData() throws Exception {
		JSONObject body = new JSONObject();
		body.put("QueryType", "insert");
		body.put("Database", database_name);
		body.put("Datatable", table_name);
		JSONObject insertObject = new JSONObject();
		body.put("InsertObject", insertObject);
		for(long l1 = LONG1; l1 <= LONG1_END + 1; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = LONG2; l2 <= LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == LONG1_END + 1)
							insertObject.put("Long1", null);
						else
							insertObject.put("Long1", l1);
						if(s1 == 52)
							insertObject.put("String1", null);
						else
							insertObject.put("String1", sb1.toString());
						if(l2 == LONG2_END + 1)
							insertObject.put("Long2", null);
						else
							insertObject.put("Long2", l2);
						if(s2 == 52)
							insertObject.put("String2", null);
						else
							insertObject.put("String2", sb2.toString());
						insertObject.put("Long3", insertObject.get("Long1"));
						insertObject.put("String3", insertObject.get("String1"));
						Utils.execute(body);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}
	
	private String getString(long n)
	{
		StringBuilder sb = new StringBuilder();
        if (n < 1)
            return sb.toString();

        while (n != 0)
        {
            n -= 1;
            sb.insert(0, (char)('a' + (n % 26)));
            n /= 26;
        }
        return sb.toString();
	}
	public void dropTable() throws Exception {
		// ɾ
		boolean exist = false;
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "table_list");
		wrapperObject.put("Database", database_name);
		JSONObject result = agent.Query(wrapperObject);
		JSONArray array = (JSONArray) result.get("Content");
		for (int ii = 0; ii < array.size(); ii++) {
			String tableNameInner = (String) array.get(ii);
			if (tableNameInner.equals(table_name)) {
				exist = true;
				break;
			}
		}
		if (exist) {
			agent.DDL_DropTable(database_name, table_name);
		}
	}
	@Test
	public void validation() throws Exception {
		JSONObject body = new JSONObject();
		body.put("QueryType", "select");
		body.put("Database", database_name);
		body.put("Datatable", table_name);
		JSONObject insertObject = new JSONObject();
		body.put("Criteria", insertObject);
		for(long l1 = LONG1; l1 <= LONG1_END + 1 ; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = LONG2; l2 <= LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == LONG1_END + 1)
							insertObject.put("Long1", null);
						else
							insertObject.put("Long1", l1);
						if(s1 == 52)
							insertObject.put("String1", null);
						else
							insertObject.put("String1", sb1.toString());
						if(l2 == LONG2_END + 1)
							insertObject.put("Long2", null);
						else
							insertObject.put("Long2", l2);
						if(s2 == 52)
							insertObject.put("String2", null);
						else
							insertObject.put("String2", sb2.toString());
//						insertObject.put("Long1", l1);
//						insertObject.put("String1", sb1.toString());
//						insertObject.put("Long2", l2);
//						insertObject.put("String2", sb2.toString());
						JSONObject result = Utils.execute(body);
						assertEquals( testEqual(result, (Long)insertObject.get("Long1"), (String)insertObject.get("String1")
								, (Long)insertObject.get("Long2"), (String)insertObject.get("String2")), true);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}

	private boolean testEqual(JSONObject result, Long l1, String s1, Long l2, String s2) {
		
		if(result == null || !result.containsKey("Result")||!result.containsKey("Count")
				||!result.containsKey("Content"))
			return false;
		if(!result.get("Result").equals("success") || !result.get("Count").equals(1l)
				|| !(((JSONArray)result.get("Content")).size() == 1))
			return false;
		JSONObject obj = (JSONObject) ((JSONArray)result.get("Content")).get(0);
		if(!obj.containsKey("Long1"))
		{
			if(obj.get("Long1") == null)
			{
				if(l1 != null)
					return false;
			}else
			{
				if(!obj.get("Long1").equals(l1))
					return false;
			}
		}
		if(!obj.containsKey("String1"))
		{
			if(obj.get("String1") == null)
			{
				if(s1 != null)
					return false;
			}else
			{
				if(!obj.get("String1").equals(s1))
					return false;
			}
		}
		if(!obj.containsKey("Long2"))
		{
			if(obj.get("Long2") == null)
			{
				if(l2 != null)
					return false;
			}else
			{
				if(!obj.get("Long2").equals(l2))
					return false;
			}
		}
		if(!obj.containsKey("String2"))
		{
			if(obj.get("String2") == null)
			{
				if(s2 != null)
					return false;
			}else
			{
				if(!obj.get("String2").equals(s2))
					return false;
			}
		}
		if(!obj.containsKey("Long3"))
		{
			if(obj.get("Long3") == null)
			{
				if(l1 != null)
					return false;
			}else
			{
				if(!obj.get("Long3").equals(l1))
					return false;
			}
		}
		if(!obj.containsKey("String3"))
		{
			if(obj.get("String3") == null)
			{
				if(s1 != null)
					return false;
			}else
			{
				if(!obj.get("String3").equals(s1))
					return false;
			}
		}
//		if(!obj.containsKey("Long1") || !obj.get("Long1").equals(l1))
//			return false;
//		if(!obj.containsKey("String1") || !obj.get("String1").equals(s1))
//			return false;
//		if(!obj.containsKey("Long2") || !obj.get("Long2").equals(l2))
//			return false;
//		if(!obj.containsKey("String2") || !obj.get("String2").equals(s2))
//			return false;
//		if(!obj.containsKey("Long3") || !obj.get("Long3").equals(l1))
//			return false;
//		if(!obj.containsKey("String3") || !obj.get("String3").equals(s1))
//			return false;
		return true;
	}
	@After
	public void tearDown() throws Exception {
		this.agent.Stop();
	}
}
