package com.saga.functionalTest.select;

import static org.junit.Assert.assertEquals;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.saga.functionalTest.insert.TableObj;
import com.saga.functionalTest.utils.Utils;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

import PerformanceTest.SingletonZillion;

//@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Select {
	static ZillionAgent agent = null;
	static JSONObject body = null;
	private static boolean is_l3_equal_l1 = true;
	private static boolean is_s3_equal_s1 = true;
	@BeforeClass
	public static void prepare() throws Exception
	{
		agent = SingletonZillion.GetZillion("Select");
		body = new JSONObject();
		body.put("QueryType", "select");
		body.put("Database", Utils.getDatabase());
		body.put("Datatable", Utils.getDatatable());
//		JSONObject insertObject = new JSONObject();
//		body.put("Criteria", insertObject);
	}
	// test ֶӦԱеı.
	@Test
	public void test_2() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject result = select(criteria);
		
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L,true, 0, 51, true, 101l, 105l, true, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 67600l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_3() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 0, 51, true, 101l, 105l, true, 0, 51, true, 1l, 1L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_4() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 1l);
		range.put("$lt", 3l);
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2l, 2L, false, 0, 51, true, 101l, 105l, true, 0, 51, true, 2l, 2L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_5() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 1l);
		range.put("$lte", 2l);
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2l, 2L, false, 0, 51, true, 101l, 105l, true, 0, 51, true, 2l, 2L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_6() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lt", 2l);
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 0, 51, true, 101l, 105l, true, 0, 51, true, 1l, 1L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_7() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lte", 2l);
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 2L, false, 0, 51, true, 101l, 105l, true, 0, 51, true, 1l, 2l, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_8() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "aa");
		criteria.put("Long1", 5l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5l, false, 26, 26, false, 101l, 105l, true, 0, 51, true, 5l, 5l, false, 26, 26, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_9() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "aa");
		range.put("$lt", "ac");
		criteria.put("Long1", 5l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 27, 27, false, 101l, 105l, true, 0, 51, true, 5l, 5L, false, 27, 27, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_10() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "aa");
		range.put("$lte", "ab");
		criteria.put("Long1", 5l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 27, 27, false, 101l, 105l, true, 0, 51, true, 5l, 5L, false, 27, 27, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_11() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lt", "ab");
		criteria.put("Long1", 5l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 26, 26, false, 101l, 105l, true, 0, 51, true, 5l, 5L, false, 26, 26, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_12() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lte", "ab");
		criteria.put("Long1", 5l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 26, 27,  false, 101l, 105l, true, 0, 51, true, 5l, 5L, false, 26, 27, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_13() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 101l, 101l, false, 0, 51, true, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_14() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 101l);
		range.put("$lt", 103l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 0, 51, true, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_15() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 101l);
		range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 0, 51, true, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_16() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 101l);
		range.put("$lt", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 101l, 101l, false, 0, 51, true, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_17() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 101l);
		range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 101l, 102l, false, 0, 51, true, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_18() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 26, 26, false, 5l, 5L, false, 0, 0, false); // 26 -> ba, 27 -> bb
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_19() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "ba");
		range.put("$lt", "bc");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 27, 27, false, 5l, 5L, false, 0, 0, false); // 26 -> ba, 27 -> bb
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_20() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "ba");
		range.put("$lte", "bb");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 27, 27, false, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_21() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "ba");
		range.put("$lt", "bb");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 26, 26, false, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_22() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "ba");
		range.put("$lte", "bb");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 0, false, 102l, 102l, false, 26, 27, false, 5l, 5L, false, 0, 0, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_23() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_24() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 101l);
		range.put("$lt", 103l);
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 102l, 102l, false, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_25() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 101l);
		range.put("$lte", 102l);
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 102l, 102l, false, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_26() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 101l);
		range.put("$lt", 102l);
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_27() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 101l);
		range.put("$lte", 102l);
		criteria.put("Long2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 102l, false, 0, 51, true, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_28() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("String2", "ba");
		criteria.put("Long2", 101l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 26, 26, false, 1l, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_29() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "ba");
		range.put("$lt", "bc");
		criteria.put("Long2", 101l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 27, 27, false, 1l, 5L, true, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_30() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "ba");
		range.put("$lte", "bb");
		criteria.put("Long2", 101l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 27, 27, false, 1l, 5L, true, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_31() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "ba");
		range.put("$lt", "bb");
		criteria.put("Long2", 101l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 26, 26, false, 1l, 5L, true, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_32() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "ba");
		range.put("$lte", "bb");
		criteria.put("Long2", 101l);
		criteria.put("String2", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 0, 51, true, 101l, 101l, false, 26, 27, false, 1l, 5L, true, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_33() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String2", "ba");
		criteria.put("Long2", 101l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 0, 51, true, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_34() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 1l);
		range.put("$lt", 3l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2l, 2L, false, 0, 51, true, 101l, 101l, false, 26, 26, false, 2l, 2L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_35() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", 1l);
		range.put("$lte", 2l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2l, 2L, false, 0, 51, true, 101l, 101l, false, 26, 26, false, 2l, 2L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_36() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lt", 2l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 0, 51, true, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_37() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lte", 2l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 2L, false, 0, 51, true, 101l, 101l, false, 26, 26, false, 1l, 2L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_38() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 26, 26, false, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 26, 26, false); // 26 -> ba, 27 -> bb
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_39() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "aa");
		range.put("$lt", "ac");
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 27, 27, false, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 27, 27, false); // 26 -> ba, 27 -> bb
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_40() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gt", "aa");
		range.put("$lte", "ab");
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 27, 27, false, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 27, 27, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 1l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_41() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lt", "ab");
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 26, 26, false, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 26, 26, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 1l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_42() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lte", "ab");
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 26, 27, false, 101l, 101l, false, 26, 26, false, 1l, 1L, false, 26, 27, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 2l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_43() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("String2", "ba");
		criteria.put("String1", "az");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 5L, true, 51, 51, false, 101l, 105l, true, 26, 26, false, 1l, 5L, true, 51, 51, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 25l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_44() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 51, true, 101l, 105l, true, 26, 26, false, 5l, 5L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 260l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_45() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("Long2", 101l);
		criteria.put("Long3", 5l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 51, true, 101l, 101l, false, 0, 51, true, 5l, 5L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 2704l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_46() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("Long2", 101l);
		criteria.put("Long3", 6l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 51, true, 101l, 101l, false, 0, 51, true, 6l, 6L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 0l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_47() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 5l);
		criteria.put("Long2", 0l);
		criteria.put("Long3", 5l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5l, 5L, false, 0, 51, true, 1l, 0l, false, 0, 51, true, 5l, 5L, false, 0, 51, true); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 0l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_48() throws Exception {
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "aa");
		criteria.put("String2", "bz");
		criteria.put("Long3", 1l);
		criteria.put("String3", "aa");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 1L, false, 26, 26, false, 101l, 105l, true, 51, 51, false, 1l, 1L, false, 26, 26, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 5l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_49() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_long1 = new JSONObject();
		JSONObject range_string1 = new JSONObject();
		JSONObject range_long2 = new JSONObject();
		JSONObject range_string2 = new JSONObject();
		JSONObject range_long3 = new JSONObject();
		JSONObject range_string3 = new JSONObject();
		range_long1.put("$gt", 1l);
		range_long1.put("$lt", 5l);
		range_string1.put("$gt", "aa");
		range_string1.put("$lt", "ae");
		range_long2.put("$gt", 101l);
		range_long2.put("$lt", 103l);
		range_string2.put("$gt", "ba");
		range_string2.put("$lt", "bc");
		range_long3.put("$gt", 2l);
		range_long3.put("$lt", 4l);
		range_string3.put("$gt", "ab");
		range_string3.put("$lt", "ad");
		criteria.put("Long1", range_long1);
		criteria.put("String1", range_string1);
		criteria.put("Long2", range_long2);
		criteria.put("String2", range_string2);
		criteria.put("Long3", range_long3);
		criteria.put("String3", range_string3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2l, 4L, false, 26, 29, false, 102l, 102l, false, 27, 27, false, 3l, 3L, false, 28, 28, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 1l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_50() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_long1 = new JSONObject();
		JSONObject range_string1 = new JSONObject();
		JSONObject range_long2 = new JSONObject();
		JSONObject range_string2 = new JSONObject();
		JSONObject range_long3 = new JSONObject();
		JSONObject range_string3 = new JSONObject();
		range_long1.put("$gte", 1l);
		range_long1.put("$lte", 3l);
		range_string1.put("$gte", "aa");
		range_string1.put("$lte", "ac");
		range_long2.put("$gte", 101l);
		range_long2.put("$lte", 103l);
		range_string2.put("$gte", "ba");
		range_string2.put("$lte", "bc");
		range_long3.put("$gte",is_l3_equal_l1? 2l : 102l);
		range_long3.put("$lte",is_l3_equal_l1? 4l : 104l);
		range_string3.put("$gte", is_s3_equal_s1? "ab" : "bb");
		range_string3.put("$lte", is_s3_equal_s1? "ad" : "bd");
		criteria.put("Long1", range_long1);
		criteria.put("String1", range_string1);
		criteria.put("Long2", range_long2);
		criteria.put("String2", range_string2);
		criteria.put("Long3", range_long3);
		criteria.put("String3", range_string3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
//		assertEquals(isEqual(result, 36l, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_51() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_long1 = new JSONObject();
		range_long1.put("$gte", 1l);
		range_long1.put("$lte", 1l);
		criteria.put("Long1", range_long1);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_52() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lte", "aa");
		criteria.put("Long1", 5l);
		criteria.put("String1", range_String1);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_53() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 101l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", range_Long2);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_54() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "ba");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 102l);
		criteria.put("String2", range_String2);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_55() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 101l);
		criteria.put("Long2", range_Long2);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_56() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "ba");
		criteria.put("Long2", 101l);
		criteria.put("String2", range_String2);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_57() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 1l);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", range_Long1);
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Test
	public void test_58() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lte", "aa");
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		criteria.put("Long1", 1l);
		criteria.put("String1", range_String1);
		
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1l, 3L, false, 26, 28, false, 101l, 103l, false, 26, 28, false, 2l, 4L, false, 27, 29, false); // 26 -> aa, 27 -> ab
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	private synchronized static JSONObject select(JSONObject arr) throws Exception
	{
		body.put("Criteria", arr);
		return Utils.execute(body);
	}
//	public static boolean isEqual(JSONObject result, long count, TableObj tabObj, boolean is_l3_equal_l1, boolean is_s3_equal_s1)
//	{
//		if(result == null || !result.containsKey("Result")||!result.containsKey("Count")
//				||!result.containsKey("Content"))
//			return false;
//		if(!result.get("Result").equals("success") || !result.get("Count").equals(count)
//				|| !(((JSONArray)result.get("Content")).size() == count))
//			return false;
//		HashSet<String> set = new HashSet<>();
//		a:for(long long1 = tabObj.getL1(); long1 <= tabObj.getL1_end(); ++long1)
//		{
//			b:for(int str1 = tabObj.getS1(); str1 <= tabObj.getS1_end(); ++str1)
//			{
//				c:for(long long2 = tabObj.getL2(); long2 <= tabObj.getL2_end(); ++long2)
//				{
//					d:for(int str2 = tabObj.getS2(); str2 <= tabObj.getS2_end(); ++str2)
//					{
//						StringBuilder sb = new StringBuilder();
//						if(is_l3_equal_l1)
//						{
//							if(long1 > tabObj.getL3_end() || long1 < tabObj.getL3())
//								continue a;
//						}else
//						{
//							if(long2 > tabObj.getL3_end() || long2 < tabObj.getL3())
//								continue c;
//						}
//						if(is_s3_equal_s1)
//						{
//							if(str1 > tabObj.getS3_end() || str1 < tabObj.getS3())
//								continue b;
//						}else
//						{
//							if(str2 > tabObj.getS3_end() || str2 < tabObj.getS3())
//								continue d;
//						}
//						sb.append(long1);
//						if(str1 > 25)
//							sb.append((char)'a');
//						sb.append((char)('a' + str1%26));
//						sb.append(long2);
//						if(str2 > 25)
//							sb.append((char)'b');
//						sb.append((char)('a' + str2%26));
//						if(is_l3_equal_l1)
//							sb.append(long1);
//						else
//							sb.append(long2);
//						if(is_s3_equal_s1)
//						{
//							if(str1 > 25)
//								sb.append((char)'a');
//							sb.append((char)('a' + str1%26));
//						}else
//						{
//							if(str2 > 25)
//								sb.append((char)'b');
//							sb.append((char)('a' + str2%26));
//						}
//						set.add(sb.toString());
//					}
//				}
//			}
//		}
//		JSONArray arr = (JSONArray)result.get("Content");
//		for(int i = 0; i < arr.size(); ++i)
//		{
//			JSONObject obj = (JSONObject)arr.get(i);
//			if(!obj.containsKey("Long1") || !obj.containsKey("String1") || !obj.containsKey("Long2")||
//					!obj.containsKey("String2")||!obj.containsKey("Long3")||!obj.containsKey("String3"))
//				return false;
//			
//			StringBuilder sb = new StringBuilder();
//			sb.append(obj.get("Long1")).append(obj.get("String1")).append(obj.get("Long2"))
//				.append(obj.get("String2")).append(obj.get("Long3")).append(obj.get("String3"));
//			
//			if(set.contains(sb.toString()))
//				set.remove(sb.toString());
//			else
//				return false;
//		}
//		if(set.isEmpty() || (arr.size() == 0 && count == 0))
//			return true;
//		return false;
//	}
	@AfterClass
	public static void dispose()
	{
		agent.Stop();
	}
}
