package com.saga.functionalTest.select;

import static org.junit.Assert.assertEquals;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

import com.saga.functionalTest.insert.TableObj;
import com.saga.functionalTest.utils.Utils;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

import PerformanceTest.SingletonZillion;

public class SelectWithNull {
	static ZillionAgent agent = null;
	static JSONObject body = null;
	private static boolean is_l3_equal_l1 = true;
	private static boolean is_s3_equal_s1 = true;
	@BeforeClass
	public static void prepare() throws Exception
	{
		agent = SingletonZillion.GetZillion("Select");
		body = new JSONObject();
		body.put("QueryType", "select");
		body.put("Database", Utils.getDatabase());
		body.put("Datatable", Utils.getDatatable());
//		JSONObject insertObject = new JSONObject();
//		body.put("Criteria", insertObject);
	}
	@Test
	public void test_3() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", "a");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 0, 0, false, 101L, 105L, true, 0, 51, true, 6L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_4() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1L);
		criteria.put("String1", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 1, 0, true, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_5() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 1, 0, true, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_6() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lte", 2l);
		criteria.put("Long1", range);
		criteria.put("String1", "a");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 2L, false, 0, 0, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_7() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", 1l);
		range.put("$lte", 2l);
		criteria.put("Long1", range);
		criteria.put("String1", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 2L, false, 1, 0, true, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_8() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lte", "az");
		criteria.put("Long1", 1l);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_9() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range = new JSONObject();
		range.put("$gte", "aa");
		range.put("$lte", "az");
		criteria.put("Long1", null);
		criteria.put("String1", range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_10() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 1l);
		L1Range.put("$lte", 2l);
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		criteria.put("Long1", L1Range);
		criteria.put("String1", S1Range);
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1L, 2L, false, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_11() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 1l);
		L1Range.put("$lte", 2l);
		criteria.put("Long1", L1Range);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1L, 2L, false, 0, 51, true, 101L, 105L, true, 26, 26, false, 1L, 5L, true, 0, 51, true);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_12() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 1l);
		L1Range.put("$lte", 2l);
		criteria.put("Long1", L1Range);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1L, 2L, false, 0, 51, true, 101L, 105L, true, 27, 26, true, 1L, 5L, true, 0, 51, true);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_13() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "c");
		S2Range.put("$lte", "z");
		criteria.put("Long1", 1l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 0, 51, true, 101L, 105L, true, 2, 25, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_14() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "c");
		S2Range.put("$lte", "z");
		criteria.put("Long1", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 0, 51, true, 101L, 105L, true, 2, 25, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_15() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 1l);
		L1Range.put("$lte", 2l);
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "c");
		S2Range.put("$lte", "z");
		criteria.put("Long1", L1Range);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1L, 2L, false, 0, 51, true, 101L, 105L, true, 2, 25, false, 1L, 5L, true, 0, 51, true);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_16() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		criteria.put("String1", S1Range);
		criteria.put("Long2", 101l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 26, 51, false, 101L, 101L, false, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_17() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		criteria.put("String1", S1Range);
		criteria.put("Long2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 26, 51, false, 102L, 101L, true, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_18() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("String1", "a");
		criteria.put("Long2", L2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 0, false, 101L, 102L, false, 0, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_19() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L3Range = new JSONObject();
		L3Range.put("$gte", is_l3_equal_l1? 1l : 101l);
		L3Range.put("$lte", is_l3_equal_l1? 2l : 102l);
		criteria.put("String1", null);
		criteria.put("Long3", L3Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 1, 0, true, 101L, 105L, true, 0, 51, true, 1L, 2L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_20() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		JSONObject L3Range = new JSONObject();
		L3Range.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		L3Range.put("$lte", is_l3_equal_l1 ? 2l : 102l);
		criteria.put("String1", S1Range);
		criteria.put("Long3", L3Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 2L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_21() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("String3", "a");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 0, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 0, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_22() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		criteria.put("String1", S1Range);
		criteria.put("String3", "a");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 0, 0, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_23() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "aa");
		S1Range.put("$lte", "az");
		criteria.put("String1", S1Range);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 26, 51, false, 101L, 105L, true, 0, 51, true, 1L, 5L, true, 1, 0, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_24() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long2", 105l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 105L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_25() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long2", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 105L, 101L, true, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_26() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 104l);
		L2Range.put("$lte", 105l);
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long2", L2Range);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 104L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_27() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 105l);
		criteria.put("Long3", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 105L, 105L, false, 0, 51, true, 1L, 1L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_28() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", null);
		criteria.put("Long3", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 106L, 105L, true, 0, 51, true, 1L, 1L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_29() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 105l);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 105L, 105L, false, 0, 51, true, 2L, 1L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_30() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", null);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 106L, 105L, true, 0, 51, true, 2L, 1L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_31() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 104l);
		L2Range.put("$lte", 106l);
		criteria.put("Long2", L2Range);
		criteria.put("String3", is_s3_equal_s1 ? "aa" : "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 104L, 105L, false, 0, 51, true, 1L, 5L, true, 26, 26, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_32() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S3Range = new JSONObject();
		S3Range.put("$gte", is_s3_equal_s1 ? "aa" : "ba");
		S3Range.put("$lte", is_s3_equal_s1 ? "az" : "bz");
		criteria.put("Long2", null);
		criteria.put("String3", S3Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 106L, 105L, true, 0, 51, true, 1L, 5L, true, 26, 51, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_33() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 104l);
		L2Range.put("$lte", 105l);
		JSONObject S3Range = new JSONObject();
		S3Range.put("$gte", "a");
		S3Range.put("$lte", "z");
		criteria.put("Long2", L2Range);
		criteria.put("String3", S3Range);
		JSONObject result = select(criteria);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 104L, 105L, false, 0, 51, true, 1L, 5L, true, 0, 51, false);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_34() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("String2", S2Range);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 26, 51, false, 6L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_35() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L3Range = new JSONObject();
		L3Range.put("$gte", is_l3_equal_l1 ? 4l : 104l);
		L3Range.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("String2", "ba");
		criteria.put("Long3", L3Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 26, 26, false, 4L, 5L, false, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_36() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String2", null);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 27, 26, true, 6L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_37() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String2", "ba");
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 26, 26, false, 1L, 5L, true, 52, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_38() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String2", null);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 27, 26, true, 1L, 5L, true, 52, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_39() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L3Range = new JSONObject();
		L3Range.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		L3Range.put("$lte", is_l3_equal_l1 ? 2l : 102l);
		criteria.put("Long3", L3Range);
		criteria.put("String3", "a");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 0, 51, true, 1L, 2L, false, 0, 0, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_40() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L3Range = new JSONObject();
		L3Range.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		L3Range.put("$lte", is_l3_equal_l1 ? 2l : 102l);
		criteria.put("Long3", L3Range);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 0, 51, true, 1L, 2L, false, 1, 0, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_41() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long3", null);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 0, 51, true, 3L, 2L, true, 1, 0, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_42() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S3Range = new JSONObject();
		S3Range.put("$gte", "aa");
		S3Range.put("$lte", "az");
		criteria.put("Long3", 1l);
		criteria.put("String3", S3Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 5L, true, 0, 51, true, 101L, 105L, true, 0, 51, true, 1L, 1L, false, 26, 51, false);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_43() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 26, 26, false, 105L, 105L, false, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_44() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", "aa");
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 26, 26, false, 105L, 105L, false, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_45() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 27, 26, true, 105L, 105L, false, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_46() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 26, 26, false, 106L, 105L, true, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_47() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		criteria.put("Long2", 105l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 26, 26, false, 105L, 105L, false, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_48() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 27, 26, true, 105L, 105L, false, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_49() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", "aa");
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 26, 26, false, 106L, 105L, true, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_50() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", "aa");
		criteria.put("Long2", 105l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 26, 26, false, 105L, 105L, false, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_51() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 27, 26, true, 106L, 105L, true, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_52() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 27, 26, true, 105L, 105L, false, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_53() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 26, 26, false, 106L, 105L, true, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_54() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 27, 26, true, 106L, 105L, true, 51, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_55() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(1L, 1L, false, 27, 26, true, 106L, 105L, true, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_56() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", "aa");
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 26, 26, false, 106L, 105L, true, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_57() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 1L, true, 27, 26, true, 106L, 105L, true, 52, 51, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_58() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", "az");
		criteria.put("Long2", 101l);
		criteria.put("String2", "b");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 51, 51, false, 101L, 101L, false, 1, 1, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_59() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", null);
		criteria.put("Long2", 101l);
		criteria.put("String2", "b");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 52, 51, true, 101L, 101L, false, 1, 1, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_60() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", "az");
		criteria.put("Long2", null);
		criteria.put("String2", "b");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 51, 51, false, 102L, 101L, true, 1, 1, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_61() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", "az");
		criteria.put("Long2", 101l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 51, 51, false, 101L, 101L, false, 2, 1, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_62() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", "b");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 52, 51, true, 102L, 101L, true, 1, 1, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_63() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", null);
		criteria.put("Long2", 101l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 52, 51, true, 101L, 101L, false, 2, 1, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_64() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", "az");
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 51, 51, false, 102L, 101L, true, 2, 1, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_65() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L1Range = new JSONObject();
		L1Range.put("$gte", 2l);
		L1Range.put("$lte", 3l);
		criteria.put("Long1", L1Range);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(2L, 3L, false, 52, 51, true, 102L, 101L, true, 2, 1, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_66() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", 5l);
		criteria.put("String1", S1Range);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 2, 25, false, 101L, 101L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_67() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", null);
		criteria.put("String1", S1Range);
		criteria.put("Long2", 101l);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 2, 25, false, 101L, 101L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_68() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", 5l);
		criteria.put("String1", S1Range);
		criteria.put("Long2", null);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 2, 25, false, 102L, 101L, true, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_69() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", 5l);
		criteria.put("String1", S1Range);
		criteria.put("Long2", 101l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 2, 25, false, 101L, 101L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_70() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", null);
		criteria.put("String1", S1Range);
		criteria.put("Long2", null);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 2, 25, false, 102L, 101L, true, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_71() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", null);
		criteria.put("String1", S1Range);
		criteria.put("Long2", 101l);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 2, 25, false, 101L, 101L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_72() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", 5l);
		criteria.put("String1", S1Range);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 2, 25, false, 102L, 101L, true, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_73() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S1Range = new JSONObject();
		S1Range.put("$gte", "c");
		S1Range.put("$lte", "z");
		criteria.put("Long1", null);
		criteria.put("String1", S1Range);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 2, 25, false, 102L, 101L, true, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_74() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "z");
		criteria.put("Long2", L2Range);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 25, 25, false, 101L, 102L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_75() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", null);
		criteria.put("String1", "z");
		criteria.put("Long2", L2Range);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 25, 25, false, 101L, 102L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_76() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", null);
		criteria.put("Long2", L2Range);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 26, 25, true, 101L, 102L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_77() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", "z");
		criteria.put("Long2", L2Range);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 25, 25, false, 101L, 102L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_78() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", L2Range);
		criteria.put("String2", "ba");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 26, 25, true, 101L, 102L, false, 26, 26, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_79() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", null);
		criteria.put("String1", "z");
		criteria.put("Long2", L2Range);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 25, 25, false, 101L, 102L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_80() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", 5l);
		criteria.put("String1", null);
		criteria.put("Long2", L2Range);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 26, 25, true, 101L, 102L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_81() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject L2Range = new JSONObject();
		L2Range.put("$gte", 101l);
		L2Range.put("$lte", 102l);
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", L2Range);
		criteria.put("String2", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 26, 25, true, 101L, 102L, false, 27, 26, true, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_82() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", 105l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 0, 0, false, 105L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_83() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", null);
		criteria.put("String1", "a");
		criteria.put("Long2", 105l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 0, 0, false, 105L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_84() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", 5l);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 1, 0, true, 105L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_85() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", 5l);
		criteria.put("String1", "a");
		criteria.put("Long2", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 0, 0, false, 106L, 105L, true, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_86() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 1, 0, true, 105L, 105L, false, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_87() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", null);
		criteria.put("String1", "a");
		criteria.put("Long2", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 0, 0, false, 106L, 105L, true, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_88() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", 5l);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(5L, 5L, false, 1, 0, true, 106L, 105L, true, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_89() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject S2Range = new JSONObject();
		S2Range.put("$gte", "ba");
		S2Range.put("$lte", "bz");
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", S2Range);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = new TableObj(6L, 5L, true, 1, 0, true, 106L, 105L, true, 26, 51, false, 1L, 5L, true, 0, 51, true);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_90() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		criteria.put("String3", "aa");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_91() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		criteria.put("String3", "aa");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_92() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_93() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 105l);
		criteria.put("String2", "bz");
		criteria.put("Long3", null);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_94() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		criteria.put("Long3", null);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_95() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", 105l);
		criteria.put("String2", null);
		criteria.put("Long3", null);
		criteria.put("String3", "aa");
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_96() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long2", null);
		criteria.put("String2", "bz");
		criteria.put("Long3", 1l);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_97() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", 105l);
		criteria.put("Long3", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_98() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", "aa");
		criteria.put("Long2", null);
		criteria.put("Long3", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_99() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_100() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", 1l);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("Long3", 1l);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_101() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_102_1() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "c");
		range_String1.put("$lte", "z");
		criteria.put("String1", range_String1);
		criteria.put("Long3", null);
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "c");
		range_String3.put("$lte", "z");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_102_2() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "c");
		range_String1.put("$lte", "z");
		criteria.put("String1", range_String1);
		criteria.put("Long3", null);
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "c");
		range_String3.put("$lte", "z");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_102_3() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "c");
		range_String1.put("$lt", "z");
		criteria.put("String1", range_String1);
		criteria.put("Long3", null);
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "c");
		range_String3.put("$lte", "z");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_102_4() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "c");
		range_String1.put("$lt", "z");
		criteria.put("String1", range_String1);
		criteria.put("Long3", null);
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "c");
		range_String3.put("$lte", "z");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_103_1() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lt", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_103_2() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lt", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_103_3() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_103_4() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("Long2", 101l);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_104() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("String1", "a");
		criteria.put("Long2", null);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_105() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		criteria.put("String1", null);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_106() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		criteria.put("Long2", null);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", 1l);
		range_Long3.put("$lte", 2l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_106_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		criteria.put("Long2", null);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bz");
		criteria.put("String2", range_String2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 1l);
		range_Long3.put("$lte", 2l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_107() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "aa");
		range_String1.put("$lte", "ab");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lte", 102l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 4l);
		range_Long3.put("$lte", 5l);
		criteria.put("Long3", range_Long3);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_107_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lte", "ab");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 102l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 4l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 102l);
		criteria.put("Long3", range_Long3);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_107_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lt", "ab");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lt", 102l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 4l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 102l);
		criteria.put("Long3", range_Long3);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_107_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "aa");
		range_String1.put("$lt", "ac");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lt", 103l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 3l);
		range_Long3.put("$lt", 5l);
		criteria.put("Long3", range_Long3);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_108() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "aa");
		range_String1.put("$lt", "ac");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lt", 103l);
		criteria.put("Long2", range_Long2);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_108_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lt", "ac");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lt", 103l);
		criteria.put("Long2", range_Long2);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_108_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "aa");
		range_String1.put("$lte", "ac");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 103l);
		criteria.put("Long2", range_Long2);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_108_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "aa");
		range_String1.put("$lte", "ac");
		criteria.put("String1", range_String1);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lte", 103l);
		criteria.put("Long2", range_Long2);
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		criteria.put("Long3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_109() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 4l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		criteria.put("String1", null);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 1l);
		range_Long3.put("$lte", 5l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_109_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 4l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		criteria.put("String1", null);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_109_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 4l);
		range_Long1.put("$lt", 5l);
		criteria.put("Long1", range_Long1);
		criteria.put("String1", null);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 101l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lt", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_109_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 4l);
		range_Long1.put("$lt", 5l);
		criteria.put("Long1", range_Long1);
		criteria.put("String1", null);
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 101l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 1l);
		range_Long3.put("$lt", 5l);
		criteria.put("Long3", range_Long3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_110() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_110_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_110_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_110_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_111() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "ax");
		range_String3.put("$lt", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_111_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "ax");
		range_String3.put("$lt", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_111_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "ax");
		range_String3.put("$lte", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_111_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "ax");
		range_String3.put("$lte", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_112() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 1l);
		range_Long3.put("$lt", 3l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "ax");
		range_String3.put("$lt", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_112_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", 1l);
		range_Long3.put("$lt", 3l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "ax");
		range_String3.put("$lt", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_112_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 1l);
		range_Long3.put("$lte", 3l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "ax");
		range_String3.put("$lte", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_112_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", 1l);
		range_Long3.put("$lte", 3l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "ax");
		range_String3.put("$lte", "az");
		criteria.put("String3", range_String3);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_113() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lt", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", is_s3_equal_s1 ? "aa" : "ba");
		range_String3.put("$lt", is_s3_equal_s1 ? "ac" : "bc");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);
	}
	@Ignore
	@Test
	public void test_113_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lt", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lt", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", is_s3_equal_s1 ? "aa" : "ba");
		range_String3.put("$lt", is_s3_equal_s1 ? "ac" : "bc");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_113_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", is_s3_equal_s1 ? "aa" : "ba");
		range_String3.put("$lte", is_s3_equal_s1 ? "ac" : "bc");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_113_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 1l);
		range_Long1.put("$lte", 3l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", is_l3_equal_l1 ? 1l : 101l);
		range_Long3.put("$lte", is_l3_equal_l1 ? 5l : 105l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", is_s3_equal_s1 ? "aa" : "ba");
		range_String3.put("$lte", is_s3_equal_s1 ? "ac" : "bc");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_114() throws Exception{
		JSONObject criteria = new JSONObject();
		criteria.put("Long1", null);
		criteria.put("String1", null);
		criteria.put("Long2", null);
		criteria.put("String2", null);
		criteria.put("Long3", null);
		criteria.put("String3", null);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_115() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 3l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", 3l);
		range_Long3.put("$lte", 5l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "aa");
		range_String3.put("$lte", "ac");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_115_2() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 3l);
		range_Long1.put("$lte", 5l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lte", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lte", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lte", "bc");
		criteria.put("String2", range_String2);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 3l);
		range_Long3.put("$lte", 5l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "aa");
		range_String3.put("$lte", "ac");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_115_3() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gte", 3l);
		range_Long1.put("$lt", 5l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gte", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gte", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gte", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gte", 3l);
		range_Long3.put("$lt", 5l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gte", "aa");
		range_String3.put("$lt", "ac");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@Test
	public void test_115_4() throws Exception{
		JSONObject criteria = new JSONObject();
		JSONObject range_Long1 = new JSONObject();
		range_Long1.put("$gt", 3l);
		range_Long1.put("$lt", 5l);
		criteria.put("Long1", range_Long1);
		
		JSONObject range_String1 = new JSONObject();
		range_String1.put("$gt", "ax");
		range_String1.put("$lt", "az");
		criteria.put("String1", range_String1);
		
		JSONObject range_Long2 = new JSONObject();
		range_Long2.put("$gt", 103l);
		range_Long2.put("$lt", 105l);
		criteria.put("Long2", range_Long2);
		
		JSONObject range_String2 = new JSONObject();
		range_String2.put("$gt", "ba");
		range_String2.put("$lt", "bc");
		criteria.put("String2", range_String2);
		
		JSONObject range_Long3 = new JSONObject();
		range_Long3.put("$gt", 3l);
		range_Long3.put("$lt", 5l);
		criteria.put("Long3", range_Long3);
		
		JSONObject range_String3 = new JSONObject();
		range_String3.put("$gt", "aa");
		range_String3.put("$lt", "ac");
		criteria.put("String3", range_String3);
		JSONObject result = select(criteria);
		TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		//TableObj obj = Utils.generateTableObj(criteria, is_l3_equal_l1, is_s3_equal_s1);
		assertEquals(Utils.isEqual(result, obj, is_l3_equal_l1, is_s3_equal_s1), true);		
	}
	@AfterClass
	public static void dispose()
	{
		agent.Stop();
	}
	private synchronized static JSONObject select(JSONObject arr) throws Exception
	{
		body.put("Criteria", arr);
		return Utils.execute(body);
	}
}
