package com.saga.functionalTest.update;

import static org.junit.Assert.assertEquals;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

import com.saga.functionalTest.insert.Insert;
import com.saga.functionalTest.insert.TableObj;
import com.saga.functionalTest.utils.Utils;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

import PerformanceTest.SingletonZillion;

public class Update {
	static ZillionAgent agent = null;
	static JSONObject body = null;
	@BeforeClass
	public static void prepare() throws Exception
	{
		agent = SingletonZillion.GetZillion("Update");
		body = new JSONObject();
		body.put("QueryType", "update");
		body.put("Database", Utils.getDatabase());
		body.put("Datatable", Utils.getDatatable());
	}
	@Ignore
	@Test
	public void test_1() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		
		for(long l1 = Insert.LONG1; l1 <= Insert.LONG1_END + 1; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(Insert.STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = Insert.LONG2; l2 <= Insert.LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(Insert.STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == Insert.LONG1_END + 1)
							criteria.put("Long1", null);
						else
							criteria.put("Long1", l1);
						if(s1 == 52)
							criteria.put("String1", null);
						else
							criteria.put("String1", sb1.toString());
						if(l2 == Insert.LONG2_END + 1)
							criteria.put("Long2", null);
						else
							criteria.put("Long2", l2);
						if(s2 == 52)
							criteria.put("String2", null);
						else
							criteria.put("String2", sb2.toString());
						set.put("Long3", criteria.get("Long2"));
						set.put("String3", criteria.get("String2"));
						JSONObject result = update(criteria, set);
						assertEquals(result.get("Count"), 1l);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}
	@Ignore
	@Test
	public void test_2() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		
		for(long l1 = Insert.LONG1; l1 <= Insert.LONG1_END + 1; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(Insert.STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = Insert.LONG2; l2 <= Insert.LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(Insert.STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == Insert.LONG1_END + 1)
							criteria.put("Long1", null);
						else
							criteria.put("Long1", l1);
						if(s1 == 52)
							criteria.put("String1", null);
						else
							criteria.put("String1", sb1.toString());
						if(l2 == Insert.LONG2_END + 1)
							criteria.put("Long2", null);
						else
							criteria.put("Long2", l2);
						if(s2 == 52)
							criteria.put("String2", null);
						else
							criteria.put("String2", sb2.toString());
						set.put("Long3", criteria.get("Long1"));
						set.put("String3", criteria.get("String1"));
						JSONObject result = update(criteria, set);
						assertEquals(result.get("Count"), 1l);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}
	@Ignore
	@Test
	public void test_5() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		criteria.put("Long1", 11l);
		criteria.put("String1", "a");
		criteria.put("Long2", 103l);
		criteria.put("String2", "a");
		set.put("Long2", 101l);
		set.put("Long3", 123l);
		update(criteria, set);
	}
	
	@Test
	public void test_3() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		
		for(long l1 = Insert.LONG1; l1 <= Insert.LONG1_END + 1; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(Insert.STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = Insert.LONG2; l2 <= Insert.LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(Insert.STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == Insert.LONG1_END + 1)
							criteria.put("Long1", null);
						else
							criteria.put("Long1", l1);
						if(s1 == 52)
							criteria.put("String1", null);
						else
							criteria.put("String1", sb1.toString());
						if(l2 == Insert.LONG2_END + 1)
							criteria.put("Long2", null);
						else
							criteria.put("Long2", l2);
						if(s2 == 52)
							criteria.put("String2", null);
						else
							criteria.put("String2", sb2.toString());
						
						set.put("Long1", criteria.get("Long1") == null ? 66l : ((Long)criteria.get("Long1")) *11 );
						set.put("String1", "zz" + (criteria.get("String1") == null? "": (String)criteria.get("String1")));
						JSONObject result = update(criteria, set);
						assertEquals(result.get("Count"), 1l);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}
	@Ignore
	@Test
	public void test_4() throws Exception {
		JSONObject criteria = new JSONObject();
		JSONObject set = new JSONObject();
		
		for(long l1 = Insert.LONG1; l1 <= Insert.LONG1_END + 1; ++l1)
		{
			for(int s1 = 0; s1 < 52 + 1; ++s1)
			{
				StringBuilder sb1 = new StringBuilder();
				if(s1 > 25)
					sb1.append(Insert.STR1);
				sb1.append((char)('a' + s1%26));
				for(long l2 = Insert.LONG2; l2 <= Insert.LONG2_END + 1; ++l2)
				{
					for(int s2 = 0; s2 < 52 + 1; ++s2)
					{
						StringBuilder sb2 = new StringBuilder();
						if(s2 > 25)
							sb2.append(Insert.STR2);
						sb2.append((char)('a' + s2%26));
						if(l1 == Insert.LONG1_END + 1)
							criteria.put("Long1", null);
						else
							criteria.put("Long1", l1);
						if(s1 == 52)
							criteria.put("String1", null);
						else
							criteria.put("String1", sb1.toString());
						if(l2 == Insert.LONG2_END + 1)
							criteria.put("Long2", null);
						else
							criteria.put("Long2", l2);
						if(s2 == 52)
							criteria.put("String2", null);
						else
							criteria.put("String2", sb2.toString());
						set.put("Long1", criteria.get("Long3"));
						set.put("String1", criteria.get("String3"));
						JSONObject result = update(criteria, set);
						assertEquals(result.get("Count"), 1l);
					}
				}
				System.out.println("long1 = " + l1 + ", string1 = " + s1);
			}
		}
	}
	private synchronized static JSONObject update(JSONObject arr, JSONObject set) throws Exception
	{
		body.put("Criteria", arr);
		body.put("Set", set);
		return Utils.execute(body);
	}
	@AfterClass
	public static void dispose()
	{
		agent.Stop();
	}
	
}
