package com.saga.functionalTest.utils;

import java.io.File;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import org.zillion.util.json.JSONReaderUtil;

import com.saga.functionalTest.insert.Insert;
import com.saga.functionalTest.insert.TableObj;
import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;

import PerformanceTest.SingletonZillion;

public class Utils {
	public static String database = "";
	public static String datatable = "";
	public static JSONObject def = null;

	public static String getDatabase() throws Exception {
		if (database.equals(""))
			readJson();
		return database;
	}

	public static String getDatatable() throws Exception {
		if (datatable.equals(""))
			readJson();
		return datatable;
	}

	public static JSONObject getDef() throws Exception {
		if (def == null)
			readJson();
		return def;
	}

	public static TableObj generateTableObj(JSONObject criteria, boolean is_l3_equal_l1, boolean is_s3_equal_s1){
		long l1;
		long l1_end;
		boolean l1_null;//true if l1 contains null
		int s1;
		int s1_end;
		boolean s1_null;
		long l2;
		long l2_end;
		boolean l2_null;
		int s2;
		int s2_end;
		boolean s2_null;
		long l3;
		long l3_end;
		boolean l3_null;
		int s3;
		int s3_end;
		boolean s3_null;
		Long[] range = getBoundary(criteria, "Long1", "Long1");
		l1 = range[0];
		l1_end = range[1];
		l1_null = range[2] == 0?false:true;
		range = getBoundary(criteria, "String1", "String1");
		s1 = (int)((long) range[0]);
		s1_end = (int)((long) range[1]);
		s1_null = range[2] == 0?false:true;
		range = getBoundary(criteria, "Long2", "Long2");
		l2 = range[0];
		l2_end = range[1];
		l2_null = range[2] == 0?false:true;
		range = getBoundary(criteria, "String2", "String2");
		s2 = (int)((long) range[0]);
		s2_end = (int)((long) range[1]);
		s2_null = range[2] == 0?false:true;
		if(is_l3_equal_l1){
			range = getBoundary(criteria, "Long3", "Long1");
		}else{
			range = getBoundary(criteria, "Long3", "Long2");
		}
		l3 = range[0];
		l3_end = range[1];
		l3_null = range[2] == 0?false:true;
		if(is_s3_equal_s1){
			range = getBoundary(criteria, "String3", "String1");
		}else{
			range = getBoundary(criteria, "String3", "String2");
		}
		s3 = (int)((long) range[0]);
		s3_end = (int)((long) range[1]);
		s3_null = range[2] == 0?false:true;
		return new TableObj(l1, l1_end, l1_null, s1, s1_end, s1_null, l2, l2_end, l2_null, s2, s2_end, s2_null, l3, l3_end, l3_null, s3, s3_end, s3_null);
	}
	private static Long[] getBoundary(JSONObject criteria, String key, String boundary){
		Long[] result = new Long[3];
		long start = 0;
		long end = 0;
		long containsNull = 0;//1:true,0:false
		long boundary_start = 0;
		long boundary_end = 0;
		switch(boundary){
		case "Long1":
			boundary_start = Insert.LONG1;
			boundary_end = Insert.LONG1_END;
			break;
		case "Long2":
			boundary_start = Insert.LONG2;
			boundary_end = Insert.LONG2_END;
			break;
		case "String1":
			boundary_start = 0;
			boundary_end = 51;
			break;
		case "String2":
			boundary_start = 0;
			boundary_end = 51;
			break;
		}
		if(!criteria.containsKey(key)){
			result[0] = boundary_start;
			result[1] = boundary_end;
			result[2] = 1l;
			return result;
		}
		if(key.startsWith("Long")){
			if(criteria.get(key) == null){
				start = boundary_end;
				end = boundary_start;
				containsNull = 1;
			}else if(criteria.get(key) instanceof Long){
				if(((Long) criteria.get(key))>boundary_end||((Long) criteria.get(key))<boundary_start){
					start = boundary_end;
					end = boundary_start;
					containsNull = 0;
				}else{
					start = (Long) criteria.get(key);
					end = (Long) criteria.get(key);
					containsNull = 0;
				}
			}else{
				JSONObject range = (JSONObject) criteria.get(key);
				if(range.containsKey("$gt")){
					start = (Long) range.get("$gt");
					++start;
					start = start < boundary_start? boundary_start:start;
					start = start > boundary_end? boundary_end:start;
				}else if(range.containsKey("$gte")){
					start = (Long) range.get("$gte");
					start = start < boundary_start? boundary_start:start;
					start = start > boundary_end? boundary_end:start;
				}
				if(range.containsKey("$lt")){
					end = (Long) range.get("$lt");
					--end;
					end = end > boundary_end? boundary_end:end;
					end = end < boundary_start? boundary_start:end;
				}else if(range.containsKey("$lte")){
					end = (Long) range.get("$lte");
					end = end > boundary_end? boundary_end:end;
					end = end < boundary_start? boundary_start:end;
				}
			}
		}
		if(key.startsWith("String")){
			if(criteria.get(key) == null){
				start = boundary_end;
				end = boundary_start;
				containsNull = 1;
			}else if(criteria.get(key) instanceof String){
				String value = (String) criteria.get(key);
				if(value.length() == 1){
					start = end = value.charAt(0) - 'a';
					containsNull = 0;
				}else{
					start = end = value.charAt(1) - 'a' + 26;
					containsNull = 0;
				}
			}else{
				JSONObject range = (JSONObject) criteria.get(key);
				if(range.containsKey("$gt")){
					String value = (String) range.get("$gt");
					if(value.length() == 1){
						start = value.charAt(0) - 'a' + 1;
						containsNull = 0;
					}else{
						start = value.charAt(1) - 'a' + 26 + 1;
						containsNull = 0;
					}
				}else if(range.containsKey("$gte")){
					String value = (String) range.get("$gte");
					if(value.length() == 1){
						start = value.charAt(0) - 'a';
						containsNull = 0;
					}else{
						start = value.charAt(1) - 'a' + 26;
						containsNull = 0;
					}
				}
				if(range.containsKey("$lt")){
					String value = (String) range.get("$lt");
					if(value.length() == 1){
						end = value.charAt(0) - 'a' - 1;
						containsNull = 0;
					}else{
						end = value.charAt(1) - 'a' + 26 - 1;
						containsNull = 0;
					}
				}else if(range.containsKey("$lte")){
					String value = (String) range.get("$lte");
					if(value.length() == 1){
						end = value.charAt(0) - 'a';
						containsNull = 0;
					}else{
						end = value.charAt(1) - 'a' + 26;
						containsNull = 0;
					}
				}
				if(range.containsKey("$gte")&&range.containsKey("$lte")){
					if(range.get("$gte").toString().equals("a")&&range.get("$lte").toString().equals("z")){
						start = boundary_start;
						end = boundary_end;
					}
				}
			}
		}
		result[0] = start;
		result[1] = end;
		result[2] = containsNull;
		return result;
	}
	private static void readJson() throws Exception {
		String path = "etc/base1/FunctionalTest/table1_index_v.json";
		def = (JSONObject) JSONReaderUtil.Instance().Read(new File(path));
		if (def != null && def.containsKey("Database") && def.containsKey("Datatable")) {
			database = def.get("Database").toString();
			datatable = def.get("Datatable").toString();
		}
	}

	public static synchronized JSONObject execute(JSONObject obj) throws Exception {
		JSONObject tmp = SingletonZillion.GetZillion().Query(obj);
		return tmp;
	}

	public static boolean isEqual(JSONObject result, TableObj tabObj, boolean is_l3_equal_l1,
			boolean is_s3_equal_s1) {
		JSONArray arr = (JSONArray) result.get("Content");
		HashSet<String> set = new HashSet<>();
		List<List<Long>> ranges = getRanges(tabObj, is_l3_equal_l1, is_s3_equal_s1);
		for (int i = 0; i < ranges.get(0).size(); ++i) {
			for (int j = 0; j < ranges.get(1).size(); ++j) {
				for (int k = 0; k < ranges.get(2).size(); ++k) {
					for (int l = 0; l < ranges.get(3).size(); ++l) {
						Long long1 = ranges.get(0).get(i);
						Long str1 = ranges.get(1).get(j);
						Long long2 = ranges.get(2).get(k);
						Long str2 = ranges.get(3).get(l);
						StringBuilder sb = new StringBuilder();
						if (long1 == null) {
							sb.append("null");
						} else {
							sb.append(long1);
						}
						if (str1 == null) {
							sb.append("null");
						} else {
							if (str1 > 25)
								sb.append((char) 'a');
							sb.append((char) ('a' + str1 % 26));
						}
						if (long2 == null) {
							sb.append("null");
						} else {
							sb.append(long2);
						}
						if (str2 == null) {
							sb.append("null");
						} else {
							if (str2 > 25)
								sb.append((char) 'b');
							sb.append((char) ('a' + str2 % 26));
						}
						if (is_l3_equal_l1) {
							if (long1 == null) {
								sb.append("null");
							} else {
								sb.append(long1);
							}
						} else {
							if (long2 == null) {
								sb.append("null");
							} else {
								sb.append(long2);
							}
						}
						if (is_s3_equal_s1) {
							if (str1 == null) {
								sb.append("null");
							} else {
								if (str1 > 25)
									sb.append((char) 'a');
								sb.append((char) ('a' + str1 % 26));
							}
						} else {
							if (str2 == null) {
								sb.append("null");
							} else {
								if (str2 > 25)
									sb.append((char) 'b');
								sb.append((char) ('a' + str2 % 26));
							}
						}
						set.add(sb.toString());
					}
				}
			}
		}

		long count = set.size();

		if (result == null || !result.containsKey("Result") || !result.containsKey("Count")
				|| !result.containsKey("Content"))
			return false;
		if (!result.get("Result").equals("success") || !result.get("Count").equals(count)
				|| !(((JSONArray) result.get("Content")).size() == count))
			return false;
		for (int i = 0; i < arr.size(); ++i) {
			JSONObject obj = (JSONObject) arr.get(i);
			if (!obj.containsKey("Long1") || !obj.containsKey("String1") || !obj.containsKey("Long2")
					|| !obj.containsKey("String2") || !obj.containsKey("Long3") || !obj.containsKey("String3"))
				return false;

			StringBuilder sb = new StringBuilder();
			sb.append(obj.get("Long1")==null?"null":obj.get("Long1"));
			sb.append(obj.get("String1")==null?"null":obj.get("String1"));
			sb.append(obj.get("Long2")==null?"null":obj.get("Long2"));
			sb.append(obj.get("String2")==null?"null":obj.get("String2"));
			sb.append(obj.get("Long3")==null?"null":obj.get("Long3"));
			sb.append(obj.get("String3")==null?"null":obj.get("String3"));
			if (set.contains(sb.toString()))
				set.remove(sb.toString());
			else
				return false;
		}
		if (set.isEmpty())
			return true;
		return false;
	}

	private static List<List<Long>> getRanges(TableObj tabObj, boolean is_l3_equal_l1, boolean is_s3_equal_s1) {
		List<List<Long>> ranges = new ArrayList<List<Long>>();
		List<Long> L1Range = getRange(tabObj.getL1(), tabObj.getL1_end(), tabObj.isL1_null());
		List<Long> S1Range = getRange(tabObj.getS1(), tabObj.getS1_end(), tabObj.isS1_null());
		List<Long> L2Range = getRange(tabObj.getL2(), tabObj.getL2_end(), tabObj.isL2_null());
		List<Long> S2Range = getRange(tabObj.getS2(), tabObj.getS2_end(), tabObj.isS2_null());
		List<Long> L3Range = getRange(tabObj.getL3(), tabObj.getL3_end(), tabObj.isL3_null());
		List<Long> S3Range = getRange(tabObj.getS3(), tabObj.getS3_end(), tabObj.isS3_null());
		if (is_l3_equal_l1) {
			getIntersection(L1Range, L3Range);
		} else {
			getIntersection(L2Range, L3Range);
		}
		if (is_s3_equal_s1) {
			getIntersection(S1Range, S3Range);
		} else {
			getIntersection(S2Range, S3Range);
		}

		ranges.add(L1Range);
		ranges.add(S1Range);
		ranges.add(L2Range);
		ranges.add(S2Range);
		return ranges;
	}

	private static List<Long> getRange(long start, long end, boolean includeNull) {
		List<Long> range = new ArrayList<>();
		if (includeNull) {
			range.add(null);
		}
		for (long i = start; i <= end; ++i) {
			range.add(i);
		}

		return range;
	}

	private static void getIntersection(List<Long> range1, List<Long> range2) {
		List<Long> intersection = new ArrayList<Long>();
		for(int i = 0; i < range1.size(); ++i){
			if(range2.contains(range1.get(i))){
				intersection.add(range1.get(i));
			}
		}
		range1.clear();
		range2.clear();
		range1.addAll(intersection);
		range2.addAll(intersection);
	}
}
