package jdbc;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;

import org.zillion.util.common.MyException;

import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import com.zillion.database.util.ResultSet_MySQL;

/**
 * @Description: JDBCԪʾ-- DatabaseMetaDataӿ
 * @CreateTime: 2014-1-19 9:46:44
 * @author: chenzw
 * @version V1.0
 */
public class JdbcUtil {
	static HikariDataSource cpds;
	static {
		try {
			// ʼJDBCصjvm
			// Class.forName("com.mysql.jdbc.Driver").newInstance();
			Class.forName("org.apache.ignite.IgniteJdbcDriver").newInstance();
		} catch (Exception e) {
			e.printStackTrace();
		}

		try {
			HikariConfig config = new HikariConfig();
			config.setJdbcUrl("jdbc:mysql://localhost:3306/test");
			config.setUsername("pbsage");
			config.setPassword("123456");
			config.setMaximumPoolSize(100);
			config.setIdleTimeout(60000L);
			config.addDataSourceProperty("cachePrepStmts", "true");
			config.addDataSourceProperty("prepStmtCacheSize", 100);
			config.addDataSourceProperty("prepStmtCacheSqlLimit", "2048");
			config.setPoolName("test");
			config.setRegisterMbeans(true);
			cpds = new HikariDataSource(config);
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static Connection getConnection() {
		Connection conn = null;
		try {
			// ݿ

			/*
			 * ÿɻȡREMARKעϢ Properties props =new Properties(); props.put("remarksReporting","true"); props.put("user", USER);
			 * props.put("password", PASS); conn =DriverManager.getConnection(URL,props);
			 */

			// conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/test", "pbsage", "1023456");
			// conn = DriverManager.getConnection("jdbc:ignite:thin://192.168.20.160:10800");
			// conn = DriverManager.getConnection("jdbc:ignite:thin://192.168.20.160:10800,192.168.20.161:10800");
			// conn = DriverManager.getConnection("jdbc:ignite:cfg://cache=tokenCache@file://" + LogUtil.GetPath() + "/ignite-jdbc.xml");
			// conn = cpds.getConnection();
			conn = cpds.getConnection();
			conn.setAutoCommit(true);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return conn;
	}

	// ر
	public static void close(Object o) {
		if (o == null) {
			return;
		}
		if (o instanceof ResultSet) {
			try {
				((ResultSet) o).close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		} else if (o instanceof Statement) {
			try {
				((Statement) o).close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		} else if (o instanceof Connection) {
			Connection c = (Connection) o;
			try {
				if (!c.isClosed()) {
					c.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

	public static void close(ResultSet rs, Statement stmt, Connection conn) {
		close(rs);
		close(stmt);
		close(conn);
	}

	public static void close(ResultSet rs, Connection conn) {
		close(rs);
		close(conn);
	}

	/**
	 * @Description: ȡݿϢ @author: chenzw @CreateTime: 2014-1-27 5:09:12 @throws
	 */
	public static void getDataBaseInfo() {
		Connection conn = getConnection();

		ResultSet rs = null;
		try {
			DatabaseMetaData dbmd = conn.getMetaData();
			System.out.println("ݿ֪û: " + dbmd.getUserName());
			System.out.println("ݿϵͳĶŷָб: " + dbmd.getSystemFunctions());
			System.out.println("ݿʱںĶŷָб: " + dbmd.getTimeDateFunctions());
			System.out.println("ݿַĶŷָб: " + dbmd.getStringFunctions());
			System.out.println("ݿ⹩Ӧ 'schema' ѡ: " + dbmd.getSchemaTerm());
			System.out.println("ݿURL: " + dbmd.getURL());
			System.out.println("Ƿֻ:" + dbmd.isReadOnly());
			System.out.println("ݿĲƷ:" + dbmd.getDatabaseProductName());
			System.out.println("ݿİ汾:" + dbmd.getDatabaseProductVersion());
			System.out.println(":" + dbmd.getDriverName());
			System.out.println("İ汾:" + dbmd.getDriverVersion());

			System.out.println("ݿʹõı");
			rs = dbmd.getTableTypes();
			while (rs.next()) {
				System.out.println(rs.getString("TABLE_TYPE"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description:ݿSchemas(ӦoracleеTablespace) @author: chenzw @CreateTime: 2014-1-27 5:10:35 @throws
	 */
	public static void getSchemasInfo() {
		Connection conn = getConnection();
		ResultSet rs = null;
		try {
			DatabaseMetaData dbmd = conn.getMetaData();
			rs = dbmd.getSchemas();
			while (rs.next()) {
				String tableSchem = rs.getString("TABLE_SCHEM");
				System.out.println(tableSchem);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description: ȡݿеıϢ @author: chenzw @CreateTime: 2014-1-27 5:08:28 @throws
	 */
	public static void getTablesList() {
		Connection conn = getConnection();
		ResultSet rs = null;
		try {
			/**
			 * ,ʹÿɻȡREMARK(ע)
			 */
			DatabaseMetaData dbmd = conn.getMetaData();
			String[] types = { "TABLE" };
			rs = dbmd.getTables(null, null, "%", types);
			while (rs.next()) {
				String tableName = rs.getString("TABLE_NAME"); // 
				String tableType = rs.getString("TABLE_TYPE"); // 
				String remarks = rs.getString("REMARKS"); // ע
				System.out.println(tableName + " - " + tableType + " - " + remarks);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description: ȡĳϢ @author: chenzw @CreateTime: 2014-1-27 3:26:30 @throws
	 */
	public static void getTablesInfo() {
		Connection conn = getConnection();
		ResultSet rs = null;
		try {
			/**
			 * ,ʹÿɻȡREMARK(ע)
			 */
			DatabaseMetaData dbmd = conn.getMetaData();
			/**
			 * ȡʹõı ԭ:ResultSet getTables(String catalog,String schemaPattern,String tableNamePattern,String[] types); catalog -
			 * ڵ;""ʾȡû,nullʾȡС schema - ڵģʽ(oracleжӦTablespace);""ʾȡûģʽ,nullʶȡģʽ; ɰַͨ("_"),ַͨ("%");
			 * tableNamePattern - ;ɰַͨ("_"),ַͨ("%"); types - ; "TABLE""VIEW""SYSTEM TABLE""GLOBAL TEMPORARY""LOCAL
			 * TEMPORARY""ALIAS"  "SYNONYM";nullʾеı;ɰַͨ("_"),ַͨ("%");
			 */
			rs = dbmd.getTables(null, null, "CUST_INTER_TF_SERVICE_REQ", new String[] { "TABLE", "VIEW" });

			while (rs.next()) {
				String tableCat = rs.getString("TABLE_CAT"); // (Ϊnull)
				String tableSchemaName = rs.getString("TABLE_SCHEM");// ģʽΪգ,oracleлȡռ,ݿδ֪
				String tableName = rs.getString("TABLE_NAME"); // 
				String tableType = rs.getString("TABLE_TYPE"); // ,͵ "TABLE""VIEW""SYSTEM TABLE""GLOBAL TEMPORARY""LOCAL
																// TEMPORARY""ALIAS"  "SYNONYM"
				String remarks = rs.getString("REMARKS"); // ע

				System.out.println(tableCat + " - " + tableSchemaName + " - " + tableName + " - " + tableType + " - " + remarks);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description: ȡϢ @author: chenzw @CreateTime: 2014-1-27 5:12:53 @throws
	 */
	public static void getPrimaryKeysInfo() {
		Connection conn = getConnection();
		ResultSet rs = null;
		try {
			DatabaseMetaData dbmd = conn.getMetaData();
			/**
			 * ȡԸе ԭ:ResultSet getPrimaryKeys(String catalog,String schema,String table); catalog - ڵ;""ʾȡû,nullʾȡС
			 * schema - ڵģʽ(oracleжӦTablespace);""ʾȡûģʽ,nullʶȡģʽ; ɰַͨ("_"),ַͨ("%"); table -
			 * ;ɰַͨ("_"),ַͨ("%");
			 */
			rs = dbmd.getPrimaryKeys(null, null, "CUST_INTER_TF_SERVICE_REQ");

			while (rs.next()) {
				String tableCat = rs.getString("TABLE_CAT"); // (Ϊnull)
				String tableSchemaName = rs.getString("TABLE_SCHEM");// ģʽΪգ,oracleлȡռ,ݿδ֪
				String tableName = rs.getString("TABLE_NAME"); // 
				String columnName = rs.getString("COLUMN_NAME");// 
				short keySeq = rs.getShort("KEY_SEQ");// к(ֵ1ʾһеֵ2ڵĵڶ)
				String pkName = rs.getString("PK_NAME"); // 

				System.out.println(tableCat + " - " + tableSchemaName + " - " + tableName + " - " + columnName + " - " + keySeq + " - " + pkName);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description: ȡϢ @author: chenzw @CreateTime: 2014-1-27 5:12:04 @throws
	 */
	public static void getIndexInfo() {
		Connection conn = getConnection();
		ResultSet rs = null;
		try {
			DatabaseMetaData dbmd = conn.getMetaData();
			/**
			 * ȡͳϢ ԭ:ResultSet getIndexInfo(String catalog,String schema,String table,boolean unique,boolean approximate) catalog -
			 * ڵ;""ʾȡû,nullʾȡС schema - ڵģʽ(oracleжӦTablespace);""ʾȡûģʽ,nullʶȡģʽ; ɰַͨ("_"),ַͨ("%");
			 * table - ;ɰַͨ("_"),ַͨ("%"); unique - òΪ trueʱ,Ψһֵ; òΪ falseʱ,; approximate -
			 * òΪtrueʱ,ǽӽֵЩֵֵ;òΪ falseʱ,ҪǾȷ;
			 */
			rs = dbmd.getIndexInfo(null, null, "CUST_INTER_TF_SERVICE_REQ", false, true);
			while (rs.next()) {
				String tableCat = rs.getString("TABLE_CAT"); // (Ϊnull)
				String tableSchemaName = rs.getString("TABLE_SCHEM");// ģʽΪգ,oracleлȡռ,ݿδ֪
				String tableName = rs.getString("TABLE_NAME"); // 
				boolean nonUnique = rs.getBoolean("NON_UNIQUE");// ֵǷԲΨһ,TYPEΪ tableIndexStatisticʱֵΪ false;
				String indexQualifier = rs.getString("INDEX_QUALIFIER");// 𣨿Ϊգ,TYPEΪ tableIndexStatistic ʱΪ null;
				String indexName = rs.getString("INDEX_NAME");//  ;TYPEΪ tableIndexStatistic ʱΪ null;
				/**
				 * ͣ tableIndexStatistic - ˱ʶһ𷵻صıͳϢ tableIndexClustered - ΪȺ tableIndexHashed - Ϊɢ tableIndexOther -
				 * Ϊĳʽ
				 */
				short type = rs.getShort("TYPE");// ;
				short ordinalPosition = rs.getShort("ORDINAL_POSITION");// ˳;TYPEΪ tableIndexStatistic ʱкΪ;
				String columnName = rs.getString("COLUMN_NAME");// ;TYPEΪ tableIndexStatisticʱΪ null;
				String ascOrDesc = rs.getString("ASC_OR_DESC");// ˳:ǽ[A:; B:];в֧,Ϊ null;TYPEΪ tableIndexStatisticʱΪ null;
				int cardinality = rs.getInt("CARDINALITY"); // ;TYPEΪ tableIndexStatistic ʱ,Ǳе;,Ψһֵ
				int pages = rs.getInt("PAGES"); // TYPEΪ tableIndexStatisicʱ,ڱҳ,ڵǰҳ
				String filterCondition = rs.getString("FILTER_CONDITION"); // ,еĻ(Ϊ null)

				System.out.println(tableCat + " - " + tableSchemaName + " - " + tableName + " - " + nonUnique + " - " + indexQualifier + " - "
						+ indexName + " - " + type + " - " + ordinalPosition + " - " + columnName + " - " + ascOrDesc + " - " + cardinality + " - "
						+ pages + " - " + filterCondition);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	/**
	 * @Description: ȡֵϢ @author: chenzw @CreateTime: 2014-1-27 2:55:56 @throws
	 */
	public static void getColumnsInfo() {
		Connection conn = getConnection();
		ResultSet rs = null;

		try {
			/**
			 * ,ʹÿɻȡеREMARK(ע)
			 */
			DatabaseMetaData dbmd = conn.getMetaData();
			/**
			 * ȡָʹõıе ԭ:ResultSet getColumns(String catalog,String schemaPattern,String tableNamePattern,String columnNamePattern)
			 * catalog - ڵ;""ʾȡû,nullʾȡС schema - ڵģʽ(oracleжӦTablespace);""ʾȡûģʽ,nullʶȡģʽ;
			 * ɰַͨ("_"),ַͨ("%"); tableNamePattern - ;ɰַͨ("_"),ַͨ("%"); columnNamePattern - ;
			 * ""ʾȡΪ""(Ȼȡ);nullʾȡе;ɰַͨ("_"),ַͨ("%");
			 */
			rs = dbmd.getColumns(null, null, "CUST_INTER_TF_SERVICE_REQ", null);

			while (rs.next()) {
				String tableCat = rs.getString("TABLE_CAT"); // 𣨿Ϊգ
				String tableSchemaName = rs.getString("TABLE_SCHEM"); // ģʽΪգ,oracleлȡռ,ݿδ֪
				String tableName_ = rs.getString("TABLE_NAME"); // 
				String columnName = rs.getString("COLUMN_NAME"); // 
				int dataType = rs.getInt("DATA_TYPE"); // Ӧjava.sql.TypesSQL(ID)
				String dataTypeName = rs.getString("TYPE_NAME"); // java.sql.Types()
				int columnSize = rs.getInt("COLUMN_SIZE"); // дС
				int decimalDigits = rs.getInt("DECIMAL_DIGITS"); // Сλ
				int numPrecRadix = rs.getInt("NUM_PREC_RADIX"); // ͨ102 --δ֪
				/**
				 * 0 (columnNoNulls) - вΪ 1 (columnNullable) - Ϊ 2 (columnNullableUnknown) - ȷǷΪ
				 */
				int nullAble = rs.getInt("NULLABLE"); // ǷΪnull
				String remarks = rs.getString("REMARKS"); // 
				String columnDef = rs.getString("COLUMN_DEF"); // Ĭֵ
				int charOctetLength = rs.getInt("CHAR_OCTET_LENGTH"); //  char ͣóеֽ
				int ordinalPosition = rs.getInt("ORDINAL_POSITION"); // е1ʼ
				/**
				 * ISOȷĳһеǷΪ(ͬNULLABLEֵ:[ 0:'YES'; 1:'NO'; 2:''; ]) YES -- ппֵ; NO -- вΪ; ַ--- ֪ǷΪ
				 */
				String isNullAble = rs.getString("IS_NULLABLE");

				/**
				 * ָʾǷԶ YES -- Զ NO -- вԶ ִ--- ȷǷԶ
				 */
				// String isAutoincrement = rs.getString("IS_AUTOINCREMENT"); //òԱ

				System.out.println(tableCat + " - " + tableSchemaName + " - " + tableName_ + " - " + columnName + " - " + dataType + " - "
						+ dataTypeName + " - " + columnSize + " - " + decimalDigits + " - " + numPrecRadix + " - " + nullAble + " - " + remarks
						+ " - " + columnDef + " - " + charOctetLength + " - " + ordinalPosition + " - " + isNullAble);

			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			JdbcUtil.close(rs, conn);
		}
	}

	private static int param_to_int(Object columnObject) throws Exception {
		int result;
		if (columnObject instanceof Integer) {
			result = ((Integer) columnObject).intValue();
		} else if (columnObject instanceof Long) {
			result = ((Long) columnObject).intValue();
		} else if (columnObject instanceof BigInteger) {
			result = ((BigInteger) columnObject).intValue();
		} else if (columnObject instanceof Boolean) {
			result = ((Boolean) columnObject) ? 1 : 0;
		} else {
			throw new MyException("");
		}
		return result;
	}

	private static long param_to_long(Object columnObject) throws Exception {
		long result;
		if (columnObject instanceof Integer) {
			result = ((Integer) columnObject).longValue();
		} else if (columnObject instanceof Long) {
			result = ((Long) columnObject).longValue();
		} else if (columnObject instanceof BigInteger) {
			result = ((BigInteger) columnObject).longValue();
		} else if (columnObject instanceof BigDecimal) {
			result = ((BigDecimal) columnObject).longValue();
		} else if (columnObject instanceof Boolean) {
			result = ((Boolean) columnObject) ? 1 : 0;
		} else {
			throw new MyException("");
		}
		return result;
	}

	private static double param_to_double(Object columnObject) throws Exception {
		double result;
		if (columnObject instanceof Integer) {
			result = ((Integer) columnObject).doubleValue();
		} else if (columnObject instanceof Long) {
			result = ((Long) columnObject).doubleValue();
		} else if (columnObject instanceof BigInteger) {
			result = ((BigInteger) columnObject).doubleValue();
		} else if (columnObject instanceof Float) {
			result = ((Float) columnObject).doubleValue();
		} else if (columnObject instanceof Double) {
			result = ((Double) columnObject).doubleValue();
		} else if (columnObject instanceof BigDecimal) {
			result = ((BigDecimal) columnObject).doubleValue();
		} else {
			throw new MyException("");
		}
		return result;
	}

	private static ResultSet_MySQL ori_select(Connection conn, String stringSQL, List<Integer> typeList, List<Object> params) throws Exception {
		ResultSet_MySQL result = new ResultSet_MySQL();

		PreparedStatement stmt = conn.prepareStatement(stringSQL);
		for (int i = 0; i < params.size(); i++) {
			int parameterIndex = i + 1;
			Object param = params.get(i);
			int ttttt = typeList.get(i);
			if (param == null) {
				stmt.setNull(parameterIndex, ttttt);
			} else {
				if (ttttt == Types.INTEGER) {
					stmt.setInt(parameterIndex, param_to_int(param));
				} else if (ttttt == Types.BIGINT) {
					stmt.setBigDecimal(parameterIndex, new BigDecimal(param_to_long(param)));
				} else if (ttttt == Types.DOUBLE) {
					stmt.setDouble(parameterIndex, param_to_double(param));
				} else if (ttttt == Types.VARCHAR) {
					stmt.setString(parameterIndex, (String) param);
				}
			}
		}
		ResultSet rs = stmt.executeQuery();
		ResultSetMetaData rsmd = rs.getMetaData();
		String[] columnLabels = new String[rsmd.getColumnCount()];
		int[] columnTypes = new int[rsmd.getColumnCount()];
		for (int i = 1; i <= rsmd.getColumnCount(); i++) {
			columnLabels[i - 1] = rsmd.getColumnLabel(i);
			columnTypes[i - 1] = rsmd.getColumnType(i);
		}
		result.columnLabels = columnLabels;
		result.columnTypes = columnTypes;
		while (rs.next()) {
			Object[] columns = new Object[columnLabels.length];
			for (int i = 0; i < columnLabels.length; i++) {
				int columnType = columnTypes[i];
				if (columnType == Types.INTEGER) {
					columns[i] = rs.getInt(columnLabels[i]);
				} else if (columnType == Types.BIGINT) {
					columns[i] = rs.getBigDecimal(columnLabels[i]);
				} else if (columnType == Types.DOUBLE) {
					columns[i] = rs.getDouble(columnLabels[i]);
				} else if (columnType == Types.VARCHAR) {
					columns[i] = rs.getString(columnLabels[i]);
				} else if (columnType == Types.LONGVARCHAR) {
					columns[i] = rs.getString(columnLabels[i]);
				} else {
					throw new MyException("");
				}
				if (rs.wasNull()) {
					columns[i] = null;
				}
			}
			result.rowList.add(columns);
		}
		rs.close();
		stmt.close();

		return result;
	}

	/**
	 * @Description: TODO @author: chenzw @CreateTime: 2014-1-17 2:47:45 @param args @throws
	 */
	public static void main(String[] args) {
		Connection conn = getConnection();
		try {
			{
				try {
					Statement stmt = conn.createStatement();
					String stringSQL = "CREATE TABLE IF NOT EXISTS PUBLIC.zillion_meta_data2"
							+ "(`tableName` varchar(250) NOT NULL,`q` varchar(250) NOT NULL,`hi` varchar(500),`hd` varchar(500),`hc` varchar(500),PRIMARY KEY (`tableName`))";
					stmt.execute(stringSQL);
					stmt.close();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			try {
				{
					String stringSQL = "INSERT INTO PUBLIC.zillion_meta_data2 (tableName,q) VALUES(?,?)";
					PreparedStatement stmt = conn.prepareStatement(stringSQL);
					stmt.setString(1, "abc");
					stmt.setString(2, "abc");
					stmt.execute();
					stmt.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			try {
				{
					String stringSQL = "CREATE INDEX IF NOT EXISTS PUBLIC.zillion_meta_data2_index_1 on PUBLIC.zillion_meta_data2 (q)";
					PreparedStatement stmt = conn.prepareStatement(stringSQL);
					stmt.execute();
					stmt.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			{
				String stringSQL = "SELECT * FROM PUBLIC.zillion_meta_data2";
				List<Integer> typeList = new ArrayList<Integer>();
				List<Object> params = new ArrayList<Object>();
				ResultSet_MySQL result = ori_select(conn, stringSQL, typeList, params);
				System.out.println(result);
			}

			conn.close();
			Thread.sleep(1000L * 15);
			conn = getConnection();

			try {
				{
					String stringSQL = "DROP INDEX IF EXISTS PUBLIC.zillion_meta_data2_index_1";
					PreparedStatement stmt = conn.prepareStatement(stringSQL);
					stmt.execute();
					stmt.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			try {
				{
					String stringSQL = "DROP TABLE IF EXISTS PUBLIC.ZILLION_META_DATA2";
					PreparedStatement stmt = conn.prepareStatement(stringSQL);
					stmt.execute();
					stmt.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		// getDataBaseInfo(); // ȡݿϢ
		// getSchemasInfo(); // ȡݿSchema
		// getTablesList(); // ȡĳûеı
		// getTablesInfo(); // ȡϢ
		// getPrimaryKeysInfo(); // ȡϢ
		// getIndexInfo(); // ȡϢ
		// getColumnsInfo(); // ȡֵϢ
	}
}