package regionTest;
import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.common.HexToByte;
import org.zillion.util.json.JSONReaderUtil;
import org.zillion.util.log.LogUtil;

import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class RegionTest3 implements Runnable{
	static long size_times = 100000;
	static long size_per_time = 10000;	

	static Long size_long = 1l;

	static String database_name = "database_1";
	static String table_name = "table3";
	ZillionAgent agent = null;
	public RegionTest3(ZillionAgent agent)
	{
		this.agent = agent;
	}
	//һtable_31010ÿ1һid11ģڶid12
	// ʵ id(long)name(string), id1-1e10 Name = id, ˳
	@Override
	public void run() {
		// TODO Auto-generated method stub
		//ZillionAgent agent = ZillionAgentObject.Get();
		try {
			agent.Start();

			agent.NDL_AddDatabase(database_name);

			// ɾ
			boolean exist = false;
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_list");
			wrapperObject.put("Database", database_name);
			JSONObject result = agent.Query(wrapperObject);
			JSONArray array = (JSONArray) result.get("Content");
			for (int ii = 0; ii < array.size(); ii++) {
				String tableNameInner = (String) array.get(ii);
				if (tableNameInner.equals(table_name)) {
					exist = true;
					break;
				}
			}
			if (exist) {
				agent.DDL_DropTable(database_name, table_name);
			}

			// ʼ
			JSONObject def = (JSONObject) JSONReaderUtil.Instance().Read(new File("etc/base1/regionTest.json"));
			JSONArray Columns = (JSONArray) def.get("Columns");
			JSONArray Key = (JSONArray) def.get("Key");

			JSONObject table_schema = new JSONObject();
			table_schema.put("Columns", Columns);
			table_schema.put("Key", Key);
			if (def.containsKey("delete_UsePutV")) {
				table_schema.put("delete_UsePutV", (Boolean) def.get("delete_UsePutV"));
			}
			agent.DDL_AddTable(database_name, table_name, table_schema, (JSONArray) def.get("Indexes"));

			insert(agent);
			agent.Stop();
			System.out.println("table_3 Finished");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	static void insert(ZillionAgent agent) throws Exception {
		LogUtil.info("insert begin:");
		long seed = size_per_time-1;
		for (long i = 0; i < size_per_time; i++) {
			JSONArray InsertObjects = new JSONArray();
			seed = (seed + 1)%(size_per_time)==0?(seed + 1):(seed + 1)%(size_per_time);
			for (int ii = 0; ii < size_times; ii++) {
				size_long = (size_per_time * ii) + seed;
				JSONObject InsertObject = new JSONObject();
				InsertObject.put("id", size_long);
				InsertObject.put("name", size_long.toString());

				InsertObjects.add(InsertObject);
			}
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "batch_put");
			wrapperObject.put("InsertObjects", InsertObjects);
			wrapperObject.put("Database", database_name);
			wrapperObject.put("Datatable", table_name);
			agent.Query(wrapperObject);
			LogUtil.info("table3 :" + (i + 1) + "/" + size_per_time);
		}
	}
}

















