package strong_consistency;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.FastJsonUtil;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.util.common.ZillionConstant;
import com.zillion.util.table.ZillionTableColumn;
import com.zillion.util.table.ZillionTableColumnEnum;
import com.zillion.util.table.ZillionTableSchema;

public class AgentTest_strong_consistency {

	static int size_Long = 1000;
	static int size_String = 100;
	static int size_Boolean = 2;

	public static void main(String[] args) throws Exception {
		// String file="etc/selects_strong_none_consistency.json";
		// String file="etc/selects.json";
		// {
		// String file = "etc/selects_strong_consistency.json";
		// ZillionConstant.strong_consistency_cache_redis = false;
		// once(file);
		// }
		{
			String file = "etc/es/selects_strong_consistency_es.json";
			ZillionConstant.strong_consistency_cache_redis = false;
			once(file);
		}
		// {
		// String file = "etc/selects_strong_consistency.json";
		// ZillionConstant.strong_consistency_cache_redis = true;
		// once(file);
		// }
		// {
		// String file = "etc/es/selects_strong_consistency_es.json";
		// ZillionConstant.strong_consistency_cache_redis = true;
		// once(file);
		// }
	}

	public static void once(String file) throws Exception {
		System.setProperty("java.security.krb5.conf", "D:\\Test\\krb5.conf");
		System.setProperty("java.security.krb5.realm", "HADOOP.COM");
		System.setProperty("java.security.krb5.kdc", "node1");
		System.setProperty("java.security.auth.login.config", "D:\\Test\\zk-jaas.conf");
		// System.setProperty("javax.security.auth.useSubjectCredsOnly", "false");

		ZillionConstant.printCriteriaGroup = true;
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		// IZillionAgent agent = new ZillionAgentWebImpl("http://101.201.234.108:8555/metadata-web/");

		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		String database_name = "db_test";
		String table_name = "table_strong_consistency";

		////////////////////////////////////////////////////////////////
		// JSONArray wrapperObjects = FastJsonReaderUtil.Instance().ReadJSONArray(new File("etc/selects_strong_none_consistency.json"));
		// JSONArray wrapperObjects = FastJsonReaderUtil.Instance().ReadJSONArray(new File("etc/es/selects.json"));
		// JSONArray wrapperObjects = FastJsonReaderUtil.Instance().ReadJSONArray(new File("etc/selects_strong_consistency.json"));
		// JSONArray wrapperObjects = FastJsonReaderUtil.Instance().ReadJSONArray(new File("etc/es/selects_strong_consistency_es.json"));
		JSONArray wrapperObjects = FastJsonReaderUtil.Instance().ReadJSONArray(new File(file));
		for (int i = 0; i < wrapperObjects.size(); i++) {
			Thread.sleep(1000L);

			JSONObject wrapperObject = (JSONObject) wrapperObjects.get(i);
			database_name = (String) wrapperObject.get("Database");
			table_name = (String) wrapperObject.get("Datatable");

			String QueryType = (String) wrapperObject.get("QueryType");
			// if (!(!QueryType.equals("table_drop") && !QueryType.equals("table_create"))) {
			// continue;
			// }

			try {
				agent.NDL_AddDatabase(database_name);
			} catch (Exception e1) {
				// e1.printStackTrace();
			}
			try {
				LogUtil.warn("" + new Date());
				// LogUtil.warn("Query:\n" + FastJsonUtil.toFormatString(wrapperObject));
				JSONObject queryResult = agent.Query(wrapperObject, true);
				LogUtil.warn("Result:\n" + FastJsonUtil.toFormatString(queryResult));
				LogUtil.warn("" + new Date());
				Object contentObject = queryResult.get("Content");
				if (contentObject != null) {
					if (contentObject instanceof JSONArray) {
						JSONArray resultContent = (JSONArray) contentObject;
						ZillionTableSchema schema = agent.container.repositoryMap.get(database_name).GetTable(table_name);
						print(schema, resultContent);
					}
				}
				Thread.sleep(1000L);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		Date fromtime = new Date();
		LogUtil.warn("insert from time:" + fromtime);
		insert(agent, database_name, table_name);
		Date totime = new Date();
		LogUtil.warn("insert from to:" + totime);
		LogUtil.warn("insert use:" + (totime.getTime() - fromtime.getTime()));

		agent.Stop();
	}

	static void insert(ZillionAgent agent, String database_name, String table_name) throws Exception {
		Random rand = new Random();
		LogUtil.info("insert begin:" + size_Boolean * size_Long * size_String);
		int exist_count = 0;
		for (int ii = 0; ii < size_Boolean; ii++) {
			for (int iii = 0; iii < size_Long; iii++) {
				JSONArray InsertObjects = new JSONArray();
				for (int iiii = 0; iiii < size_String; iiii++) {
					int index = ((iii * size_String + iiii) * 2 + ii);
					JSONObject InsertObject = new JSONObject();
					InsertObject.put("KeyBoolean", ii % 2 == 0 ? true : false);
					InsertObject.put("KeyLong", (long) iii);
					InsertObject.put("KeyString", "n" + iiii);
					InsertObject.put("ValueLong", (long) index);
					InsertObject.put("ValueString", "n" + iiii);
					InsertObject.put("ValueBoolean", ii % 2 == 0 ? true : false);
					InsertObjects.add(InsertObject);
				}
				JSONObject wrapperObject = new JSONObject();
				wrapperObject.put("QueryType", "batch_insert");
				wrapperObject.put("InsertObjects", InsertObjects);
				wrapperObject.put("Database", database_name);
				wrapperObject.put("Datatable", table_name);
				agent.Query(wrapperObject);
				exist_count += InsertObjects.size();
				if (exist_count % 1000 == 0) {
					LogUtil.info("" + exist_count);
				}
			}
		}
		LogUtil.info("finish:" + size_Long);
	}

	static void print(ZillionTableSchema schema, JSONArray resultContent) {
		List<String> columnList = new ArrayList<String>();
		for (String column : schema.Key) {
			columnList.add(column);
		}
		for (String column : schema.OtherColumn) {
			columnList.add(column);
		}

		for (String column : columnList) {
			System.out.printf("%20s", column);
			System.out.print("\t");
		}
		System.out.println();
		for (int i = 0; i < resultContent.size(); i++) {
			JSONObject item = (JSONObject) resultContent.get(i);
			for (String column : columnList) {
				if (item.containsKey(column)) {
					ZillionTableColumn column_schema = schema.ColumnMap.get(column);
					if (column_schema.Type == ZillionTableColumnEnum.BOOLEAN) {
						System.out.printf("%20s", ((Boolean) item.get(column)) ? "true" : "false");
					} else if (column_schema.Type == ZillionTableColumnEnum.LONG) {
						System.out.printf("%20d", (Long) item.get(column));
					} else if (column_schema.Type == ZillionTableColumnEnum.DOUBLE) {
						System.out.printf("%20.2f", (Double) item.get(column));
					} else if (column_schema.Type == ZillionTableColumnEnum.STRING) {
						System.out.printf("%20s", (String) item.get(column));
					}
					System.out.print("\t");
				}
			}
			System.out.println();
		}
	}
}
