package strong_consistency;

import java.util.ArrayList;
import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.database.consistency.StrongConsistencyUtil;
import com.zillion.util.common.ZillionConstant;
import com.zillion.util.common.ZillionGenerateUtil;
import com.zillion.util.table.ZillionTableSchema;

public class SCMain {
	static String Database = "db_test";
	// static String table_name = "table_strong_none_consistency";
	// static String table_name = "table_strong_consistency";
	// static String table_name = "table_es";
	static String table_name = "table_strong_consistency_es";

	public static void main(String[] args) throws Exception {
		System.setProperty("java.security.krb5.conf", "D:\\Test\\krb5.conf");
		System.setProperty("java.security.krb5.realm", "HADOOP.COM");
		System.setProperty("java.security.krb5.kdc", "node1");
		System.setProperty("java.security.auth.login.config", "D:\\Test\\zk-jaas.conf");
		// System.setProperty("javax.security.auth.useSubjectCredsOnly", "false");

		// ZillionConstant.printCriteriaGroup = true;
//		ZillionConstant.random_exception_enable = true;
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		// IZillionAgent agent = new ZillionAgentWebImpl("http://101.201.234.108:8555/metadata-web/");

		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		int thread_count = 10;
		ZillionTableSchema schema = agent.container.repositoryMap.get(Database).GetTable(table_name);

		List<SCThread> threadList = new ArrayList<SCThread>();
		for (int index = 0; index < thread_count; index++) {
			SCThread thread = new SCThread(agent);
			thread.start();
			threadList.add(thread);
		}

		List<String> columnList = ZillionGenerateUtil.getIndexColumn(schema);
		for (int cycle = 0; cycle < Integer.MAX_VALUE; cycle++) {
			{
				List<JSONObject> SetList = new ArrayList<JSONObject>();
				for (int index = 0; index < thread_count; index++) {
					JSONObject Set = ZillionGenerateUtil.generateUpdateSet(schema, columnList);
					SetList.add(Set);
				}

				RefreshJobList(SetList);

				for (int index = 0; index < thread_count; index++) {
					SCThread thread = threadList.get(index);
					JSONObject Set = SetList.get(index);
					thread.Push(Set);
				}
			}

			while (true) {
				Thread.sleep(1L);
				int JobFinishCount = GetJobFinishCount();
				if (JobFinishCount == jobCount) {
					break;
				}
			}
			Thread.sleep(1L);

			List<JSONArray> ContentList = new ArrayList<JSONArray>();
			boolean not_consistency = StrongConsistencyUtil.not_consistency(schema, agent, Database, table_name, ContentList);
			if (not_consistency) {
				for (int i = 0; i < ContentList.size(); i++) {
					JSONArray Content = ContentList.get(i);
					LogUtil.warn(Content.toJSONString());
				}
				LogUtil.warn("not_consistency" + "\t" + not_consistency);

				boolean good = false;
				for (int ii = 0; ii < 60000; ii++) {
					Thread.sleep(1L);

					ContentList = new ArrayList<JSONArray>();
					boolean not_consistency2 = StrongConsistencyUtil.not_consistency(schema, agent, Database, table_name, ContentList);
					if (!not_consistency2) {
						LogUtil.warn("not_consistency2" + "\t" + not_consistency2);
//						for (int i = 0; i < ContentList.size(); i++) {
//							JSONArray Content = ContentList.get(i);
//							LogUtil.warn(Content.toJSONString());
//						}
						good = true;
						break;
					}
				}
				if (good) {
					continue;
				} else {
					break;
				}
			}
		}

		for (int index = 0; index < thread_count; index++) {
			SCThread thread = threadList.get(index);
			thread.requestStop();
		}
		for (int index = 0; index < thread_count; index++) {
			SCThread thread = threadList.get(index);
			thread.join();
		}

		agent.Stop();
		System.out.println();
	}

	static int jobCount = 0;
	static List<JSONObject> jobList = new ArrayList<JSONObject>();
	static List<JSONObject> jobList_finish = new ArrayList<JSONObject>();

	public static synchronized void RefreshJobList(List<JSONObject> buildingList) {
		jobList.clear();
		jobList_finish.clear();
		for (JSONObject building : buildingList) {
			jobList.add(building);
		}
		jobCount = jobList.size();
	}

	public static synchronized JSONObject Pop() {
		JSONObject result = null;
		if (jobList.size() > 0) {
			result = jobList.remove(0);
		}
		return result;
	}

	public static synchronized void Finish(JSONObject job) {
		jobList_finish.add(job);
	}

	public static synchronized int GetJobFinishCount() {
		return jobList_finish.size();
	}
}
