package strong_consistency;

import java.util.ArrayList;
import java.util.List;

import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class SCThread extends Thread {
	ZillionAgent agent;

	public SCThread(ZillionAgent agent) {
		this.agent = agent;
	}

	private volatile boolean stop = false;

	public void requestStop() {
		stop = true;
		try {
			this.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	public void run() {
		while (!stop) {
			JSONObject job = this.Pop();
			if (job == null) {
				continue;
			}

			try {
				Process(job);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	List<JSONObject> jobList = new ArrayList<JSONObject>();

	public synchronized void Push(JSONObject building) {
		jobList.add(building);
	}

	public synchronized JSONObject Pop() {
		JSONObject result = null;
		if (jobList.size() > 0) {
			result = jobList.remove(0);
		}
		return result;
	}

	void Process(JSONObject job) throws Exception {
		{
			JSONObject Criteria = new JSONObject();
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "update");
			wrapperObject.put("Database", SCMain.Database);
			wrapperObject.put("Datatable", SCMain.table_name);
			wrapperObject.put("Criteria", Criteria);
			wrapperObject.put("Set", job);
//			LogUtil.warn(job.toJSONString());
			JSONObject queryResult = agent.Query(wrapperObject);
			JSONArray ConflictArray = (JSONArray) queryResult.get("ConflictArray");
//			if (ConflictArray != null && ConflictArray.size() > 0) {
//				LogUtil.error("ConflictArray" + "\t" + ConflictArray.toJSONString());
//			}
		}

		SCMain.Finish(job);
	}
}