package test.async;

import java.io.File;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.json.Convertor_JSON;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.JSONReaderUtil;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.database.async.AsyncUtil;

public class AgentTest_async {

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration);
		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		////////////////////////////////////////////////////////////////
		JSONObject wrapperObject = (JSONObject) Convertor_JSON.SagaJson2FastJson(JSONReaderUtil.Instance().Read(new File("etc/select.json")));
		String database_name = (String) wrapperObject.get("Database");
		try {
			agent.NDL_AddDatabase(database_name);
		} catch (Exception e1) {
			// e1.printStackTrace();
		}

		String uuid = AsyncUtil.SubmitJob(agent, wrapperObject);
		while (true) {
			Thread.sleep(1000L);

			JSONObject jobStatus = AsyncUtil.QueryJobStatus(uuid);
			long count = (Long) jobStatus.get("count");
			boolean finish = (Boolean) jobStatus.get("finish");
			boolean success = (Boolean) jobStatus.get("success");
			String exception = (String) jobStatus.get("exception");
			JSONObject queryResult = (JSONObject) jobStatus.get("queryResult");
			LogUtil.warn("count:" + count + "\t" + "finish:" + finish + "\n" + "success:" + success + "\n" + "exception:" + exception + "\n"
					+ "queryResult:" + queryResult);
			if (finish) {
				break;
			}
		}
		AsyncUtil.ClearJob(uuid);

		agent.Stop();
	}
}
