package test.async;

import java.io.File;

import org.zillion.util.json.Convertor_JSON;
import org.zillion.util.json.FastJsonUtil;
import org.zillion.util.json.JSONReaderUtil;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.IZillionAgent;
import com.zillion.database.agent.ZillionAgentWebImpl;
import com.zillion.database.async.AsyncJob;
import com.zillion.database.async.AsyncUtil;
import com.zillion.util.common.ZillionConstant;

public class AgentTest_async_select {

	public static void main(String[] args) throws Exception {
		IZillionAgent agent;

		// Configuration configuration = HBaseConfiguration.create();
		// agent = new ZillionAgent(configuration);

		agent = new ZillionAgentWebImpl("http://localhost:8888/metadata-web/");
		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		////////////////////////////////////////////////////////////////
		JSONObject wrapperObject = (JSONObject) Convertor_JSON.SagaJson2FastJson(JSONReaderUtil.Instance().Read(new File("etc/async_select.json")));
		// String database_name = (String) wrapperObject.get("Database");
		// try {
		// agent.NDL_AddDatabase(database_name);
		// } catch (Exception e1) {
		// // e1.printStackTrace();
		// }
		ZillionConstant.export_batch_size = 10000L;
		boolean sync = true;
		if (sync) {
			AsyncJob job = new AsyncJob(null, null);
			JSONObject result = agent.Query(wrapperObject, false, job);
			LogUtil.warn(FastJsonUtil.toFormatString(result));
		} else {
			String uuid = AsyncUtil.SubmitJob(agent, wrapperObject);
			while (true) {
				Thread.sleep(1L);

				JSONArray itemList = AsyncUtil.TryPopOnePage(uuid);
				if (itemList.size() > 0) {
					LogUtil.warn("" + itemList.size() + "\n" + FastJsonUtil.toFormatString(itemList));
					continue;
				}

				AsyncUtil.Finish(uuid);
				break;
			}
			Thread.sleep(1000L);
			AsyncUtil.ClearJob(uuid);
		}

		agent.Stop();
	}
}
