package test.es;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.apache.http.HttpHost;
import org.elasticsearch.action.DocWriteResponse;
import org.elasticsearch.action.delete.DeleteRequest;
import org.elasticsearch.action.delete.DeleteResponse;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.index.IndexRequest;
import org.elasticsearch.action.index.IndexResponse;
import org.elasticsearch.action.support.replication.ReplicationResponse;
import org.elasticsearch.action.support.replication.ReplicationResponse.ShardInfo;
import org.elasticsearch.action.update.UpdateRequest;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;

public class ESTest {

	public static void main(String[] args) throws Exception {
		// High Level Client init
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));

		index(client);
	}

	public static void index(RestHighLevelClient client) throws Exception {
		Map<String, Object> jsonMap = new HashMap<>();
		jsonMap.put("user", "kimchy");
		jsonMap.put("postDate", new Date());
		jsonMap.put("message", "trying out Elasticsearch");
		IndexRequest indexRequest = new IndexRequest("posts", "doc", "1").source(jsonMap);
		IndexResponse indexResponse = client.index(indexRequest, RequestOptions.DEFAULT);
		{
			String index = indexResponse.getIndex(); // indexƣ͵Ϣ
			String type = indexResponse.getType();
			String id = indexResponse.getId();
			long version = indexResponse.getVersion();
			if (indexResponse.getResult() == DocWriteResponse.Result.CREATED) {

			} else if (indexResponse.getResult() == DocWriteResponse.Result.UPDATED) {

			}
			ShardInfo shardInfo = indexResponse.getShardInfo();
			// ԷƬʹõж
			if (shardInfo.getTotal() != shardInfo.getSuccessful()) {

			}
			if (shardInfo.getFailed() > 0) {
				for (ReplicationResponse.ShardInfo.Failure failure : shardInfo.getFailures()) {
					String reason = failure.reason();
				}
			}
		}
	}

	public static void get(RestHighLevelClient client) throws Exception {
		GetRequest getRequest = new GetRequest("posts", // index name
				"doc", // type
				"1"); // id
		GetResponse getResponse = client.get(getRequest, RequestOptions.DEFAULT);
		{
			String index = getResponse.getIndex();
			String type = getResponse.getType();
			String id = getResponse.getId();
			if (getResponse.isExists()) {
				long version = getResponse.getVersion();
				String sourceAsString = getResponse.getSourceAsString();
				Map<String, Object> sourceAsMap = getResponse.getSourceAsMap();
				byte[] sourceAsBytes = getResponse.getSourceAsBytes();
			} else {
				// TODO
			}
		}
	}

	public static void delete(RestHighLevelClient client) throws Exception {
		DeleteRequest request = new DeleteRequest("posts", "doc", "1");
		DeleteResponse deleteResponse = client.delete(request, RequestOptions.DEFAULT);

	}

	public static void update(RestHighLevelClient client) throws Exception {
		Map<String, Object> jsonMap = new HashMap<>();
		jsonMap.put("updated", new Date());
		jsonMap.put("reason", "dailys update");
		UpdateRequest updateRequest = new UpdateRequest("posts", "doc", "1").doc(jsonMap);
		try {
			client.update(updateRequest, RequestOptions.DEFAULT);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
