package test.es;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import org.apache.http.HttpHost;
import org.elasticsearch.action.admin.indices.create.CreateIndexRequest;
import org.elasticsearch.action.admin.indices.create.CreateIndexResponse;
import org.elasticsearch.action.admin.indices.delete.DeleteIndexRequest;
import org.elasticsearch.action.admin.indices.get.GetIndexRequest;
import org.elasticsearch.action.admin.indices.get.GetIndexResponse;
import org.elasticsearch.action.delete.DeleteRequest;
import org.elasticsearch.action.delete.DeleteResponse;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.index.IndexRequest;
import org.elasticsearch.action.index.IndexResponse;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.action.support.master.AcknowledgedResponse;
import org.elasticsearch.action.update.UpdateRequest;
import org.elasticsearch.action.update.UpdateResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.common.settings.Settings;
import org.elasticsearch.common.unit.TimeValue;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.SearchHit;
import org.elasticsearch.search.SearchHits;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.elasticsearch.search.sort.FieldSortBuilder;
import org.elasticsearch.search.sort.ScoreSortBuilder;
import org.elasticsearch.search.sort.SortOrder;
import org.junit.Test;

public class ESTest2 {
	public static void main(String[] args) throws Exception {
		ESTest2 ESTest2 = new ESTest2();
		// // ESTest2.createIndex();
		// ESTest2.getIndex();
		// ESTest2.insertDocument();
		// ESTest2.searchDocument();
		// // ESTest2.getDocument();

		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));
		// ESTest2.new_createIndex(client);
		 ESTest2.new_insertDocument(client);
		ESTest2.new_searchDocument(client);
		client.close();
	}

	public void new_createIndex(RestHighLevelClient client) throws Exception {
		CreateIndexRequest request = new CreateIndexRequest("new_index");
		request.settings(Settings.builder().put("index.number_of_shards", 1).put("index.number_of_replicas", 1));

		CreateIndexResponse createIndexResponse = client.indices().create(request, RequestOptions.DEFAULT);

		System.out.println("isAcknowledged:" + createIndexResponse.isAcknowledged());
		System.out.println("isShardsAcknowledged:" + createIndexResponse.isShardsAcknowledged());
	}

	public void new_insertDocument(RestHighLevelClient client) throws Exception {
		Map<String, Object> jsonMap = new HashMap<>();
		jsonMap.put("name", "·");
		jsonMap.put("number", "10");
		jsonMap.put("create_date", "2019-02-17");
		IndexRequest request = new IndexRequest("new_index").source(jsonMap);
		IndexResponse indexResponse = client.index(request, RequestOptions.DEFAULT);

		System.out.println("id:" + indexResponse.getId());
	}

	public void new_searchDocument(RestHighLevelClient client) throws Exception {
		SearchRequest request = new SearchRequest();
		request.indices("new_index");
		SearchSourceBuilder sourceBuilder = new SearchSourceBuilder();
		
//		sourceBuilder.query(QueryBuilders.matchAllQuery());

//		sourceBuilder.query(QueryBuilders.matchQuery("number", "10"));
		sourceBuilder.query(QueryBuilders.termQuery("number", "10"));
//		sourceBuilder.sort(new ScoreSortBuilder().order(SortOrder.DESC));
//		sourceBuilder.sort(new FieldSortBuilder("_uid").order(SortOrder.ASC));
//		sourceBuilder.sort(new FieldSortBuilder("name").order(SortOrder.ASC));
		sourceBuilder.from(0);
		sourceBuilder.size(10);
		sourceBuilder.timeout(new TimeValue(60, TimeUnit.SECONDS));
		
		request.source(sourceBuilder);

		SearchResponse searchResponse = client.search(request, RequestOptions.DEFAULT);
		SearchHits hits = searchResponse.getHits();
		SearchHit[] searchHits = hits.getHits();
		System.out.println("SearchHit:" + searchHits.length);
		for (SearchHit hit : searchHits) {
			Map<String, Object> datas = hit.getSourceAsMap();
			System.out.println(datas.toString());
		}
	}

	/**
	 * Index
	 */
	@Test
	public void createIndex() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		CreateIndexRequest request = new CreateIndexRequest("employee");// 
		// ÿ֮ضá
		request.settings(Settings.builder().put("index.number_of_shards", 3).put("index.number_of_replicas", 2));
		// ѡ
		// request.timeout(TimeValue.timeValueMinutes(2));//ʱ,ȴнڵ㱻ȷ(ʹTimeValueʽ)
		// request.timeout("2m");//ʱ,ȴнڵ㱻ȷ(ʹַʽ)
		request.masterNodeTimeout(TimeValue.timeValueMinutes(1));// masterڵĳʱʱ(ʹTimeValueʽ)
		// request.masterNodeTimeout("1m");//masterڵĳʱʱ(ʹַʽ)
		// request.waitForActiveShards(2);//ڴAPIӦ֮ǰȴĻƬintʽʾ

		CreateIndexResponse createIndexResponse = client.indices().create(request, RequestOptions.DEFAULT);

		client.close();

		System.out.println("isAcknowledged:" + createIndexResponse.isAcknowledged());
		System.out.println("isShardsAcknowledged:" + createIndexResponse.isShardsAcknowledged());
	}

	/**
	 * ɾ
	 * 
	 * @throws Exception
	 */
	@Test
	public void deleteIndex() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		DeleteIndexRequest request = new DeleteIndexRequest("goods");
		request.timeout(TimeValue.timeValueMinutes(2));
		// request.timeout("2m");
		request.masterNodeTimeout(TimeValue.timeValueMinutes(1));
		// request.masterNodeTimeout("1m");
		AcknowledgedResponse deleteIndexResponse = client.indices().delete(request, RequestOptions.DEFAULT);
		System.out.println("isAcknowledged:" + deleteIndexResponse.isAcknowledged());
		client.close();
	}

	/**
	 * Ƿ
	 * 
	 * @throws Exception
	 */
	@Test
	public void existIndex() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		GetIndexRequest request = new GetIndexRequest();
		request.indices("goods");
		boolean exists = client.indices().exists(request, RequestOptions.DEFAULT);
		System.out.println("goods:" + exists);
		client.close();
	}

	/**
	 * ȡ
	 * 
	 * @throws Exception
	 */
	@Test
	public void getIndex() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		GetIndexRequest request = new GetIndexRequest().indices("shop");
		GetIndexResponse getIndexResponse = client.indices().get(request, RequestOptions.DEFAULT);
		System.out.println(Arrays.toString(getIndexResponse.getIndices()));
		client.close();
	}

	/**
	 * ߸ĵ
	 * 
	 * @throws Exception
	 */
	@Test
	public void insertDocument() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		Map<String, Object> jsonMap = new HashMap<>();
		jsonMap.put("title", "·");
		jsonMap.put("create_date", "2019-02-17");
		IndexRequest request = new IndexRequest("shop", "goods", "2").source(jsonMap);
		IndexResponse indexResponse = client.index(request, RequestOptions.DEFAULT);

		System.out.println("id:" + indexResponse.getId());

		client.close();
	}

	/**
	 * ȡĵ
	 * 
	 * @throws Exception
	 */
	@Test
	public void getDocument() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		GetRequest request = new GetRequest("shop", "goods", "1");
		GetResponse getResponse = client.get(request, RequestOptions.DEFAULT);

		System.out.println("£" + getResponse.getSource().toString());

		client.close();
	}

	/**
	 * жĳһĵǷ
	 * 
	 * @throws Exception
	 */
	@Test
	public void existDocument() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		GetRequest request = new GetRequest("shop", "goods", "1");
		boolean exists = client.exists(request, RequestOptions.DEFAULT);

		System.out.println("Ƿڣ" + exists);

		client.close();
	}

	/**
	 * ɾĵ
	 * 
	 * @throws Exception
	 */
	@Test
	public void deleteDocuemnt() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		DeleteRequest request = new DeleteRequest("shop", "goods", "2");
		request.timeout(TimeValue.timeValueMinutes(2));
		// request.timeout("2m");
		DeleteResponse deleteResponse = client.delete(request, RequestOptions.DEFAULT);

		System.out.println(deleteResponse.getSeqNo());
		client.close();
	}

	/**
	 * ĵ
	 * 
	 * @throws Exception
	 */
	@Test
	public void updateDocument() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		Map<String, Object> jsonMap = new HashMap<>();
		jsonMap.put("title", "·222");
		jsonMap.put("create_date", "2019-02-17");
		UpdateRequest request = new UpdateRequest("shop", "goods", "1").doc(jsonMap);
		UpdateResponse updateResponse = client.update(request, RequestOptions.DEFAULT);
		System.out.println(updateResponse.getId());
		client.close();
	}

	/**
	 * 
	 * 
	 * @throws Exception
	 */
	@Test
	public void searchDocument() throws Exception {
		RestHighLevelClient client = new RestHighLevelClient(RestClient.builder(new HttpHost("localhost", 9200, "http")));// ʼ
		SearchRequest request = new SearchRequest();
		request.indices("shop");
		SearchSourceBuilder sourceBuilder = new SearchSourceBuilder();
		sourceBuilder.query(QueryBuilders.matchQuery("title", "Ь"));
		// ## start
		sourceBuilder.sort(new ScoreSortBuilder().order(SortOrder.DESC));
		sourceBuilder.sort(new FieldSortBuilder("_uid").order(SortOrder.ASC));
		// ## end
		sourceBuilder.from(0);
		sourceBuilder.size(5);
		sourceBuilder.timeout(new TimeValue(60, TimeUnit.SECONDS));
		request.source(sourceBuilder);

		SearchResponse searchResponse = client.search(request, RequestOptions.DEFAULT);
		SearchHits hits = searchResponse.getHits();

		SearchHit[] searchHits = hits.getHits();

		System.out.println("SearchHit:" + searchHits.length);

		for (SearchHit hit : searchHits) {
			Map<String, Object> datas = hit.getSourceAsMap();
			System.out.println(datas.toString());
		}

		client.close();
	}
}