package test.hbase;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;

import org.apache.hadoop.hbase.HColumnDescriptor;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;

public class AdminUtil {
	public static DecimalFormat df = new DecimalFormat("000000000");
	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");

	public static void createTable_rep(Admin admin, TableName tableName, byte[][] splitKeys) throws Exception {
		String[] familyName_array = { "f" };
		int[] maxVersions_array = { 1 };

		HTableDescriptor desc = new HTableDescriptor(tableName);
		for (int i = 0; i < familyName_array.length; i++) {
			String familyName = familyName_array[i];
			int maxVersions = maxVersions_array[i];
			HColumnDescriptor coldef = new HColumnDescriptor(familyName);
			coldef.setMaxVersions(maxVersions);
			coldef.setScope(1);
			desc.addFamily(coldef);
		}
		if (splitKeys != null) {
			admin.createTable(desc, splitKeys);
		} else {
			admin.createTable(desc);
		}

//		admin.disableTable(tableName);
//		for (int i = 0; i < familyName_array.length; i++) {
//			String familyName = familyName_array[i];
//			int maxVersions = maxVersions_array[i];
//			HColumnDescriptor coldef = new HColumnDescriptor(familyName);
//			coldef.setMaxVersions(maxVersions);
//			coldef.setScope(1);
//			admin.modifyColumn(tableName, coldef);
//		}
//		admin.enableTable(tableName);
	}

	public static void createTable(Admin admin, TableName tableName, byte[][] splitKeys) throws Exception {
		String[] familyName_array = { "f" };
		int[] maxVersions_array = { 1 };

		HTableDescriptor desc = new HTableDescriptor(tableName);
		for (int i = 0; i < familyName_array.length; i++) {
			String familyName = familyName_array[i];
			int maxVersions = maxVersions_array[i];
			HColumnDescriptor coldef = new HColumnDescriptor(familyName);
			coldef.setMaxVersions(maxVersions);
			desc.addFamily(coldef);
		}
		if (splitKeys != null) {
			admin.createTable(desc, splitKeys);
		} else {
			admin.createTable(desc);
		}
	}

	public static void deleteTable(Admin admin, TableName tableName) throws Exception {
		if (admin.tableExists(tableName)) {
			if (admin.isTableEnabled(tableName)) {
				admin.disableTable(tableName);
			}
			admin.deleteTable(tableName);
		}
	}

}
