package test.hbase;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.Get;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Put;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.ResultScanner;
import org.apache.hadoop.hbase.client.Row;
import org.apache.hadoop.hbase.client.Scan;
import org.apache.hadoop.hbase.filter.BinaryComparator;
import org.apache.hadoop.hbase.filter.CompareFilter;
import org.apache.hadoop.hbase.filter.Filter;
import org.apache.hadoop.hbase.filter.FilterList;
import org.apache.hadoop.hbase.filter.MultiRowRangeFilter;
import org.apache.hadoop.hbase.filter.MultiRowRangeFilter.RowRange;
import org.apache.hadoop.hbase.filter.RowFilter;
import org.apache.hadoop.hbase.util.Bytes;

public class HBaseTest3 {

	static String[] name_ss = { "james", "john", "robert", "michael", "william", "david", "richard", "charles", "joseph", "thomas" };
	static String[] name2_ss = { "mary", "patricia", "linda", "barbara", "elizabeth", "jennifer", "maria", "susan", "margaret", "dorothy" };
	static int age_length = 2;
	static int age2_length = 2;
	static int score_length = 10;
	static int score2_length = 10;

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		String table_name = "table_zillion";
		TableName tableName = TableName.valueOf(table_name);

		AdminUtil.deleteTable(admin, tableName);
		AdminUtil.createTable(admin, tableName, null);

		HTable table = (HTable) connection.getTable(tableName);

		{
			Put put = new Put(Bytes.toBytes("row1"));
			put.addColumn(Bytes.toBytes("f"), Bytes.toBytes("v1"), Bytes.toBytes("val1"));
			put.addColumn(Bytes.toBytes("f"), Bytes.toBytes("v2"), Bytes.toBytes("val2"));
			table.put(put);
		}
		{
			Put put = new Put(Bytes.toBytes("row1"));
			put.addColumn(Bytes.toBytes("f"), Bytes.toBytes("v1"), null);
			put.addColumn(Bytes.toBytes("f"), Bytes.toBytes("v2"), null);
			table.put(put);
		}

		table.close();
		admin.close();
		connection.close();
	}

}
