package test.hbase;

import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HRegionInfo;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.NamespaceDescriptor;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.util.Bytes;

public class HBaseTest_MoveRegion {

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		admin.setBalancerRunning(false, true);

		HTableDescriptor desc = admin.getTableDescriptor(TableName.valueOf("db_wanda", "zillion_data_original_6301000001_2017"));

		String namespace = desc.getTableName().getNamespaceAsString();
		String tableName_tmp = desc.getTableName().getNameAsString();
		System.out.println(namespace + "\t" + tableName_tmp);

		List<HRegionInfo> regionList = admin.getTableRegions(desc.getTableName());
		System.out.println("region count" + "\t" + regionList.size());
		for (HRegionInfo region : regionList) {
			// admin.move(region.getEncodedNameAsBytes(), Bytes.toBytes("node2,16020,1494558199534"));
			// admin.move(region.getEncodedNameAsBytes(), Bytes.toBytes("node3,16020,1494558200298"));
			// admin.move(region.getEncodedNameAsBytes(), Bytes.toBytes("node4,16020,1494558183668"));
			System.out.println();
		}

		// regionList = admin.getTableRegions(desc.getTableName());
		// for (HRegionInfo region : regionList) {
		// admin.compactRegion(region.getEncodedNameAsBytes());
		// }

		admin.majorCompact(desc.getTableName());
		// admin.compact(desc.getTableName());

		admin.setBalancerRunning(true, true);

		admin.close();
		connection.close();
	}

}
