package test.hbase;

import java.util.HashMap;
import java.util.Map;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.CellUtil;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.NamespaceDescriptor;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.ResultScanner;
import org.apache.hadoop.hbase.client.Scan;
import org.apache.hadoop.hbase.util.Bytes;

import com.zillion.util.common.ByteToObject;

public class HBaseTest_count {
	public static boolean delete_UsePutV = true;

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		NamespaceDescriptor[] nss = admin.listNamespaceDescriptors();
		for (NamespaceDescriptor ns : nss) {
			if (ns.getName().equals("db_wanda")) {
				Map<String, Integer> countMap = new HashMap<String, Integer>();
				{
					HTable table_meta = (HTable) connection
							.getTable(TableName.valueOf(Bytes.toBytes(ns.getName()), Bytes.toBytes("zillion_meta_data")));
					Scan scan = new Scan();
					scan.addColumn(ByteToObject.toBytes("f"), ByteToObject.toBytes("hi"));
					ResultScanner scanner = table_meta.getScanner(scan);
					while (true) {
						Result res = scanner.next();
						if (res == null) {
							break;
						}
						String row = Bytes.toString(res.getRow());
						byte[] column_name_bytes = CellUtil.cloneValue(res.listCells().get(0));
						String column_name = ByteToObject.toString(column_name_bytes);
						System.out.println("" + row + "\t" + column_name);
						countMap.put(ns.getName() + ":" + "zillion_data_" + row, Integer.parseInt(column_name));
					}
				}

				HTableDescriptor[] descs = admin.listTableDescriptorsByNamespace(ns.getName());
				for (HTableDescriptor desc : descs) {
					TableName tableName = desc.getTableName();
					String namespace = tableName.getNamespaceAsString();
					String tableName_tmp = tableName.getNameAsString();
					if (tableName_tmp.equals(ns.getName() + ":" + "zillion_meta_data")
							|| tableName_tmp.equals(ns.getName() + ":" + "zillion_meta_index")) {
						continue;
					}

					HTable table = (HTable) connection.getTable(tableName);

					int count = 0;
					Scan scan = new Scan();
					if (delete_UsePutV) {
						scan.addColumn(ByteToObject.toBytes("f"), ByteToObject.toBytes("v"));
					}
					scan.addColumn(ByteToObject.toBytes("f"), ByteToObject.toBytes("meter"));
					ResultScanner scanner = table.getScanner(scan);
					while (true) {
						Result res = scanner.next();
						if (res == null) {
							break;
						}
						count++;
					}
					System.out.println(namespace + "\t" + tableName_tmp + "\t" + count);
					Integer meta_count = countMap.get(tableName_tmp);
					if (meta_count != count) {
						System.out.println("******************" + tableName_tmp + "\t" + meta_count + "\t" + count);
					}
				}
			}
		}

		admin.close();
		connection.close();
	}

}
