package test.hbase;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HColumnDescriptor;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Put;
import org.apache.hadoop.hbase.util.Bytes;

public class HBaseTest_insert {

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		TableName tableName = TableName.valueOf("ems_data", "test_table");
		HTableDescriptor desc = new HTableDescriptor(tableName);
		HColumnDescriptor coldef = new HColumnDescriptor("f");
		coldef.setMaxVersions(1);
		desc.addFamily(coldef);
		admin.createTable(desc);

		HTable table = (HTable) connection.getTable(tableName);

		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		int finish_count = 0;
		for (int i = 0; i < 10; i++) {
			List<Put> batch = new ArrayList<Put>();
			for (int ii = 0; ii < 1000; ii++) {
				Put row = new Put(Bytes.toBytes(i * 1000 + ii));
				row.addColumn(Bytes.toBytes("f"), Bytes.toBytes("data"), Bytes.toBytes(1.0));
				batch.add(row);
			}
			table.put(batch);
			finish_count += batch.size();
			System.out.println(sdf.format(new Date()) + "\t" + "finish" + "\t" + finish_count);
		}

		table.close();

		admin.disableTable(tableName);
		admin.deleteTable(tableName);

		admin.close();
		connection.close();
	}
}
