package test.hbase;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.NamespaceDescriptor;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;

public class HBaseTest_show {

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		NamespaceDescriptor[] nss = admin.listNamespaceDescriptors();
		for (NamespaceDescriptor ns : nss) {
			HTableDescriptor[] descs = admin.listTableDescriptorsByNamespace(ns.getName());
			for (HTableDescriptor desc : descs) {
				String namespace = desc.getTableName().getNamespaceAsString();
				String tableName_tmp = desc.getTableName().getNameAsString();
				System.out.println(namespace + "\t" + tableName_tmp);
			}
		}

		admin.close();
		connection.close();
	}

}
