package test.phoenix;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.zillion.util.format.FormatStaticUtil;
import org.zillion.util.log.LogUtil;

public class PhoenixTest_originaldata {
	static String database_name = "database_1";
	static String table_name = "originaldata6";

	static int building_count = 1;

	static List<String> buildingList = new ArrayList<String>();

	static {
		try {
			Class.forName("org.apache.phoenix.jdbc.PhoenixDriver").newInstance();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		try {
			{
				long start = 1101010001;
				String building = null;
				for (int ii = 0; ii < building_count; ii++) {
					building = FormatStaticUtil.toString(start);
					buildingList.add(building);
					start += 100000000;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws Exception {
		String connectionStr = "jdbc:phoenix:zookeeper1:2181";
		Connection connection = DriverManager.getConnection(connectionStr);
		connection.setAutoCommit(true);

		Statement stmt = connection.createStatement();
		try {
			stmt.execute("create schema " + database_name);
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			stmt.execute("DROP TABLE " + database_name + "." + table_name);
		} catch (Exception e) {
			e.printStackTrace();
		}

		stmt.execute("CREATE TABLE " + database_name + "." + table_name + "(building varchar NOT NULL," + "meter varchar NOT NULL,"
				+ "funcid bigint NOT NULL," + "receivetime varchar NOT NULL," + "data double ,"
				+ "CONSTRAINT pk PRIMARY KEY (building, meter,funcid,receivetime)) ");

		stmt.close();
		connection.close();

		List<PhoenixThread> threadList = new ArrayList<PhoenixThread>();
		for (int i = 0; i < buildingList.size(); i++) {
			String building = buildingList.get(i);
			PhoenixThread thread = new PhoenixThread(connectionStr, database_name, table_name, building);
			thread.start();
			threadList.add(thread);
		}

		Date time_from = new Date();
		while (true) {
			Thread.sleep(1L);

			boolean all_finish = true;
			for (PhoenixThread thread : threadList) {
				if (thread.isAlive()) {
					all_finish = false;
					break;
				}
			}
			if (all_finish) {
				break;
			}
		}
		Date time_to = new Date();
		LogUtil.warn("" + (time_to.getTime() - time_from.getTime()));

		System.out.println();
	}
}
