package test.phoenix;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.zillion.util.format.FormatStaticUtil;

import com.alibaba.fastjson.JSONArray;

public class PhoenixThread extends Thread {
	static int meter_count = 10;
	static int funcid_count = 100;
	static int receivetime_count = 100;

	static JSONArray region_keys = new JSONArray();
	static List<String> meterList = new ArrayList<String>();
	static List<Long> funcidList = new ArrayList<Long>();
	static List<String> receivetimeList = new ArrayList<String>();

	static {
		try {
			{
				long start = 1000;
				for (int i = 0; i < meter_count; i++) {
					meterList.add(FormatStaticUtil.toString(start));
					start += 1;
				}
			}
			{
				long start = 0;
				for (int i = 0; i < funcid_count; i++) {
					funcidList.add(start);
					start += 1;
				}
			}
			{
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				Date start = sdf.parse("2000-01-01 00:00:00");
				for (int i = 0; i < receivetime_count; i++) {
					start = new Date(start.getTime() + 1000L * 60 * 5);
					receivetimeList.add(sdf.format(start));
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	String connectionStr;
	String database_name;
	String table_name;
	String building;

	public PhoenixThread(String connectionStr, String database_name, String table_name, String building) {
		this.connectionStr = connectionStr;
		this.database_name = database_name;
		this.table_name = table_name;
		this.building = building;
	}

	public void run() {
		try {
			Connection connection = DriverManager.getConnection(connectionStr);
			connection.setAutoCommit(true);

			try {
				insert(connection);
			} catch (Exception e) {
				e.printStackTrace();
			}

			connection.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	void insert(Connection connection) throws Exception {
		Random rand = new Random();
		for (int index2 = 0; index2 < meterList.size(); index2++) {
			String meter = meterList.get(index2);
			for (int index3 = 0; index3 < funcidList.size(); index3++) {
				Long funcid = funcidList.get(index3);
				String stringSQL = "UPSERT INTO " + database_name + "." + table_name + "(building,meter,funcid,receivetime,data) values(?,?,?,?,?)";
				PreparedStatement stmt = connection.prepareStatement(stringSQL);
				for (int index4 = 0; index4 < receivetimeList.size(); index4++) {
					String receivetime = receivetimeList.get(index4);
					stmt.setString(1, building);
					stmt.setString(2, meter);
					stmt.setInt(3, funcid.intValue());
					stmt.setString(4, receivetime);
					stmt.setDouble(5, rand.nextDouble());
					stmt.addBatch();
				}
				stmt.executeBatch();
				stmt.close();
			}
		}
	}
}
