package test.phoenix;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.Statement;
import java.util.Random;

public class TestPhoenix1 {
	static {
		try {
			Class.forName("org.apache.phoenix.jdbc.PhoenixDriver");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws Exception {
		Connection connection = DriverManager.getConnection("jdbc:phoenix:zookeeper1:2181");
		connection.setAutoCommit(false);

		{
			try {
				Statement stmt = connection.createStatement();
				stmt.execute("DROP TABLE table1");
				connection.commit();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		{
			Statement stmt = connection.createStatement();
			stmt.execute("CREATE TABLE table1(id varchar NOT NULL primary key,name varchar NULL)");
			stmt.execute("CREATE INDEX index1 ON table1(name)");
			stmt.executeUpdate("UPSERT INTO table1(ID,NAME) VALUES('a','menglu-a')");
			stmt.executeUpdate("UPSERT INTO table1(ID,NAME) VALUES('b','menglu-b')");
			connection.commit();
		}

		// {
		// Statement stmt = connection.createStatement();
		// PhoenixResultSet resultSet = (PhoenixResultSet) stmt.executeQuery("SELECT * FROM table1");
		// PrintResultSet(resultSet);
		// resultSet.close();
		// stmt.close();
		// }

		// {
		// PreparedStatement pstmt = connection.prepareStatement("SELECT * FROM table1 WHERE id=?");
		// pstmt.setString(1, "a");
		// PhoenixResultSet resultSet = (PhoenixResultSet) pstmt.executeQuery();
		// PrintResultSet(resultSet);
		// resultSet.close();
		// pstmt.close();
		// }

		{
			Statement stmt = connection.createStatement();
			stmt.execute("DELETE FROM table1");
			connection.commit();
		}

		{
			int upsertBatchSize = 1000;
			String upsertStatement = "UPSERT INTO table1(ID,NAME) VALUES(?,?)";
			PreparedStatement stmt = connection.prepareStatement(upsertStatement);
			int rowCount = 0;
			Random r = new Random();
			for (int i = 0; i < 100; i++) {
				String id = "id" + i;
				String name = "name" + r.nextInt(1000);
				stmt.setString(1, id);
				stmt.setString(2, name);
				stmt.execute();
				if (++rowCount % upsertBatchSize == 0) {
					connection.commit();
					System.out.println("Rows upserted: " + rowCount);
				}
			}
			connection.commit();
		}

		connection.close();
	}

	// static void PrintResultSet(PhoenixResultSet resultSet) throws Exception {
	// ResultSetMetaData meta = resultSet.getMetaData();
	// ArrayList<String> cols = new ArrayList<String>();
	// JSONArray jsonArr = new JSONArray();
	// while (resultSet.next()) {
	// if (cols.size() == 0) {
	// for (int i = 1, count = meta.getColumnCount(); i <= count; i++) {
	// cols.add(meta.getColumnName(i));
	// }
	// }
	//
	// JSONObject json = new JSONObject();
	// for (int i = 0, len = cols.size(); i < len; i++) {
	// json.put(cols.get(i), resultSet.getString(cols.get(i)));
	// }
	// jsonArr.put(json);
	// System.out.println(json);
	// }
	// }

}
