package test.redis;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import redis.clients.jedis.JedisPoolConfig;
import redis.clients.jedis.JedisShardInfo;
import redis.clients.jedis.ShardedJedis;
import redis.clients.jedis.ShardedJedisPool;

public class TestRedisClusterMain {
	static JedisPoolConfig config = new JedisPoolConfig();
	static List<JedisShardInfo> list = new LinkedList<JedisShardInfo>();
	static ShardedJedisPool pool;

	public static void main(String[] args) {
		config.setMaxTotal(100);
		config.setMaxIdle(50);
		config.setMaxWaitMillis(3000);
		config.setTestOnBorrow(true);
		config.setTestOnReturn(true);
		// Ⱥ
		JedisShardInfo jedisShardInfo1 = new JedisShardInfo("192.168.3.222", 6379);
		jedisShardInfo1.setPassword("foobared");
		list.add(jedisShardInfo1);
		pool = new ShardedJedisPool(config, list);

		// main_list1(args);
		// main_list1(args);
		// main_map(args);
		main_1(args);

		pool.close();
	}

	public static void main_1(String[] args) {
		ShardedJedis jedis = pool.getResource();

		Map<String, String> result = jedis.hgetAll("db_test:table_strong_consistency_es");
		// jedis.del("db_test:table_strong_consistency_es");
		Iterator<String> keyIter = result.keySet().iterator();
		while (keyIter.hasNext()) {
			String key = keyIter.next();
			System.out.println(key + ":" + result.get(key));
		}
	}

	public static void main_list1(String[] args) {
		ShardedJedis jedis = pool.getResource();

		// 洢ݵб
		jedis.del("kecheng");
		jedis.lpush("kecheng", "java");
		jedis.lpush("kecheng", "php");
		jedis.lpush("kecheng", "Mysql");

		// ȡ洢ݲ
		List<String> list = jedis.lrange("kecheng", 0, 100);
		for (int i = 0; i < list.size(); i++) {
			System.out.println("redis list洢ֵ:" + list.get(i));
		}

		jedis.close();
	}

	public static void main_list2(String[] args) {
		ShardedJedis jedis = pool.getResource();

		// key java frameworkд
		jedis.lpush("java framework", "spring");
		jedis.lpush("java framework", "struts");
		jedis.lpush("java framework", "hibernate");

		// ȡjedis.lrangeǰΧȡ
		// һkeyڶʼλãǽλãjedis.llenȡ -1ʾȡ
		System.out.println(jedis.lrange("java framework", 0, -1));

		jedis.del("java framework");
		jedis.rpush("java framework", "spring");
		jedis.rpush("java framework", "struts");
		jedis.rpush("java framework", "hibernate");
		System.out.println(jedis.lrange("java framework", 0, -1));

		jedis.close();
	}

	public static void main_map(String[] args) {
		ShardedJedis jedis = pool.getResource();

		// ---------------
		{
			Map<String, String> map = new HashMap<String, String>();
			map.put("name", "xinxin");
			map.put("age", "22");
			map.put("qq", "123456");
			jedis.hmset("user", map);
		}

		{
			Map<String, String> map = new HashMap<String, String>();
			map.put("sex", "male");

			jedis.hmset("user", map);
		}

		// ȡuserеnameִн:[minxr]-->עһ͵List
		// һǴredismapkeyǷmapеĶkeykeyԸǿɱ
		String[] names = { "name", "age", "sex", "qq" };
		List<String> rsmap = jedis.hmget("user", names);
		System.out.println(rsmap);

		// ɾmapеĳֵ
		jedis.hdel("user", "age");
		System.out.println(jedis.hmget("user", "age")); // ΪɾˣԷصnull
		System.out.println(jedis.hlen("user")); // keyΪuserļдŵֵĸ2
		System.out.println(jedis.exists("user"));// ǷkeyΪuserļ¼ true
		System.out.println(jedis.hkeys("user"));// mapеkey
		System.out.println(jedis.hvals("user"));// mapеvalue

		Iterator<String> iter = jedis.hkeys("user").iterator();
		while (iter.hasNext()) {
			String key = iter.next();
			System.out.println(key + ":" + jedis.hmget("user", key));
		}

		jedis.close();
	}

	public static void main_set(String[] args) {
		ShardedJedis jedis = pool.getResource();

		jedis.sadd("users", "liuling");
		jedis.sadd("users", "xinxin");
		jedis.sadd("users", "ling");
		jedis.sadd("users", "zhangxinxin");
		jedis.sadd("users", "who");

		// Ƴnoname
		jedis.srem("users", "who");
		System.out.println(jedis.smembers("users"));// ȡмvalue
		System.out.println(jedis.sismember("users", "who"));// ж who ǷuserϵԪ
		System.out.println(jedis.srandmember("users"));
		System.out.println(jedis.scard("users"));// ؼϵԪظ

		jedis.close();
	}
}
