package test.redis;

import java.util.concurrent.TimeUnit;

import org.redisson.api.RLock;
import org.redisson.api.RedissonClient;
import org.zillion.util.log.LogUtil;

public class TestRedissonThread extends Thread {
	boolean needStop = false;
	RedissonClient redisson;
	int number;

	public TestRedissonThread(RedissonClient redisson, int number) {
		this.redisson = redisson;
		this.number = number;
	}

	public void RequestStop() {
		this.needStop = true;
	}

	@Override
	public void run() {
		while (!this.needStop) {
			try {
				RLock lock = redisson.getLock("anyLock");
				LogUtil.warn(this.number + "\t" + "1");
				boolean res = lock.tryLock(10, 100, TimeUnit.SECONDS);
				LogUtil.warn(this.number + "\t" + "2");
				if (res) {
					try {
						LogUtil.warn(this.number + "\t" + "myjob" + "begin");
						Thread.sleep(1000L * 3);
						LogUtil.warn(this.number + "\t" + "myjob" + "end");
					} finally {
						LogUtil.warn(this.number + "\t" + "3");
						lock.unlock();
						LogUtil.warn(this.number + "\t" + "4");
					}
				}
				LogUtil.warn(this.number + "\t" + "finish");
				break;
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

}
