package test.zk;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.Stat;

public class ZKModifyTest {

	public static void main(String[] args) throws Exception {
		ZooKeeper zk = new ZooKeeper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000, null);

		Stat stat = zk.exists("/zillion", true);
		if (stat != null) {
			zk.delete("/zillion", -1);
		}
		Thread.sleep(1000L);
		stat = zk.exists("/zillion", true);
		if (stat == null) {
			zk.create("/zillion", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		}
		Thread.sleep(1000L);

		zk.setData("/zillion", "data".getBytes("UTF-8"), -1);
		Thread.sleep(1000L);
		zk.setData("/zillion", "data".getBytes("UTF-8"), -1);
		Thread.sleep(1000L);
		zk.setData("/zillion", "data".getBytes("UTF-8"), -1);
		Thread.sleep(1000L);

		zk.create("/zillion/node1", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);
		zk.create("/zillion/node2", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);
		zk.create("/zillion/node3", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);

		zk.create("/zillion/node1/node11", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);
		zk.create("/zillion/node1/node12", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);
		zk.create("/zillion/node1/node13", "data".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
		Thread.sleep(1000L);

		zk.delete("/zillion/node1/node11", -1);
		Thread.sleep(1000L);
		zk.delete("/zillion/node1/node12", -1);
		Thread.sleep(1000L);
		zk.delete("/zillion/node1/node13", -1);
		Thread.sleep(1000L);

		zk.delete("/zillion/node1", -1);
		Thread.sleep(1000L);
		zk.delete("/zillion/node2", -1);
		Thread.sleep(1000L);
		zk.delete("/zillion/node3", -1);
		Thread.sleep(1000L);

		zk.close();
	}
}
