package test.zk;

import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.Watcher.Event.EventType;
import org.apache.zookeeper.Watcher.Event.KeeperState;
import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.proto.WatcherEvent;

public class ZKWatcher implements Watcher {
	public ZooKeeper zk;

	public ZKWatcher() {

	}

	public void process(WatchedEvent event) {
		String path = event.getPath();
		EventType type = event.getType();
		KeeperState state = event.getState();
		WatcherEvent wrapper = event.getWrapper();
		System.out.println(path + "\t" + state + "\t" + type + "\t" + wrapper);

		if (type == EventType.NodeChildrenChanged) {
			Stat stat = new Stat();
			try {
				this.zk.getChildren(path, this, stat);
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (type == EventType.NodeCreated) {
			Stat stat = new Stat();
			try {
				this.zk.getData(path, this, stat);
			} catch (Exception e) {
				e.printStackTrace();
			}
			try {
				this.zk.getChildren(path, this, stat);
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (type == EventType.NodeDataChanged) {
			Stat stat = new Stat();
			try {
				this.zk.getData(path, this, stat);
				System.out.println();
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (type == EventType.NodeDeleted) {
			try {
				this.zk.exists(path, this);
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (type == EventType.None) {
		}
	}
}
