package test.zookeeper;

import java.util.List;

import org.apache.zookeeper.data.Stat;

import com.zillion.util.zk.ZKWrapper;

public class DeleteTest {

	public static void main(String[] args) throws Exception {
		ZKWrapper zk = new ZKWrapper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000);

//		recursive(zk, "/compute_engine");
		 recursive(zk, "/zillion");
		// recursive(zk, "/root");
		// recursiveChildren(zk, "/root");

		zk.close();
	}

	public static void recursive(ZKWrapper zk, String path) throws Exception {
		Stat stat = zk.exists(path, false);
		if (stat == null) {
			return;
		}

		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}

		zk.delete(path, -1);
		System.out.println("delete:" + path);
	}

	public static void recursiveChildren(ZKWrapper zk, String path) throws Exception {
		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}
}
