package test.zookeeper;

import java.util.List;

import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.Stat;

public class ModifyTest {

	public static void main(String[] args) throws Exception {
		ZooKeeper zk = new ZooKeeper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000, null);

		recursive(zk, "/root");
		// recursiveChildren(zk, "/root");

		zk.close();
	}

	public static void recursive(ZooKeeper zk, String path) throws Exception {
		Stat stat = new Stat();
		byte[] data = zk.getData(path, false, stat);
		String dataString = new String(data, "UTF-8");
		dataString = dataString + "-1";
		Stat stat_new = zk.setData(path, dataString.getBytes("UTF-8"), stat.getVersion());
		System.out.println(path + ":" + dataString + "\t" + stat_new);

		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}

	public static void recursiveChildren(ZooKeeper zk, String path) throws Exception {
		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}
}
