package test.zookeeper;

import java.util.List;

import org.apache.zookeeper.ZooKeeper;
import org.zillion.util.common.HexToByte;
import org.zillion.util.log.LogUtil;

public class ScannerTest {

	public static void main(String[] args) throws Exception {
		ZooKeeper zk = new ZooKeeper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000, null);

		 recursive(zk, "/compute_engine");
//		 recursive(zk, "/zillion");
//		for (int i = 0; i < Integer.MAX_VALUE; i++) {
//			try {
//				recursiveChildren(zk, "/zillion/nslock");
//			} catch (Exception e) {
//			}
//		}
		// recursive(zk, "/root");
		// recursiveChildren(zk, "/");

		zk.close();
	}

	public static void recursive(ZooKeeper zk, String path) throws Exception {
		byte[] data = zk.getData(path, false, null);
		if (data != null) {
			String dataString = HexToByte.byteToHex(data) + "\n\t" + new String(data, "UTF-8");
			LogUtil.info(path + ":\n\t" + dataString);
		}

		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}

	public static void recursiveChildren(ZooKeeper zk, String path) throws Exception {
		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}
}
