package test.zookeeper;

import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.ZooKeeper;

public class WatcherTest {
	public static class ZKWatcher implements Watcher {
		public void process(WatchedEvent event) {
			System.out.println(event.getPath() + "\t" + event.getState() + "\t" + event.getType() + "\t" + event.getWrapper());
		}
	}

	public static void main(String[] args) throws Exception {
		Watcher zkwatcher = new ZKWatcher();
		ZooKeeper zk = new ZooKeeper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000, zkwatcher);

		NodeWatcher watcher = new NodeWatcher(zk);
		String path = "/root";
		watcher.recursive(zk, watcher, path);

		while (true) {
			Thread.sleep(1L);
		}

		// zk.close();
	}

}
