package wanda;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class computelog_delete {

	public static void main(String[] args) throws Exception{
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace(); 
		} 

		String database_name = "db_time_data";
		int reserve_size=10000;

		JSONObject queryJSON=new JSONObject();
		queryJSON.put("QueryType", "select");
		queryJSON.put("Database",database_name);
		queryJSON.put("Datatable", "ci_instance");
		JSONObject Criteria=new JSONObject();
		queryJSON.put("Criteria", Criteria);
		JSONObject queryResult=agent.Query(queryJSON);
		JSONArray queryContent=(JSONArray)queryResult.get("Content");
		for(int i=0;i<queryContent.size();i++){
			JSONObject ci_instance=(JSONObject)queryContent.get(i);
			String object_sign= (String)ci_instance.get("object_sign");
			String instance_name= (String)ci_instance.get("instance_name");
			if(instance_name.startsWith("fjd")){
				JSONObject cut=null;
				{
					JSONObject queryJSONInner=new JSONObject();
					queryJSONInner.put("QueryType", "select");
					queryJSONInner.put("Database",database_name);
					queryJSONInner.put("Datatable", "fjd_0_computelog");
					JSONObject CriteriaInner=new JSONObject();
					CriteriaInner.put("building", object_sign);
					queryJSONInner.put("Criteria", CriteriaInner);
					JSONObject queryResultInner=agent.Query(queryJSONInner);
					JSONArray queryContentInner=(JSONArray)queryResultInner.get("Content");
					if(queryContentInner.size()>=reserve_size){
						cut=(JSONObject)queryContentInner.get(queryContentInner.size()-reserve_size);
					}
				}
				if(cut!=null){
				long compute_round=(Long)cut.get("compute_round");
				String[] delete_tables={"fjd_0_computelog","fjd_0_computedetail"};
				for(String delete_table:delete_tables){
					JSONObject queryJSONInner=new JSONObject();
					queryJSONInner.put("QueryType", "delete");
					queryJSONInner.put("Database",database_name);
					queryJSONInner.put("Datatable", delete_table);
					JSONObject CriteriaInner=new JSONObject();
					CriteriaInner.put("building", object_sign);
					JSONObject Range=new JSONObject();
					Range.put("$lte", compute_round);
					CriteriaInner.put("compute_round", Range);
					queryJSONInner.put("Criteria", CriteriaInner);
					LogUtil.warn(queryJSONInner.toJSONString());
					JSONObject queryResultInner=agent.Query(queryJSONInner);
					LogUtil.warn(queryResultInner.toJSONString());
				}
				}
			}else if(instance_name.equals("stat_Inst")||instance_name.equals("servicedata")||instance_name.equals("EMS")){
				JSONObject cut=null;
				{
					JSONObject queryJSONInner=new JSONObject();
					queryJSONInner.put("QueryType", "select");
					queryJSONInner.put("Database",database_name);
					queryJSONInner.put("Datatable", "ce_computelog");
					JSONObject CriteriaInner=new JSONObject();
					CriteriaInner.put("object_sign", object_sign);
					CriteriaInner.put("instance_name", instance_name);
					queryJSONInner.put("Criteria", CriteriaInner);
					JSONObject queryResultInner=agent.Query(queryJSONInner);
					JSONArray queryContentInner=(JSONArray)queryResultInner.get("Content");
					if(queryContentInner.size()>=reserve_size){
						cut=(JSONObject)queryContentInner.get(queryContentInner.size()-reserve_size);
					}
				}
				if(cut!=null){
				long compute_round=(Long)cut.get("compute_round");
				String[] delete_tables={"ce_computelog","ce_computeinputlog","ce_computeinputdetail","ce_computeoutputdetail"};
				for(String delete_table:delete_tables){
					JSONObject queryJSONInner=new JSONObject();
					queryJSONInner.put("QueryType", "delete");
					queryJSONInner.put("Database",database_name);
					queryJSONInner.put("Datatable", delete_table);
					JSONObject CriteriaInner=new JSONObject();
					CriteriaInner.put("object_sign", object_sign);
					CriteriaInner.put("instance_name", instance_name);
					JSONObject Range=new JSONObject();
					Range.put("$lte", compute_round);
					CriteriaInner.put("compute_round", Range);
					queryJSONInner.put("Criteria", CriteriaInner);
					LogUtil.warn(queryJSON.toJSONString());
					JSONObject queryResultInner=agent.Query(queryJSONInner);
					LogUtil.warn(queryResultInner.toJSONString());
				}
				}
			}
		}
		
		agent.Stop();
	}
}
