package wanda;
import java.io.File;
import java.net.URL;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.database.util.DatabaseImpl_HBase;
import com.zillion.util.common.ZillionConstant;
import com.zillion.util.table.ZillionTableIndex;
import com.zillion.util.table.ZillionTableSchema;

import useful.HBaseAdminHelper;

public class wanda_delete_original_month {
	public static List<String> buildingList=new ArrayList<String>();
	
	public static Map<String, Boolean> BuildingIncludesMap = new HashMap<String, Boolean>();
	public static Map<String, Boolean> BuildingExcludesMap = new HashMap<String, Boolean>();
	public static List<CollectRule> CollectRuleList = new ArrayList<CollectRule>();
	static {
		try {
			{
				SAXReader saxReader = new SAXReader();
				String filepathDatabase;
				URL urlDatabase = wanda_delete_original_month.class.getResource("/wanda-building.xml");
				if (urlDatabase == null) {
					filepathDatabase = System.getProperty("user.dir") + "/wanda-building.xml";
				} else {
					filepathDatabase = urlDatabase.getPath();
				} 

				File xmlFile = new File(URLDecoder.decode(filepathDatabase, "UTF-8"));
				if (xmlFile.exists()) {
					Document document = saxReader.read(xmlFile);
					Iterator iter;
					Element element;
					Attribute attribute;

					iter = document.selectNodes("/root/BuildingIncludes/Building").iterator();
					while (iter.hasNext()) {
						element = (Element) iter.next();
						BuildingIncludesMap.put(element.getText(), true);
					}

					iter = document.selectNodes("/root/BuildingExcludes/Building").iterator();
					while (iter.hasNext()) {
						element = (Element) iter.next();
						BuildingExcludesMap.put(element.getText(), true);
					}

					iter = document.selectNodes("/root/CollectRules/CollectRule").iterator();
					while (iter.hasNext()) {
						element = (Element) iter.next();
						CollectRule rule = new CollectRule();

						Element Condition = (Element) element.selectNodes("Condition").iterator().next();
						attribute = Condition.attribute("building");
						if (attribute != null) {
							rule.Condition.building = attribute.getValue();
						}
						attribute = Condition.attribute("sign");
						if (attribute != null) {
							rule.Condition.sign = attribute.getValue();
						}
						attribute = Condition.attribute("funcid");
						if (attribute != null) {
							rule.Condition.funcid = Integer.parseInt(attribute.getValue());
						}

						Element Operation = (Element) element.selectNodes("Operation").iterator().next();
						attribute = Operation.attribute("table");
						if (attribute != null) {
							rule.Operation.table = attribute.getValue();
						}
						attribute = Operation.attribute("monthly");
						if (attribute != null) {
							rule.Operation.monthly = attribute.getValue().equals("true") ? true : false;
						}
						attribute = Operation.attribute("offset");
						if (attribute != null) {
							rule.Operation.offset = attribute.getValue().equals("true") ? true : false;
						}
						attribute = Operation.attribute("upload");
						if (attribute != null) {
							rule.Operation.upload = attribute.getValue().equals("true") ? true : false;
						}
						attribute = Operation.attribute("upload_table");
						if (attribute != null) {
							rule.Operation.upload_table = attribute.getValue().split(",");
						}
						attribute = Operation.attribute("present");
						if (attribute != null) {
							rule.Operation.present = attribute.getValue().equals("true") ? true : false;
						}
						attribute = Operation.attribute("present_table");
						if (attribute != null) {
							rule.Operation.present_table = attribute.getValue();
						}
						attribute = Operation.attribute("building_new");
						if (attribute != null) {
							rule.Operation.building_new = attribute.getValue();
						}
						attribute = Operation.attribute("sign_new");
						if (attribute != null) {
							rule.Operation.sign_new = attribute.getValue();
						}
						attribute = Operation.attribute("funcid_new");
						if (attribute != null) {
							rule.Operation.funcid_new = Integer.parseInt(attribute.getValue());
						}
						CollectRuleList.add(rule);
					}

				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		

		Iterator<String> keyIter=BuildingIncludesMap.keySet().iterator();
		while(keyIter.hasNext()){
			String key=keyIter.next();
			if(BuildingExcludesMap.containsKey(key)){
				continue;
			}
			
			String building_new=key;
			for(CollectRule rule:CollectRuleList){
				if(rule.Condition.building.equals(key)){
					building_new=rule.Operation.building_new;
					break;
				}
			}
			buildingList.add(building_new);
			LogUtil.warn(building_new);
		}
		Collections.sort(buildingList);
	}

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace(); 
		} 
		
		Admin admin=((DatabaseImpl_HBase)agent.container.DatabaseImpl).admin;

		int max_sizeMB=1024*8;
		String database_name = "db_time_data";
		List<String> table_nameList=new ArrayList<String>();
		table_nameList.add("fjd_0_buildingcomputetime");
		table_nameList.add("fjd_0_metercomputetime");
		table_nameList.add("fjd_0_computelog");
		table_nameList.add("fjd_0_computedetail");
		table_nameList.add("fjd_1_computelog");
		table_nameList.add("fjd_1_computedetail");
		table_nameList.add("fjd_2_computelog");
		table_nameList.add("fjd_2_computedetail");
		table_nameList.add("ci_instance");
		table_nameList.add("ci_instanceinput");
		table_nameList.add("ci_instanceoutput");
		table_nameList.add("ci_status");
		table_nameList.add("ce_computelog");
		table_nameList.add("ce_computeinputlog");
		table_nameList.add("ce_computeinputdetail");
		table_nameList.add("ce_computeoutputdetail");
		table_nameList.add("ce_curround");
		table_nameList.add("ce_preroundindex");
		
		//h
		for(String table_name:table_nameList){	
			for(String building:buildingList){
				JSONObject queryJSON=new JSONObject();
				queryJSON.put("QueryType", "delete");
				queryJSON.put("Database",database_name);
				queryJSON.put("Datatable", table_name);
				if(table_name.startsWith("ci_")||table_name.startsWith("ce_")){
					{
						JSONObject Criteria=new JSONObject();
						Criteria.put("object_sign", building);
						queryJSON.put("Criteria", Criteria);
						LogUtil.warn(queryJSON.toJSONString());
						JSONObject queryResult=agent.Query(queryJSON);
						LogUtil.warn(queryResult.toJSONString());
					}
					{
						JSONObject Criteria=new JSONObject();
						Criteria.put("object_sign", "Bd"+building+"001");
						queryJSON.put("Criteria", Criteria);
						LogUtil.warn(queryJSON.toJSONString());
						JSONObject queryResult=agent.Query(queryJSON);
						LogUtil.warn(queryResult.toJSONString());
					}
				}else{
					JSONObject Criteria=new JSONObject();
					Criteria.put("building", building);
					queryJSON.put("Criteria", Criteria);
					LogUtil.warn(queryJSON.toJSONString());
					JSONObject queryResult=agent.Query(queryJSON);
					LogUtil.warn(queryResult.toJSONString());
				}
			}
		}

		//
		for(String table_name:table_nameList){	
			ZillionTableSchema schema=agent.container.repositoryMap.get(database_name).GetTable(table_name);				
				List<TableName> tableNameList=new ArrayList<TableName>();
				if(schema.split_column!=null){
					JSONObject queryJSON=new JSONObject();
					queryJSON.put("QueryType", "split_list");
					queryJSON.put("Database",database_name);
					queryJSON.put("Datatable", table_name);
					JSONObject queryResult=agent.Query(queryJSON);
					JSONArray Content=(JSONArray)queryResult.get("Content");
					for(int i=0;i<Content.size();i++){
						String split=(String)Content.get(i);
						tableNameList.add(TableName.valueOf(database_name, ZillionConstant.prefix_data+table_name+"_"+split));
						for(ZillionTableIndex index_schema: schema.Indexes){
							tableNameList.add(TableName.valueOf(database_name, ZillionConstant.prefix_index+table_name+"."+index_schema.index_name+"_"+split));
						}
					}
				}else{
					tableNameList.add(TableName.valueOf(database_name, ZillionConstant.prefix_data+table_name));
					for(ZillionTableIndex index_schema: schema.Indexes){
						tableNameList.add(TableName.valueOf(database_name, ZillionConstant.prefix_index+table_name+"."+index_schema.index_name));
					}
				}
				
				for(TableName tableName:tableNameList){
					HBaseAdminHelper.Table_merge_by_sizeMB(admin, tableName, max_sizeMB);
					HBaseAdminHelper.Table_majorCompact(admin, tableName);
				}
		}
		

		agent.Stop();
	}
}
